// Copyright (c) 2010 Motorola, Inc. All Rights Reserved.

#ifndef TAPPLICATION_H
#define TAPPLICATION_H

#include "debug/TTracker.h"
#include "interface/TToiNameServiceCaller.h"
#include "interface/TToiApplicationDispatcher.h"
#include "interface/TToiApplicationServiceCaller.h"
#include "ipc/IIpcEventHandler.h"
#include "ipc/TIpcClient.h"

class TApplication : public IToiApplication
{
private:
  TTracker* Tracker;
  TToiApplicationServiceCaller* ApplicationService;
  std::string ApplicationAddress;
  TToiApplicationDispatcher Dispatcher;
  IToiApplicationService::TToiApplicationId ApplicationId;

public:
  TApplication(TIpcClient& ipcClient, IIpcEventHandler& ipcEventHandler,
               IToiNameService& nameService,
               IToiApplicationService::TToiApplicationId applicationId);
  virtual ~TApplication() throw ();

  // IToiApplication
  virtual void Ping() throw ();
  virtual void ChangeState(const IToiApplicationService::TToiApplicationState&
                           state) throw ();
  virtual void LoadUri(const std::string& uri,
                       const std::string& mimeType) throw ();
  virtual void ExecuteCommand(const std::string& command) throw ();
};

#endif // TAPPLICATION_H
