// Copyright (c) 2010 Motorola, Inc. All Rights Reserved.

#ifndef TMEDIA_H
#define TMEDIA_H

#include "interface/IToiNameService.h"
#include "interface/TToiMediaObserverAdapter.h"
#include "interface/TToiMediaObserverDispatcher.h"
#include "interface/TToiMediaServiceCaller.h"
#include "interface/TToiMediaSessionCaller.h"
#include "ipc/IIpcEventHandler.h"
#include "ipc/TIpcClient.h"

class TMedia : public TToiMediaObserverAdapter
{
private:
  TIpcClient& IpcClient;
  IToiApplicationService::TToiApplicationId ApplicationId;
  std::string ObserverAddress;
  TToiMediaObserverDispatcher Dispatcher;
  TToiMediaServiceCaller* MediaService;
  TToiMediaSessionCaller* MediaSession;
  int RelayId;
  std::string SocketName;

public:
  TMedia(TIpcClient& ipcClient, IIpcEventHandler& ipcEventHandler,
         IToiNameService& nameService,
         IToiApplicationService::TToiApplicationId applicationId,
         const std::string& socketName);
  virtual ~TMedia() throw();

  void RemoveSession();

  // TToiMediaObserverAdapter
  virtual void OnSessionStateChanged(const IToiMediaService::TToiSessionInfo&
                                     sessionInfo) throw ();
};

#endif // TMEDIA_H
