#!/bin/bash

set -e
set -u

if [ $# -ne 4 ]; then
    echo "Usage: $0 INFILE SECTION PATCHFILE OUTFILE"
    exit 1
fi

infile=$1
section=$2
patchfile=$3
outfile=$4

cross=mipsel-motorola-linux-uclibc-

patchfilesize=$(stat -c%s $patchfile)

section=$(${cross}objdump -h $infile | grep $section)

offset=0x$(echo $section | awk '{print $6}')
offset=$(printf "%d\n" $offset)
sectionsize=0x$(echo $section | awk '{print $3}')
sectionsize=$(printf "%d\n" $sectionsize)

# do padding of patchfile if necessary
if [ $patchfilesize -gt $sectionsize ]; then
    echo "patchfile is too big! size: $patchfilesize. Maximum: $sectionsize"
    exit 1
elif [ $patchfilesize -lt $sectionsize ]; then
    padding=$(($sectionsize - $patchfilesize))
    dd if=/dev/zero bs=1 count=$padding seek=$(($offset + $patchfilesize)) conv=notrunc of=$outfile 2>/dev/null
fi

# Write patchfile section to outfile
cp $infile $outfile
dd if=$patchfile bs=1 count=$patchfilesize seek=$offset conv=notrunc of=$outfile 2>/dev/null
