#!/bin/sh

set -e
set -u

### The script finds all directories named "ui-langs" within the "data"
### directory of the IIP and copies the language files corresponding
### to the languages defined in the Information Service object
### cfg.uilangs (which is set by the IIP kreatv-option-ui-langs).
### English is always copied.

langs="$(/usr/bin/toish informationservice GetObject cfg.uilangs)"

lang_dirs=$(find -type d -name "ui-langs")

old_ifs=$IFS

for lang_dir in $lang_dirs; do

    IFS=,
    for lang in $langs; do
	if [ -e $lang_dir/$lang.xml ]; then
	    echo "Installing $lang UI language" 1>&2
	    mv -f $lang_dir/$lang.xml $lang_dir/../
	fi
    done
    if [ -e $lang_dir/eng.xml ]; then
	mv -f $lang_dir/eng.xml $lang_dir/../
    fi

    rm -rf $lang_dir

done

IFS=$old_ifs
