#!/usr/bin/python

import struct
import os
import sys

def pagepad(filename, min = 0):
    size = os.stat(filename).st_size
    padding = ((size + 4095) & ~4095) - size
    if padding < min:
        padding = padding + 4096
    if padding > 0:
        file = open(filename, "ab")
        file.write(chr(0) * padding)
        file.close()
        size = os.stat(filename).st_size

    return size

strippedkernel = sys.argv[1]
initrd_image = sys.argv[2]
bss_size = int(sys.argv[3], 16)

# Add page aligned BSS section
pagepad(strippedkernel)
kernelfile = open(strippedkernel, "ab")
kernelfile.write(chr(0) * bss_size)
kernelfile.close()

# Add INRD + initrd size
# setup.c expects the cookie to be located just before
# a page aligned padding area.
strippedkernelsize = pagepad(strippedkernel, 8)

kernelfile = open(strippedkernel, "ab")
kernelfile.truncate(strippedkernelsize - 8)
kernelfile.write(struct.pack('<II', 0x494e5244, os.stat(initrd_image).st_size))
kernelfile.close()
