#!/bin/sh

set -e
set -u

### This script moves all files from the data directory of an IIP to the
### root (/) of the file system.

files="$(find *)"

while [ ! -z "$files" ]
  do

  loop="false"

  for file in $files
    do

    if [ -f $file -o -h $file ]
	then
	### File is a regular file or a symbolic link
	mv $file /$file
    elif [ ! -e /$file ]
	then
        ### File is a directory and does not exist in "/"
	mv $file /$file
	loop="true"
	break
    else
	### Directory exists and will not be created
	continue
    fi
  done

  if ( "$loop" eq "true" )
    then
      ### Update files when we have moved a whole directory
      files="$(find *)"
      continue
  fi

  break

done
