var sidebar = null;
var categories = null;
var items = null;
var SCROLLOFFSET = 100;
var lastSelectedItem = null;

function string2elementId(str) {
    var myregexp = new RegExp(/[^A-Za-z0-9]/g);
    return str.replace(myregexp, "_");
}

function createSidebar() {
    sidebar = document.getElementById("sidebar");

    categories = document.createElement("ul");
    sidebar.appendChild(categories);

    categories.setAttribute("id","categories");
}

// dirName used as Id for the category
function addCategory(catName, dirName, sortorder) {
    if ( !categories ) {
        createSidebar();
    }
    var catId = string2elementId(dirName);
    if (!document.getElementById(catId)) {
        var categoryElement = document.createElement("li");
        var title = document.createElement("h2");
        title.innerHTML = catName;
        categoryElement.appendChild(title);
        var list = document.createElement("ul");
        list.setAttribute("id", catId);
        categoryElement.appendChild(list);
        categories.appendChild(categoryElement);
    }
}


// one ugly hack is used for the portals page where the same items come up
// in two different categories. I use a space char in the name, which is
// not shown and anyway converted to an underscore when the name is used
// as an id. A better way might be to add nonprinting unique
// codes in [] brackets in the name which is stripped before display
function addItem(itemName, sortorder, itemHREF, catName) {
    if (!items) {
        items = [];
    }

    var catId = string2elementId(catName);
    var element_cat = document.getElementById(catId);
    if (!element_cat) {
        alert("error building sidebar. Trying to add " +
                itemName + " to non-existing category " + catName);
        return;
    }

    var li = document.createElement("li");
    var a = document.createElement("a");

    var itemId = string2elementId(itemName);
    a.setAttribute("id", itemId);
    a.setAttribute("href", itemHREF);
    a.innerHTML = itemName;
    li.appendChild(a);

    element_cat.appendChild(li);
}


function addLink(linkname, linkhref, catName, prio) {
    addItem(linkname, prio, linkhref, catName);
}


function selectItem(itemName) {
    if ( !itemName ) {
        sidebar.scrollIntoView();
        return;
    }

    var itemId = string2elementId(itemName);
    var e = document.getElementById(itemId);
    if ( !e) {
        alert("selectItem cannot find " + itemName );
        return;
    }
    e.className += " selected";
    e.scrollIntoView(true);

    if (e.offsetTop <= sidebar.scrollTop + SCROLLOFFSET) {
        sidebar.scrollTop = e.offsetTop - SCROLLOFFSET;
    }
    else {
        //sidebar.scrollTop = 99999;
    }
    // IE centers overflowed text.. so do a scroll to the left..
    // (can move this to resize func?)
    sidebar.scrollLeft=0;

    lastSelectedItem = itemName;
}

function selectTab(tabName) {
    var e = document.getElementById("tab_" + tabName);
    if ( e ) {
        e.className += " selected";
    }
    else {
        alert("Error! Trying to select non-existant tab " + tabName);
    }
}
