/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *--------------------------------------------------------------------
 *
 * TExampleObject.h
 *
 * Wrapper around NPObject for example scriptable object
 *
 * Copyright (c) 2010 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TEXAMPLEOBJECT_H
#define TEXAMPLEOBJECT_H

#include <npapi/npruntime.h>
#include <base/NonCopyable.h>

class TExamplePlugin;

// internal object which holds all the information about NP object and around
class TExampleObject  : public NPObject
{
public:
  TExampleObject( TExamplePlugin* owner );
  ~TExampleObject();
  TExamplePlugin* const owner_;
  bool isValid_;
private:
  // block constructor & copy
  TExampleObject();
  NON_COPYABLE(TExampleObject);
};

#endif // TEXAMPLEOBJECT_H
