/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TTestRenderer.cpp
 *
 * Copyright (c) 2010 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#include "TTestRenderer.h"


TTestRenderer::TTestRenderer(/*NPP parent*/)
  : window_(NULL),
    color(0)
{
  TRACE("created");
}

TTestRenderer::~TTestRenderer()
{
  TRACE("destroyed");
  window_ = NULL;
  color = 0;
}

void TTestRenderer::SetColor(uint32_t newColor)
{
  color = newColor;
}

void TTestRenderer::ForceRedraw(const NPP instance)
{
  NPRect damageRect;
  damageRect.left = 40;
  damageRect.top = 240;
  damageRect.right = 360;
  damageRect.bottom = 260;
  NPN_InvalidateRect(instance, &damageRect);

  damageRect.left = 40;
  damageRect.top = 270;
  damageRect.right = 360;
  damageRect.bottom = 290;
  NPN_InvalidateRect(instance, &damageRect);

  NPN_ForceRedraw(instance);
}

void TTestRenderer::TestPaint(ekioh::EKPluginEvent& event)
{
  uint8_t* dst = event.paint.pixmap.buffer +
                 (event.paint.pixmap.stride * event.paint.y0) +
                 ((event.paint.pixmap.bitsPerPixel / 8) * event.paint.x0);

  for (int yl = event.paint.y0; yl < event.paint.y1; yl++) {
    uint32_t* d = (uint32_t *) dst;
    for (int xl = event.paint.x0; xl < event.paint.x1; xl++) {
      *d++ = color;
    }
    dst += event.paint.pixmap.stride;
  }
  TRACE(" painted color 0x%X.", color);
}

void TTestRenderer::SetWindow(NPWindow * window)
{
  TRACE("window=%p",window);
  window_ = window;
  x = window->x;
  y = window->y;
  width = window->width;
  height = window->height;
}
