/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TTestRenderer.h
 *
 * This class implements a renderer class for this test NPAPI plugin. This
 * is suited to be replaced with another renderer class for other purposes.
 *
 * Copyright (c) 2010 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef TTESTRENDERER_H
#define TTESTRENDERER_H

#include <cassert>
#include "Plugins/EKPluginEvent.h"
#include "ExampleInternal.h"

class TTestRenderer
{
public:
  TTestRenderer();
  ~TTestRenderer();

  void SetWindow(NPWindow * );
  void TestPaint(ekioh::EKPluginEvent& );
  void SetColor(uint32_t );
  void ForceRedraw(const NPP );

private:
  NPWindow* window_;

  uint32_t x, y;
  uint32_t width, height;
  uint32_t color;
};

# endif

