/*
 *--------------------------------------------------------------------
 *
 * TSimpleDescriptor.cpp
 *
 * This class describes the simple element.
 *
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#include "TSimpleDescriptor.h"
#include "TSimpleElement.h"
#include "media/streamer/ParameterNames.h"


namespace {
  // An anonymous namespace forces local linkage, which enables the
  // linker to create a smaller executable.

  const IElementDescriptor::TMetadataInfo MetadataInfo[] = {
    { "SimpleExampleMetadata",
      IElementDescriptor::TMetadataInfo::INPUT_PRODUCED,
      IElementDescriptor::TMetadataInfo::OUTPUT_COMMITTED,
      IElementDescriptor::TMetadataInfo::TYPE_CONTINUAL },
  };

  const IElementDescriptor::TMetadataInfo* const MetadataInfoVector[] = {
    &MetadataInfo[0],
    NULL
  };

  const IElementDescriptor::TProperties Properties = {
    "Simple",
    500,
    "MPEG-2/Transport Stream",
    OUTPUT_SAME_AS_INPUT,
    IElementDescriptor::TProperties::ELEMENT_INTERMEDIATE,
    MetadataInfoVector,
    "Framing"
  };

}  // Anonymous namespace.


void TSimpleDescriptor::GetProperties(TProperties* properties) throw ()
{
  *properties = Properties;
}

bool TSimpleDescriptor::MatchUri(const std::string& /*uri*/) throw ()
{
  return false;
}

bool TSimpleDescriptor::HasTrait(const std::string& /*trait*/) throw ()
{
  return false;
}

IElement* TSimpleDescriptor::CreateElement() throw ()
{
  return new TSimpleElement;
}
