/*
 *--------------------------------------------------------------------
 *
 * TSimpleElement.h
 *
 * A simple example pipeline element.
 * 
 * Copyright (c) 2004 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TSIMPLEELEMENT_H
#define TSIMPLEELEMENT_H

#include "media/streamer/IElement.h"
#include "media/streamer/IInputPad.h"
#include "media/streamer/IDebug.h"


class TSimpleElement : public IElement,
                       public IInputPad
{
private:
  IDebug* Debug;
  IOutputPad* OutputPad;

public:
  TSimpleElement() throw ();
  virtual ~TSimpleElement() throw ();

  // IElement interface.
  virtual void Initialize(IPump* pump, const char* dataFormat) throw ();
  virtual void* QueryInterface(const char* name) throw ();
  virtual void Destroy() throw ();

  // IInputPad interface.
  virtual void Process(const TSegmentList& segments) throw ();
  virtual void Flush(const TSegmentList& segments) throw ();
};

#endif
