/*
 * The EKLibrary library is proprietary and copyright Ekioh Ltd.
 * This EKLibrary file is licensed as follows:
 *
 * Copyright (c) 2010 Ekioh Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef EK_EKPLUGEVENT_H
#define EK_EKPLUGEVENT_H

#include "EKTypes.h"

namespace ekioh {

enum EKPixelFormat
{
    EKPixelFormat_ARGB32
};

struct EKPluginPixMap
{
    uint32_t width; ///< width in pixels
    uint32_t height; ///< height in pixels
    int32_t stride; ///< number of bytes to next row. could be negative.
    uint32_t bitsPerPixel; ///< bits per pixel
    EKPixelFormat pixelFormat; ///< format of pixel data
    uint8_t* buffer; ///< pointer to pixel data
};

struct EKPluginEvent
{
    enum EventType
    {
        Paint
    };

    int version; ///< version of this structure
    EventType type;

    union {
        struct {
            // The plugin must only draw to the area of this pixmap defined
            // by the NPWindow structure in the NPP_SetWindow call.
            EKPluginPixMap pixmap;

            // Dirty rectangle relative to top-left of pixmap.
            int x0;
            int y0;
            int x1;
            int y1;
        } paint;
    };
};

} // namespace

//typedef ekioh::EKPluginEvent NPEvent;

#endif

