# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.

from kreatvipccaller import KreaTvIpcCaller
from binipcparameterstack import BinIpcParameterStack
from ToiDlnaContentDirectoryObserver import ToiDlnaContentDirectoryObserver


class ToiDlnaContentDirectoryService(KreaTvIpcCaller):

  # Enum TToiPropertyType
  TYPE_STRING = 0
  TYPE_INTEGER = 1
  TYPE_BOOLEAN = 2
  TYPE_DATE = 3
  TYPE_RESOLUTION = 4
  TYPE_DURATION = 5

  # Enum TToiCdsActionCapability
  CDS_CAPABILITY_CREATE_OBJECT = 0x1
  CDS_CAPABILITY_DESTROY_OBJECT = 0x2
  CDS_CAPABILITY_SEARCH = 0x4
  CDS_CAPABILITY_IMPORT_RESOURCE = 0x8
  CDS_CAPABILITY_EXPORT_RESOURCE = 0x10
  CDS_CAPABILITY_STOP_TRANSFER_PROGRESS = 0x20
  CDS_CAPABILITY_GET_TRANSFER_PROGRESS = 0x40
  CDS_CAPABILITY_IMAGE_UPLOAD = 0x80
  CDS_CAPABILITY_AUDIO_UPLOAD = 0x100
  CDS_CAPABILITY_AV_UPLOAD = 0x200
  CDS_CAPABILITY_X_GET_DLNA_UPLOAD_PROFILES = 0x400

  # Const OP_RESULT_OBJECT
  OP_RESULT_OBJECT = 1

  # Const OP_RESULT_CAPABILITY
  OP_RESULT_CAPABILITY = 2

  # Const OP_ERROR_INVALID_ARGUMENTS
  OP_ERROR_INVALID_ARGUMENTS = -3

  # Const OP_ERROR_INVALID_ACTION
  OP_ERROR_INVALID_ACTION = -4

  # Const OP_ERROR_UNSUPPORTED_SEARCH_CRITERIA
  OP_ERROR_UNSUPPORTED_SEARCH_CRITERIA = -5

  # Const OP_ERROR_UNSUPPORTED_SORT_CRITERIA
  OP_ERROR_UNSUPPORTED_SORT_CRITERIA = -6

  # Const OP_ERROR_NO_SUCH_CONTAINER
  OP_ERROR_NO_SUCH_CONTAINER = -7

  # Const OP_ERROR_RESTRICTED
  OP_ERROR_RESTRICTED = -8

  # Const OP_ERROR_CAN_NOT_PROCESS_REQUEST
  OP_ERROR_CAN_NOT_PROCESS_REQUEST = -9

  # Const PROPERTY_OBJECT_ATTR_CHILD_COUNT
  PROPERTY_OBJECT_ATTR_CHILD_COUNT = 11

  # Const PROPERTY_OBJECT_ATTR_SEARCHABLE
  PROPERTY_OBJECT_ATTR_SEARCHABLE = 12

  # Const PROPERTY_OBJECT_ATTR_REF_ID
  PROPERTY_OBJECT_ATTR_REF_ID = 13

  # Const PROPERTY_OBJECT_ATTR_RESTRICTED
  PROPERTY_OBJECT_ATTR_RESTRICTED = 14

  # Const PROPERTY_CREATE_CLASS
  PROPERTY_CREATE_CLASS = 20

  # Const PROPERTY_CREATE_CLASS_ATTR_INCLUDE_DERIVED
  PROPERTY_CREATE_CLASS_ATTR_INCLUDE_DERIVED = 21

  # Const PROPERTY_CREATE_CLASS_ATTR_NAME
  PROPERTY_CREATE_CLASS_ATTR_NAME = 22

  # Const PROPERTY_CREATOR
  PROPERTY_CREATOR = 30

  # Const PROPERTY_DATE
  PROPERTY_DATE = 40

  # Const PROPERTY_DESCRIPTION
  PROPERTY_DESCRIPTION = 50

  # Const PROPERTY_LANGUAGE
  PROPERTY_LANGUAGE = 60

  # Const PROPERTY_RES
  PROPERTY_RES = 70

  # Const PROPERTY_RES_ATTR_BITRATE
  PROPERTY_RES_ATTR_BITRATE = 71

  # Const PROPERTY_RES_ATTR_BITS_PER_SAMPLE
  PROPERTY_RES_ATTR_BITS_PER_SAMPLE = 72

  # Const PROPERTY_RES_ATTR_COLOR_DEPTH
  PROPERTY_RES_ATTR_COLOR_DEPTH = 73

  # Const PROPERTY_RES_ATTR_DURATION
  PROPERTY_RES_ATTR_DURATION = 74

  # Const PROPERTY_RES_ATTR_IMPORT_URI
  PROPERTY_RES_ATTR_IMPORT_URI = 75

  # Const PROPERTY_RES_ATTR_AUDIO_CHANNELS_COUNT
  PROPERTY_RES_ATTR_AUDIO_CHANNELS_COUNT = 76

  # Const PROPERTY_RES_ATTR_PROTOCOL_INFO
  PROPERTY_RES_ATTR_PROTOCOL_INFO = 77

  # Const PROPERTY_RES_ATTR_RESOLUTION
  PROPERTY_RES_ATTR_RESOLUTION = 78

  # Const PROPERTY_RES_ATTR_SAMPLE_FREQUENCY
  PROPERTY_RES_ATTR_SAMPLE_FREQUENCY = 79

  # Const PROPERTY_RES_ATTR_SIZE
  PROPERTY_RES_ATTR_SIZE = 80

  # Const PROPERTY_RES_ATTR_PROTECTION
  PROPERTY_RES_ATTR_PROTECTION = 81

  # Const PROPERTY_RES_RENDER_SUPPORTED
  PROPERTY_RES_RENDER_SUPPORTED = 82

  # Const PROPERTY_SEARCH_CLASS
  PROPERTY_SEARCH_CLASS = 90

  # Const PROPERTY_SEARCH_CLASS_ATTR_INCLUDE_DERIVED
  PROPERTY_SEARCH_CLASS_ATTR_INCLUDE_DERIVED = 91

  # Const PROPERTY_SEARCH_CLASS_ATTR_NAME
  PROPERTY_SEARCH_CLASS_ATTR_NAME = 92

  # Const PROPERTY_ACTOR
  PROPERTY_ACTOR = 100

  # Const PROPERTY_ALBUM
  PROPERTY_ALBUM = 110

  # Const PROPERTY_ARTIST
  PROPERTY_ARTIST = 120

  # Const PROPERTY_AUTHOR
  PROPERTY_AUTHOR = 130

  # Const PROPERTY_PRODUCER
  PROPERTY_PRODUCER = 140

  # Const PROPERTY_DIRECTOR
  PROPERTY_DIRECTOR = 150

  # Const PROPERTY_PUBLISHER
  PROPERTY_PUBLISHER = 160

  # Const PROPERTY_CONTRIBUTOR
  PROPERTY_CONTRIBUTOR = 170

  # Const PROPERTY_GENRE
  PROPERTY_GENRE = 180

  # Const PROPERTY_ICON
  PROPERTY_ICON = 190

  # Const PROPERTY_ORIGINAL_TRACK_NUMBER
  PROPERTY_ORIGINAL_TRACK_NUMBER = 200

  # Const PROPERTY_PLAYLIST
  PROPERTY_PLAYLIST = 210

  # Const PROPERTY_RATING
  PROPERTY_RATING = 220

  # Const PROPERTY_SCHEDULED_START_TIME
  PROPERTY_SCHEDULED_START_TIME = 230

  # Const PROPERTY_SCHEDULED_END_TIME
  PROPERTY_SCHEDULED_END_TIME = 240

  # Const PROPERTY_CHANNEL_NAME
  PROPERTY_CHANNEL_NAME = 250

  # Const PROPERTY_CHANNEL_NR
  PROPERTY_CHANNEL_NR = 260

  # Const PROPERTY_STORAGE_FREE
  PROPERTY_STORAGE_FREE = 270

  # Const PROPERTY_STORAGE_MAX_PARTITION
  PROPERTY_STORAGE_MAX_PARTITION = 280

  # Const PROPERTY_STORAGE_MEDIUM
  PROPERTY_STORAGE_MEDIUM = 290

  # Const PROPERTY_STORAGE_TOTAL
  PROPERTY_STORAGE_TOTAL = 300

  # Const PROPERTY_STORAGE_USED
  PROPERTY_STORAGE_USED = 310

  # Const PROPERTY_WRITE_STATUS
  PROPERTY_WRITE_STATUS = 320

  # Const PROPERTY_REGION
  PROPERTY_REGION = 330

  # Const PROPERTY_LONG_DESCRIPTION
  PROPERTY_LONG_DESCRIPTION = 340

  # Const PROPERTY_RADIO_CALL_SIGN
  PROPERTY_RADIO_CALL_SIGN = 350

  # Const PROPERTY_RADIO_STATION_ID
  PROPERTY_RADIO_STATION_ID = 360

  # Const PROPERTY_RADIO_BAND
  PROPERTY_RADIO_BAND = 370

  # Const PROPERTY_USER_ANNOTATION
  PROPERTY_USER_ANNOTATION = 380

  # Const PROPERTY_CLASS
  PROPERTY_CLASS = 390

  # Const PROPERTY_TITLE
  PROPERTY_TITLE = 400

  # Const PROPERTY_RES_PI_PROTOCOL
  PROPERTY_RES_PI_PROTOCOL = 410

  # Const PROPERTY_RES_PI_MIME_TYPE
  PROPERTY_RES_PI_MIME_TYPE = 411

  # Const PROPERTY_RES_PI_PROFILE_NAME
  PROPERTY_RES_PI_PROFILE_NAME = 412

  # Const PROPERTY_RES_PI_OPERATIONS
  PROPERTY_RES_PI_OPERATIONS = 413

  # Const PROPERTY_RES_PI_PLAY_SPEED
  PROPERTY_RES_PI_PLAY_SPEED = 414

  # Const PROPERTY_RES_PI_CONVERSION_INDICATOR
  PROPERTY_RES_PI_CONVERSION_INDICATOR = 415

  # Const PROPERTY_RES_PI_FLAGS
  PROPERTY_RES_PI_FLAGS = 416

  # Const PROPERTY_RES_PI_MAX_RTSP_SPEED
  PROPERTY_RES_PI_MAX_RTSP_SPEED = 417

  def __init__(self, ipcproxy, object_address):
    KreaTvIpcCaller.__init__(self, ipcproxy.ip_address, ipcproxy.port)
    self._ipcproxy = ipcproxy
    self.set_object_address(object_address)

  def GetRootContainerId(self):
    """
    Returns the CDS root container identifier.
    
    \retval ojbectId       The root container identifier.
    """
    __request = BinIpcParameterStack()
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetRootContainerId")
    __result = []
    # Read objectId
    __result.append(__response.pop_string())
    return __result[0]

  def GetCapabilities(self, operationId):
    """
    Starts an asynchronous operation to find the capabilities of the CDS.
    The resulting \ref TToiCdsCapabilities can be read after an operation
    event with result type set to \ref OP_RESULT_CAPABILITY.
    
    \param operationId      Operation identifier.
    
    \exception TToiInvalidArgumentException
    Raised if the operation identifier is invalid.
    
    \exception TToiOperationNotSupportedException
    Raised if the service is unavailable.
    
    \see GetOperationCapabilityResult()
    
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    self.call(__request, "IToiDlnaContentDirectoryService", "GetCapabilities")

  def Browse(self, operationId, containerId, propertyFilter, sortCriteria, startIndex, count):
    """
    Starts an asynchronous operation to browse the direct children of
    a container. The objects to return are determined by giving a
    server side offset (startIndex) and number of objects to return
    (count).  A startIndex value of 0 is used to retrieve objects
    from the very beginning of the container. The ServerIndex value
    of a returned \ref TToiCdsObject can be used as offset in
    additional calls to \ref Browse().
    
    The \@childCount attribute of the container may contain
    the total number of objects, but this is not mandatory.
    
    The result is returned by an operation event with result type set to
    \ref OP_RESULT_OBJECT.
    
    \param operationId     Operation identifier.
    
    \param containerId     The identifier of the container object to browse.
    
    \param propertyFilter  The properties to request. Only these properties
    will be included in the object data returned.
    
    \param sortCriteria    The sort criteria to be used for the results.
    A negative value indicates descending sort order
    for that property identifier, and a positive value
    (same as the property identifier) indicates
    ascending sort order.
    The properties that the CDS supports for sorting
    can be found in \ref TToiCdsCapabilities.
    
    \param startIndex      Start index of first object to retrieve.
    
    \param count           The number of objects to be read (a value of 0
    will return all objects).
    
    \exception TToiInvalidArgumentException
    Raised if any of the parameters to the call are
    invalid.
    
    \exception TToiOperationNotSupportedException
    Raised if the service is unavailable.
    
    \see GetOperationObjectResult()
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    # Write containerId
    __request.push_string(containerId)
    # Write propertyFilter
    for iter_k in propertyFilter[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(propertyFilter))
    # Write sortCriteria
    for iter_k in sortCriteria[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(sortCriteria))
    # Write startIndex
    __request.push_int32(startIndex)
    # Write count
    __request.push_int32(count)
    self.call(__request, "IToiDlnaContentDirectoryService", "Browse")

  def GetObjectById(self, operationId, objectId, propertyFilter):
    """
    Starts an asynchronous operation to read a single CDS object.
    The result is returned by an operation event with result type set to
    \ref OP_RESULT_OBJECT.
    
    \param operationId     Operation identifier.
    
    \param objectId        The object identifier to read properties for.
    
    \param propertyFilter  The properties to request. Only these properties
    will be included in the object data returned.
    
    \exception TToiInvalidArgumentException
    Raised if any of the parameters to the call are
    invalid.
    
    \exception TToiOperationNotSupportedException
    Raised if the service is unavailable.
    
    \see GetOperationObjectResult()
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    # Write objectId
    __request.push_string(objectId)
    # Write propertyFilter
    for iter_k in propertyFilter[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(propertyFilter))
    self.call(__request, "IToiDlnaContentDirectoryService", "GetObjectById")

  def Search(self, operationId, containerId, searchCriteria, propertyFilter, sortCriteria, startIndex, count):
    """
    Starts an asynchronous operation to search for matching objects
    in a container. The objects to return are determined by giving a
    server side offset (startIndex) and number of objects to return
    (count).  A startIndex value of 0 is used to retrieve objects
    from the very beginning of the container. The ServerIndex value
    of a returned \ref TToiCdsObject can be used as offset in
    additional calls to \ref Search().
    The support for search operations in different media servers may vary,
    but examples and syntax can be found in public UPnP documents:
    http://upnp.org/specs/av/UPnP-av-ContentDirectory-v1-Service.pdf
    
    The result is returned by an operation event with result type set to
    \ref OP_RESULT_OBJECT.
    
    \param operationId     Operation identifier.
    
    \param containerId     The identifier of the container object to browse.
    
    \param searchCriteria  The search criteria to be used when querying the
    media server.
    The properties that the CDS supports for searching
    can be found in \ref TToiCdsCapabilities.
    
    \param propertyFilter  The properties to request. Only these properties
    will be included in the object data returned.
    
    \param sortCriteria    The sort criteria to be used for the results.
    A negative value indicates descending sort order
    for that property identifier, and a positive value
    (same as the property identifier) indicates
    ascending sort order.
    The properties that the CDS supports for sorting
    can be found in \ref TToiCdsCapabilities.
    
    \param startIndex      Start index of first object to retrieve.
    
    \param count           The number of objects to be read (a value of 0
    will return all matching objects).
    
    \exception TToiInvalidArgumentException
    Raised if any of the parameters to the call are
    invalid.
    
    \exception TToiOperationNotSupportedException
    Raised if the service is unavailable.
    
    \see GetOperationObjectResult()
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    # Write containerId
    __request.push_string(containerId)
    # Write searchCriteria
    __request.push_string(searchCriteria)
    # Write propertyFilter
    for iter_k in propertyFilter[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(propertyFilter))
    # Write sortCriteria
    for iter_k in sortCriteria[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(sortCriteria))
    # Write startIndex
    __request.push_int32(startIndex)
    # Write count
    __request.push_int32(count)
    self.call(__request, "IToiDlnaContentDirectoryService", "Search")

  def GetPropertyInfoById(self, id):
    """
    Returns the CDS property name and type by property identifier.
    
    \param id              Property identifier.
    
    \retval name           Property name.
    
    \retval type           Property type.
    \exception TToiInvalidArgumentException
    Raised if the property identifier is unknown.
    """
    __request = BinIpcParameterStack()
    # Write id
    __request.push_int32(id)
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetPropertyInfoById")
    __result = []
    # Read type
    __result.append(__response.pop_int32())
    # Read name
    __result.append(__response.pop_string())
    return tuple(__result)

  def GetPropertyIdByName(self, name):
    """
    Returns the CDS property identifier used for given property name.
    
    \param name            Property name.
    
    \retval id             Property identifier.
    \exception TToiInvalidArgumentException
    Raised if name is not a known property.
    """
    __request = BinIpcParameterStack()
    # Write name
    __request.push_string(name)
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetPropertyIdByName")
    __result = []
    # Read id
    __result.append(__response.pop_int32())
    return __result[0]

  def GetOperationObjectResult(self, operationId, maxCount):
    """Return objects that are result of an asynchronous DLNA
    operation that notified results of type \ref OP_RESULT_OBJECT.
    The returned result is removed from the internal cache of the
    service and are not available in a second call to this method.
    
    \param operationId    Operation identifier.
    \param maxCount       The maximum number of objects the user are
    interested in, 0 if as many as possible shall be
    returned.
    
    \retval objects       The resulting objects.
    
    \retval hasMore       Set to true if not all objects (up to maxCount)
    could fit in sequence due to platform limitations.
    False otherwise.
    
    \exception TToiInvalidArgumentException
    Raised if operation is unknown or does not support
    object results.
    
    \exception TToiNoDataException
    Raised if no result is available.
    
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    # Write maxCount
    __request.push_int32(maxCount)
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetOperationObjectResult")
    __result = []
    # Read hasMore
    __result.append(__response.pop_bool())
    # Read objects
    objects = []
    for k in range(__response.pop_int32()):
      temp_l = {}
      temp_l["Properties"] = []
      for l in range(__response.pop_int32()):
        temp_m = {}
        temp_m["Value"] = __response.pop_string()
        temp_m["SubIndex"] = __response.pop_int32()
        temp_m["Id"] = __response.pop_int32()
        temp_l["Properties"].append(temp_m)
      temp_l["ServerIndex"] = __response.pop_int32()
      temp_l["Title"] = __response.pop_string()
      temp_l["ObjectClass"] = __response.pop_string()
      temp_l["ParentId"] = __response.pop_string()
      temp_l["ObjectId"] = __response.pop_string()
      objects.append(temp_l)
    __result.append(objects)
    return tuple(__result)

  def GetOperationCapabilityResult(self, operationId):
    """Return media server capability result of an asynchronous DLNA
    operation that notified results of type \ref OP_RESULT_CAPABILITY.
    The returned result is removed from the internal cache of the
    service and are not available in a second call to this method.
    
    \param operationId    Operation identifier.
    
    \retval capabilities  The CDS action capabilities.
    
    \exception TToiInvalidArgumentException
    Raised if operation is unknown or does not support
    capability results.
    
    \exception TToiNoDataException
    Raised if no result is available.
    """
    __request = BinIpcParameterStack()
    # Write operationId
    __request.push_int32(operationId)
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetOperationCapabilityResult")
    __result = []
    # Read capabilities
    capabilities = {}
    capabilities["ActionCapabilities"] = __response.pop_int32()
    capabilities["SortingCapabilities"] = []
    for k in range(__response.pop_int32()):
      capabilities["SortingCapabilities"].append(__response.pop_int32())
    capabilities["SearchingCapabilities"] = []
    for k in range(__response.pop_int32()):
      capabilities["SearchingCapabilities"].append(__response.pop_int32())
    __result.append(capabilities)
    return __result[0]

  def GetCdsOperationManager(self):
    """Returns the operation manager that handles asynchronous operations for
    this Content Directory Service. The procedure of executing asynchronous
    operations is generic and looks like this:
    <ul>
    <li>Get a handle to the operation manager.</li>
    <li>Register an observer to get operation events from the operation
    manager.</li>
    <li>Create an operation in order to get an operation identifier.</li>
    <li>Call an asynchronous operation using the operation identifier.</li>
    <li>Receive progress events for the asynchronous operation.</li>
    <li>When the operation is completed, get result data (if any).</li>
    <li>Release the operation or reuse the identifier for another
    asynchronous call.</li>
    </ul>
    
    \retval address The address to the operation manager.
    """
    __request = BinIpcParameterStack()
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetCdsOperationManager")
    __result = []
    # Read address
    __result.append(__response.pop_string())
    return __result[0]

  def GetServerUuid(self):
    """Returns the uuid of the media server hosting this service.
    
    \retval uuid          The UUID of the media server.
    """
    __request = BinIpcParameterStack()
    __response = self.call(__request, "IToiDlnaContentDirectoryService", "GetServerUuid")
    __result = []
    # Read uuid
    __result.append(__response.pop_string())
    return __result[0]

  def ReleaseInstance(self):
    """When an application is done using the Content Direcory Service it should
    gracefully release it by calling this function.
    """
    __request = BinIpcParameterStack()
    self.call(__request, "IToiDlnaContentDirectoryService", "ReleaseInstance")

  def RegisterObserver(self, applicationId, address):
    """Register an observer of type IToiDlnaContentDirectoryObserver.
    The observer will receive events sent by this IToiDlnaContentDirectoryService instance.
    
    \param applicationId  The identifier of the observing application.
    \param address        The address where the IToiDlnaContentDirectoryService can find an
    IToiDlnaContentDirectoryObserver interface.
    \exception TToiInvalidArgumentException
    Raised if the specified address is invalid
    or if the application has already registered
    itself as an observer with the same address.
    \see IToiDlnaContentDirectoryObserver
    """
    __request = BinIpcParameterStack()
    # Write applicationId
    __request.push_int32(applicationId)
    # Write address
    __request.push_string(address)
    self.call(__request, "IToiDlnaContentDirectoryService", "RegisterObserver")

  def ReleaseObserver(self, address):
    """Release an observer previously registered with \ref RegisterObserver.
    
    \param address        The address where the IToiDlnaContentDirectoryService
    can find the registered IToiDlnaContentDirectoryObserver interface.
    \exception TToiInvalidArgumentException
    Raised if the specified address is invalid.
    \see IToiDlnaContentDirectoryObserver
    """
    __request = BinIpcParameterStack()
    # Write address
    __request.push_string(address)
    self.call(__request, "IToiDlnaContentDirectoryService", "ReleaseObserver")

  def CreateObserver(self):
    """Create and register an observer for the service.
       (This method is only available from Python.)
    """
    observer = ToiDlnaContentDirectoryObserver(self._ipcproxy, self)
    request = BinIpcParameterStack()
    request.push_int32(self._ipcproxy.application_id)
    request.push_string(observer.observer_address)
    self.call(request, "IToiDlnaContentDirectoryService", "RegisterObserver")
    return observer
