# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.

from kreatvipccaller import KreaTvIpcCaller
from binipcparameterstack import BinIpcParameterStack
from ToiInformationObserver import ToiInformationObserver


class ToiInformationService(KreaTvIpcCaller):

  # Enum TToiStorageType
  STORAGE_PERMANENT = 0
  STORAGE_VOLATILE = 1

  # Const CFG_IIPDISTRIBUTION
  CFG_IIPDISTRIBUTION = "cfg.iipdistribution"

  # Const CFG_INFOCAST
  CFG_INFOCAST = "cfg.infocast"

  # Const CFG_EITCACHE_NVOD_IGNORERUNNINGSTATUS
  CFG_EITCACHE_NVOD_IGNORERUNNINGSTATUS = "cfg.eitcache.nvod.ignorerunningstatus"

  # Const CFG_LOCAL_TIMEZONE
  CFG_LOCAL_TIMEZONE = "cfg.locale.timezone"

  # Const CFG_LOCAL_LOCATIONCODE
  CFG_LOCAL_LOCATIONCODE = "cfg.locale.locationcode"

  # Const CFG_MEDIA_AUDIO_AUTOSELECTION
  CFG_MEDIA_AUDIO_AUTOSELECTION = "cfg.media.audio.autoselection"

  # Const CFG_MEDIA_AUDIO_LANGUAGEPRIORITY
  CFG_MEDIA_AUDIO_LANGUAGEPRIORITY = "cfg.media.audio.languagepriority"

  # Const CFG_MEDIA_AUDIO_FORMATPRIORITY
  CFG_MEDIA_AUDIO_FORMATPRIORITY = "cfg.media.audio.formatpriority"

  # Const CFG_MEDIA_AUDIO_TYPEPRIORITY
  CFG_MEDIA_AUDIO_TYPEPRIORITY = "cfg.media.audio.typepriority"

  # Const CFG_MEDIA_AUDIO_PREFERREDLANGUAGEDESCRIPTOR
  CFG_MEDIA_AUDIO_PREFERREDLANGUAGEDESCRIPTOR = "cfg.media.audio.preferredLanguageDescriptor"

  # Const CFG_AUDIOOUTPUT_DOLBYDIGITAL_DRC
  CFG_AUDIOOUTPUT_DOLBYDIGITAL_DRC = "cfg.audiooutput.dolbydigital.drc"

  # Const CFG_AUDIOOUTPUT_DOLBYDIGITAL_DOWNMIX
  CFG_AUDIOOUTPUT_DOLBYDIGITAL_DOWNMIX = "cfg.audiooutput.dolbydigital.downmix"

  # Const CFG_AUDIOOUTPUT_DOLBYDIGITAL_LFE
  CFG_AUDIOOUTPUT_DOLBYDIGITAL_LFE = "cfg.audiooutput.dolbydigital.lfe"

  # Const CFG_MEDIA_DRM_CGMSA
  CFG_MEDIA_DRM_CGMSA = "cfg.media.drm.cgmsa"

  # Const CFG_MEDIA_DRM_MACROVISION
  CFG_MEDIA_DRM_MACROVISION = "cfg.media.drm.macrovision"

  # Const CFG_MEDIA_STREAMER
  CFG_MEDIA_STREAMER = "cfg.media.streamer"

  # Const CFG_MEDIA_SUBTITLING_AUTOSELECTION
  CFG_MEDIA_SUBTITLING_AUTOSELECTION = "cfg.media.subtitling.autoselection"

  # Const CFG_MEDIA_SUBTITLING_LANGUAGEPRIORITY
  CFG_MEDIA_SUBTITLING_LANGUAGEPRIORITY = "cfg.media.subtitling.languagepriority"

  # Const CFG_MEDIA_SUBTITLING_TYPEPRIORITY
  CFG_MEDIA_SUBTITLING_TYPEPRIORITY = "cfg.media.subtitling.typepriority"

  # Const CFG_MEDIA_SUBTITLING_MODEPRIORITY
  CFG_MEDIA_SUBTITLING_MODEPRIORITY = "cfg.media.subtitling.modepriority"

  # Const CFG_MEDIA_TIMESHIFT_PLAYBACKPOLICY
  CFG_MEDIA_TIMESHIFT_PLAYBACKPOLICY = "cfg.media.timeshift.playbackpolicy"

  # Const CFG_STORAGE_AUTOMOUNT
  CFG_STORAGE_AUTOMOUNT = "cfg.storage.automount"

  # Const CFG_NTP_MAXPOLL
  CFG_NTP_MAXPOLL = "cfg.ntp.maxpoll"

  # Const CFG_NTP_MINPOLL
  CFG_NTP_MINPOLL = "cfg.ntp.minpoll"

  # Const CFG_NTP_SERVER
  CFG_NTP_SERVER = "cfg.ntp.server"

  # Const CFG_STANDBY_ALLOWUPDATE
  CFG_STANDBY_ALLOWUPDATE = "cfg.standby.allowupdate"

  # Const CFG_STANDBY_BOOTPOLICY
  CFG_STANDBY_BOOTPOLICY = "cfg.standby.bootpolicy"

  # Const CMD_REBOOT
  CMD_REBOOT = "cmd.reboot"

  # Const VAR_IP_DHCP_240
  VAR_IP_DHCP_240 = "var.ip._dhcp.240"

  # Const VAR_IP_DHCP_241
  VAR_IP_DHCP_241 = "var.ip._dhcp.241"

  # Const VAR_IP_DHCP_242
  VAR_IP_DHCP_242 = "var.ip._dhcp.242"

  # Const VAR_IP_DHCP_243
  VAR_IP_DHCP_243 = "var.ip._dhcp.243"

  # Const VAR_UTCTIME
  VAR_UTCTIME = "var.utctime"

  # Const CFG_LOCALE_UI
  CFG_LOCALE_UI = "cfg.locale.ui"

  # Const CFG_MEDIA_CHANNELTABLE
  CFG_MEDIA_CHANNELTABLE = "cfg.media.channeltable"

  # Const CFG_PORTAL_DISPLAYBUFFER_HD_WIDTH
  CFG_PORTAL_DISPLAYBUFFER_HD_WIDTH = "cfg.portal.displaybuffer.hd.width"

  # Const CFG_PORTAL_DISPLAYBUFFER_HD_HEIGHT
  CFG_PORTAL_DISPLAYBUFFER_HD_HEIGHT = "cfg.portal.displaybuffer.hd.height"

  # Const CFG_PORTAL_DISPLAYBUFFER_SD_WIDTH
  CFG_PORTAL_DISPLAYBUFFER_SD_WIDTH = "cfg.portal.displaybuffer.sd.width"

  # Const CFG_PORTAL_DISPLAYBUFFER_SD_HEIGHT
  CFG_PORTAL_DISPLAYBUFFER_SD_HEIGHT = "cfg.portal.displaybuffer.sd.height"

  # Const CFG_PORTAL_PROXYLIST
  CFG_PORTAL_PROXYLIST = "cfg.portal.proxylist"

  # Const CFG_PORTAL_RENDERINGBUFFER_WIDTH
  CFG_PORTAL_RENDERINGBUFFER_WIDTH = "cfg.portal.renderingbuffer.width"

  # Const CFG_PORTAL_RENDERINGBUFFER_HEIGHT
  CFG_PORTAL_RENDERINGBUFFER_HEIGHT = "cfg.portal.renderingbuffer.height"

  # Const CFG_PORTAL_RENDERINGMODE_HD
  CFG_PORTAL_RENDERINGMODE_HD = "cfg.portal.renderingmode.hd"

  # Const CFG_PORTAL_RENDERINGMODE_SD
  CFG_PORTAL_RENDERINGMODE_SD = "cfg.portal.renderingmode.sd"

  # Const CFG_PORTAL_WHITELISTURLS
  CFG_PORTAL_WHITELISTURLS = "cfg.portal.whitelisturls"

  # Const CFG_WEBKIT_USERAGENT
  CFG_WEBKIT_USERAGENT = "cfg.webkit.useragent"

  # Const CFG_AQAM_CONNECTED
  CFG_AQAM_CONNECTED = "cfg.aqam.connectedforservice"

  # Const CFG_AQAM_TUNING_TURNONCHANNEL
  CFG_AQAM_TUNING_TURNONCHANNEL = "cfg.aqam.tuning.turnonchannel"

  # Const CFG_AQAM_TUNING_TURNOFFCHANNEL
  CFG_AQAM_TUNING_TURNOFFCHANNEL = "cfg.aqam.tuning.turnoffchannel"

  # Const CFG_AQAM_AUDIO_ISODEFAULTLANGUAGE
  CFG_AQAM_AUDIO_ISODEFAULTLANGUAGE = "cfg.aqam.audio.isodefaultlanguage"

  # Const CFG_IP_DNS1
  CFG_IP_DNS1 = "cfg.ip.dns1"

  # Const CFG_IP_DNS2
  CFG_IP_DNS2 = "cfg.ip.dns2"

  # Const CFG_IP_ETH0_MODE
  CFG_IP_ETH0_MODE = "cfg.ip.eth0.mode"

  # Const CFG_IP_ETH0_ADDR
  CFG_IP_ETH0_ADDR = "cfg.ip.eth0.addr"

  # Const CFG_IP_ETH0_MASK
  CFG_IP_ETH0_MASK = "cfg.ip.eth0.mask"

  # Const CFG_IP_GATEWAY
  CFG_IP_GATEWAY = "cfg.ip.gateway"

  # Const CONST_FW_VERSION
  CONST_FW_VERSION = "const._fw.version"

  # Const CONST_CAPABILITIES_MACROVISION
  CONST_CAPABILITIES_MACROVISION = "const.capabilities.macrovision"

  # Const VAR_CAPABILITIES_DVR
  VAR_CAPABILITIES_DVR = "var.capabilities.dvr"

  # Const CONST_IP_ETH0_MAC
  CONST_IP_ETH0_MAC = "const.ip.eth0.mac"

  # Const CONST_HW_MANUFACTURER
  CONST_HW_MANUFACTURER = "const.hw.manufacturer"

  # Const CONST_HW_PRODUCTNAME
  CONST_HW_PRODUCTNAME = "const.hw.productname"

  # Const CONST_HW_SERIALNUMBER
  CONST_HW_SERIALNUMBER = "const.hw.serialnumber"

  # Const CONST_MEDIA_TIMESHIFTBUFFER_CONFIGSIZE
  CONST_MEDIA_TIMESHIFTBUFFER_CONFIGSIZE = "const.media.timeshiftbuffer.configsize"

  # Const CONST_MEDIA_TIMESHIFTBUFFER_CONFIGTIME
  CONST_MEDIA_TIMESHIFTBUFFER_CONFIGTIME = "const.media.timeshiftbuffer.configtime"

  # Const CONST_SW_BRANCH
  CONST_SW_BRANCH = "const.sw.branch"

  # Const CONST_SW_DATE
  CONST_SW_DATE = "const.sw.date"

  # Const CONST_SW_HOST
  CONST_SW_HOST = "const.sw.host"

  # Const CONST_SW_TIME
  CONST_SW_TIME = "const.sw.time"

  # Const CONST_SW_USER
  CONST_SW_USER = "const.sw.user"

  # Const CONST_SW_VERSION
  CONST_SW_VERSION = "const.sw.version"

  # Const CFG_ARCHITECTURE_TARGET
  CFG_ARCHITECTURE_TARGET = "config.architecture.target"

  # Const CFG_ARCHITECTURE_BOOTIMAGECOMPATIBILITY
  CFG_ARCHITECTURE_BOOTIMAGECOMPATIBILITY = "config.architecture.bootimagecompatibility"

  # Const CFG_ARCHITECTURE_DBLCOMPATIBILITY
  CFG_ARCHITECTURE_DBLCOMPATIBILITY = "config.architecture.dblcompatibility"

  # Const VAR_IP_DNS1
  VAR_IP_DNS1 = "var.ip.dns1"

  # Const VAR_IP_DNS2
  VAR_IP_DNS2 = "var.ip.dns2"

  # Const VAR_IP_ETH0_ADDR
  VAR_IP_ETH0_ADDR = "var.ip.eth0.addr"

  # Const VAR_IP_ETH0_MASK
  VAR_IP_ETH0_MASK = "var.ip.eth0.mask"

  # Const VAR_IP_ETH0_STATUS
  VAR_IP_ETH0_STATUS = "var.ip.eth0.status"

  # Const VAR_IP_GATEWAY
  VAR_IP_GATEWAY = "var.ip.gateway"

  # Const VAR_IP_METACHANNEL
  VAR_IP_METACHANNEL = "var.ip.metachannel"

  # Const VAR_RCU_LOWBATTERY
  VAR_RCU_LOWBATTERY = "var.rcu.low_battery"

  # Const VAR_IO_STATE
  VAR_IO_STATE = "var.io.state"

  # Const VAR_MEDIA_TIMESHIFTBUFFER_SPACEREQUIRED
  VAR_MEDIA_TIMESHIFTBUFFER_SPACEREQUIRED = "var.media.timeshiftbuffer.spacerequired"

  # Const VAR_MEDIA_TIMESHIFTBUFFER_AVAILABILITY
  VAR_MEDIA_TIMESHIFTBUFFER_AVAILABILITY = "var.media.timeshiftbuffer.availability"

  def __init__(self, ipcproxy):
    KreaTvIpcCaller.__init__(self, ipcproxy.ip_address, ipcproxy.port)
    self._ipcproxy = ipcproxy
    self.lookup("InformationService")

  def IsObjectDefined(self, objectName):
    """This method is used to test if an object exists, i.e. if the
    object has a value in any adapter.
    
    \param objectName    The name of the object.
    \retval exists       Whether the object exists or not.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    __response = self.call(__request, "IToiInformationService", "IsObjectDefined")
    __result = []
    # Read exists
    __result.append(__response.pop_bool())
    return __result[0]

  def GetObject(self, objectName):
    """This method is used to get a value of an object. If the object does not
    exist in any adapter, an exception is thrown. The IPC transport layer will
    generate a TIpcException if the result is too large, in which case
    \ref GetObjectToFile() must be used.
    
    \param objectName    The name of the object.
    \retval value        The value of the object.
    \exception TToiInvalidArgumentException
    Raised when there is no value for the object in any
    adapter.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    __response = self.call(__request, "IToiInformationService", "GetObject")
    __result = []
    # Read value
    __result.append(__response.pop_string())
    return __result[0]

  def GetObjects(self, objectNames):
    """This method is used to get the values of several objects in a single
    atomic transaction. The IPC transport layer will generate a
    TIpcException if the result is too large, in which case
    \ref GetObjectToFile() must be used.
    
    \param objectNames   A list of object names.
    \retval values       A list of values.
    \exception TToiInvalidArgumentException
    Raised when there is no value in any adapter for some
    of the objects.
    """
    __request = BinIpcParameterStack()
    # Write objectNames
    for iter_k in objectNames[::-1]:
      __request.push_string(iter_k)
    __request.push_int32(len(objectNames))
    __response = self.call(__request, "IToiInformationService", "GetObjects")
    __result = []
    # Read values
    values = []
    for k in range(__response.pop_int32()):
      values.append(__response.pop_string())
    __result.append(values)
    return __result[0]

  def GetObjectToFile(self, objectName, filename):
    """This method is used to get large binary objects through files. The file
    must already exist (created by caller with acceptable permissions) and
    will be truncated unless empty.
    
    \param objectName    The name of the object.
    \retval filename     A filename identifying a file where the value is
    stored.
    \exception TToiInvalidArgumentException
    Raised when there is no value for the object in any
    adapter.
    \exception TToiFileException
    Raised when there are file problems, e.g. the
    supplied file does not exist or if there are
    internal file problems.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    # Write filename
    __request.push_string(filename)
    self.call(__request, "IToiInformationService", "GetObjectToFile")

  def SetObject(self, objectName, value, storageType):
    """This method is used to set the value of an object. It can be used to set
    the value in either a permanent or volatile adapter.
    
    \param objectName    The name of the object.
    \param value         The new value.
    \param storageType   The type of adapter to store the value in.
    \exception TToiInvalidArgumentException
    Raised if there is no adapter of the specified
    storage type that supports the object.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    # Write value
    __request.push_string(value)
    # Write storageType
    __request.push_int32(storageType)
    self.call(__request, "IToiInformationService", "SetObject")

  def SetObjects(self, objectNames, values, storageTypes):
    """This method is used to set the values of several objects in a single
    atomic transaction. It can be used to set values in both permanent and
    volatile adapters.
    
    \param objectNames   A list of object names.
    \param values        The new values.
    \param storageTypes  A list of adapter types.
    \exception TToiInvalidArgumentException
    Raised if there is no adapter of the specified
    storage type that supports one of the objects.
    """
    __request = BinIpcParameterStack()
    # Write objectNames
    for iter_k in objectNames[::-1]:
      __request.push_string(iter_k)
    __request.push_int32(len(objectNames))
    # Write values
    for iter_k in values[::-1]:
      __request.push_string(iter_k)
    __request.push_int32(len(values))
    # Write storageTypes
    for iter_k in storageTypes[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(storageTypes))
    self.call(__request, "IToiInformationService", "SetObjects")

  def SetObjectFromFile(self, objectName, filename, storageType):
    """This method is used to set large binary objects via files.
    
    \param objectName    The name of the object.
    \param filename      A filename identifying a file where the value will
    be read from.
    \param storageType   The type of adapter to store the value in.
    \exception TToiInvalidArgumentException
    Raised if there is no adapter of the specified
    storage type that supports the object.
    \exception TToiFileException
    Raised when there are file problems, e.g. the
    supplied file does not exist or if there are
    internal file problems.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    # Write filename
    __request.push_string(filename)
    # Write storageType
    __request.push_int32(storageType)
    self.call(__request, "IToiInformationService", "SetObjectFromFile")

  def UnsetObject(self, objectName, storageType):
    """This method is used to remove the value of an object. No
    exception is thrown if the object currently does not have a
    value. Note that a call to this method will only remove the
    object from a single adapter; it may still exist in another. For
    instance, the object may have been set through infocast, but this
    method can only remove the value from either a permanent
    storage, e.g. flash file system, or volatile storage, e.g. RAM.
    
    \param objectName    The name of the object.
    \param storageType   The type of adapter to remove the value from.
    \exception TToiInvalidArgumentException
    Raised if there is no adapter of the specified
    storage type that supports the object.
    """
    __request = BinIpcParameterStack()
    # Write objectName
    __request.push_string(objectName)
    # Write storageType
    __request.push_int32(storageType)
    self.call(__request, "IToiInformationService", "UnsetObject")

  def UnsetObjects(self, objectNames, storageTypes):
    """This method is used to remove the values of several objects in a
    single atomic transaction. It can be used to remove values in
    both permanent and volatile adapters. No exception is thrown if
    one of the objects currently does not have a value. Note that a
    call to this method will only remove an object from a single
    adapter; it may still exist in another. For instance, an object
    may have been set through infocast, but this method can only
    remove a value from either a permanent storage, e.g. flash file
    system, or volatile storage, e.g. RAM.
    
    \param objectNames   A list of object names.
    \param storageTypes  A list of adapter types.
    \exception TToiInvalidArgumentException
    Raised if there is no adapter of the specified
    storage type that supports one of the objects.
    """
    __request = BinIpcParameterStack()
    # Write objectNames
    for iter_k in objectNames[::-1]:
      __request.push_string(iter_k)
    __request.push_int32(len(objectNames))
    # Write storageTypes
    for iter_k in storageTypes[::-1]:
      __request.push_int32(iter_k)
    __request.push_int32(len(storageTypes))
    self.call(__request, "IToiInformationService", "UnsetObjects")

  def SubscribeObject(self, address, objectExpression, callbackFlag):
    """This method is used to subscribe to value changes for an
    object. The subscriber is notified on the
    \ref IToiInformationObserver::OnObjectsChanged(). If the object exists
    when the subscription is made, there will be a callback immediately if the
    callbackFlag is set, otherwise the object is requested from the
    adapters and a notification is made when the object becomes
    available.
    
    The expression used can be a name of an object or an expression with a
    wildcard (*). The wildcard may only be used at the end of an expression
    and immediately after a dot (.), e.g. cfg.*, otherwise it is treated
    as an ordinary character.
    
    \param address            The address of the observer interface.
    \param objectExpression   A object name or an expression with wildcard
    \param callbackFlag       If true, an immediate callback is invoked if
    the object exists.
    \exception TToiInvalidArgumentException
    Raised if the address is invalid.
    \see IToiInformationObserver
    """
    __request = BinIpcParameterStack()
    # Write address
    __request.push_string(address)
    # Write objectExpression
    __request.push_string(objectExpression)
    # Write callbackFlag
    __request.push_bool(callbackFlag)
    self.call(__request, "IToiInformationService", "SubscribeObject")

  def UnsubscribeObject(self, address, objectExpression):
    """This method is used to remove a subscription. If the expression
    contains a wildcard, only the exact expression is removed, e.g. if you
    have subscribed to cfg.* and cfg.ipaddress and then unsubscribe
    cfg.*, only the cfg.* subscription will be removed. No exception is
    thrown if the subscription does not exist.
    
    \param address            The address of the subscriber.
    \param objectExpression   An object name or an expression with wildcard.
    \exception TToiInvalidArgumentException
    Raised if the address is invalid.
    \see ReleaseObserver(), IToiInformationObserver
    """
    __request = BinIpcParameterStack()
    # Write address
    __request.push_string(address)
    # Write objectExpression
    __request.push_string(objectExpression)
    self.call(__request, "IToiInformationService", "UnsubscribeObject")

  def RegisterObserver(self, applicationId, address):
    """Register an observer of type IToiInformationObserver.
    The observer will receive events sent by this IToiInformationService instance.
    
    \param applicationId  The identifier of the observing application.
    \param address        The address where the IToiInformationService can find an
    IToiInformationObserver interface.
    \exception TToiInvalidArgumentException
    Raised if the specified address is invalid
    or if the application has already registered
    itself as an observer with the same address.
    \see IToiInformationObserver
    """
    __request = BinIpcParameterStack()
    # Write applicationId
    __request.push_int32(applicationId)
    # Write address
    __request.push_string(address)
    self.call(__request, "IToiInformationService", "RegisterObserver")

  def ReleaseObserver(self, address):
    """Release an observer previously registered with \ref RegisterObserver.
    
    \param address        The address where the IToiInformationService
    can find the registered IToiInformationObserver interface.
    \exception TToiInvalidArgumentException
    Raised if the specified address is invalid.
    \see IToiInformationObserver
    """
    __request = BinIpcParameterStack()
    # Write address
    __request.push_string(address)
    self.call(__request, "IToiInformationService", "ReleaseObserver")

  def CreateObserver(self):
    """Create and register an observer for the service.
       (This method is only available from Python.)
    """
    observer = ToiInformationObserver(self._ipcproxy, self)
    request = BinIpcParameterStack()
    request.push_int32(self._ipcproxy.application_id)
    request.push_string(observer.observer_address)
    self.call(request, "IToiInformationService", "RegisterObserver")
    return observer
