# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.

from kreatvipccaller import KreaTvIpcCaller
from binipcparameterstack import BinIpcParameterStack


class ToiNameService(KreaTvIpcCaller):

  def __init__(self, ipcproxy):
    KreaTvIpcCaller.__init__(self, ipcproxy.ip_address, ipcproxy.port)
    self._ipcproxy = ipcproxy
    self.lookup("NameService")

  def LookupObject(self, name):
    """
    This function returns the IPC address for the provided
    service name.
    
    \param  name       The service name for the which
    the IPC address is requested.
    
    \retval address    The IPC address of the requested service name.
    
    \exception TToiInvalidArgumentException
    Raised if the service name is not recognized.
    """
    __request = BinIpcParameterStack()
    # Write name
    __request.push_string(name)
    __response = self.call(__request, "IToiNameService", "LookupObject")
    __result = []
    # Read address
    __result.append(__response.pop_string())
    return __result[0]

