# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.

from kreatvipccaller import KreaTvIpcCaller
from binipcparameterstack import BinIpcParameterStack


class ToiStorageFile(KreaTvIpcCaller):

  # Enum TToiStorageFileType
  FILE_TYPE_TEMPORARY = 0

  def __init__(self, ipcproxy, object_address):
    KreaTvIpcCaller.__init__(self, ipcproxy.ip_address, ipcproxy.port)
    self._ipcproxy = ipcproxy
    self.set_object_address(object_address)

  def GetUri(self):
    """Gets the URI of a file
    
    \retval uri The path/location of a file
    """
    __request = BinIpcParameterStack()
    __response = self.call(__request, "IToiStorageFile", "GetUri")
    __result = []
    # Read uri
    __result.append(__response.pop_string())
    return __result[0]

  def GetType(self):
    """Gets the type of the file.
    
    \retval fileType Type of the file.
    """
    __request = BinIpcParameterStack()
    __response = self.call(__request, "IToiStorageFile", "GetType")
    __result = []
    # Read fileType
    __result.append(__response.pop_int32())
    return __result[0]

  def ReleaseInstance(self):
    """This function releases the resources used by this instance.
    Any temporary files will be deleted. 
    """
    __request = BinIpcParameterStack()
    self.call(__request, "IToiStorageFile", "ReleaseInstance")

