from subtitletestenv import SubtitleTestEnv
import rteutils
import mediautils
import time
from PIL import Image
import tempfile

class SubtitleCaptureTestCase(SubtitleTestEnv):

    def pixmap_to_image(self, pixmap, width=720, height=576):
        image = Image.frombuffer("RGBA", (width, height), pixmap, 'raw', "RGBA", 0, 1)
        image.transpose(Image.FLIP_TOP_BOTTOM)
        b, g, r, a = image.split()
        image2 = Image.merge("RGB", (r, g, b))
        return image2
    
    def save_image(self, image, fileobject, extension = "PNG"):
        image.save(fileobject, extension)
    
    def dump_capture_image(self, resultDir, prefix = "dump_"):
        pixmap = self._rte.subtitlerenderer.GetImageBuffer()
        image = self.pixmap_to_image(pixmap.data)
        (image_file, filename) = tempfile.mkstemp(".png", prefix, resultDir)
        self.save_image(image, filename)

        image_location = filename
        if filename.find("/var/www/html/katt") != -1:
            short_filename = filename.replace("/var/www/html/katt", "")
            url = "http://glenesk.ea.mot.com:6080/public/png_view?file_path=" + short_filename
            image_location = url
    
        return image_location
