from ktestcase import KattTestCase
from subtitlecapturetestcase import SubtitleCaptureTestCase
import rteutils
import ktestrunner
import mediautils
import time

#KATTrequirement: COMP-20, Audio and subtitle components shall be turned off during all kind of trickplay.

class TestSubtitleFastForward(KattTestCase, SubtitleCaptureTestCase):
    def setUp(self):
        self._rte = rteutils.createRteConnection(self.stbIp)
        self.kill_applications(self._rte)

    def tearDown(self):
        self._rte.subtitlerenderer.StopCapture()
        mediautils.safeClose(self._rte)

    def test_subtitle_fastforward(self):
        self._rte.subtitlerenderer.StartCapture()
        self._rte.info.SetObject('cfg.media.subtitling.autoselection', 'TRUE', False)
        self._rte.info.SetObject('cfg.media.subtitling.languagepriority', 'nor,fra', False)

        # Use stream kms0050
        uri = self.get_uri('kms0050')
        mediautils.safePlay(self._rte, uri)

        time.sleep(10)
        existflag = self._rte.subtitlerenderer.HasCaptured()
        self.assertTrue(existflag, 'Failed to show subtitle')

        self._rte.media.Play(2000)
        self._rte.subtitlerenderer.Refresh()
        time.sleep(10)
        num = self._rte.subtitlerenderer.GetPageCount()
        if num == 0 or (num==1 and self._rte.subtitlerenderer.HasCaptured() == False):
            existflag = False
        else:
            existflag = True
        self.assertFalse(existflag, 'Failed to fast forward subtitles test.')

if __name__ == '__main__':
    ktestrunner.RunTests()
