# -----------------------------------------------------------------------------
#
# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
#
# This program is confidential and proprietary to Motorola Mobility, Inc and
# may not be copied, reproduced, disclosed to others, published or used, in
# whole or in part, without the expressed prior written permission of Motorola
# Mobility, Inc.
#
# -----------------------------------------------------------------------------

from subtitletestcase import SubtitleTestCase
import ktestrunner

#KATTrequirement: COMP-6(v2), Activation of automatic subtitle selection.
#KATTrequirement: COMP-10(v2), Automatic subtitle selection - mode list.

class TestSubtitleMode(SubtitleTestCase):

    def test_subtitle_mode(self):
        self.safe_play_wait('kms0625')

        self.set_is('autoselection', 'TRUE')
        self.set_is('languagepriority', 'swe,fra')
        self.set_is('typepriority', 'normal,hearing_impaired')

        # Test priority 'Teletext,DVB'
        self.set_is('modepriority', 'Teletext,DVB')
        comp = self.get_component_by_info('swe', f=self._player.SUBTITLE_TELETEXT)
        self.assertTrue(self.wait_active_subtitle([comp]))

        # Test priority 'DVB,Teletext'
        self.set_is('modepriority', 'DVB,Teletext')
        comp = self.get_component_by_info('swe', f=self._player.SUBTITLE_DVB)
        self.assertTrue(self.wait_active_subtitle([comp]))

        # Close media player.
        self.safe_close()

if __name__ == '__main__':
    ktestrunner.RunTests()

