from ktestcase import KattTestCase
from subtitlecapturetestcase import SubtitleCaptureTestCase
import rteutils
import mediautils
import toi
import ktestrunner

from PIL import Image
import time
import tempfile

#KATTrequirement: GFX-18, There shall be a graphics extension that supports decoding and rendering of subtitles. This extension shall be usable and controllable from an application. The application shall be responsible for composing the subtitles with other graphics.

class TestSubtitleRendererNormalPlay(KattTestCase, SubtitleCaptureTestCase):
    def setUp(self):
        self._rte = rteutils.createRteConnection(self.stbIp)
        self.kill_applications(self._rte)
        self._rte.subtitlerenderer.StartCapture()
        self._rte.info.SetObject('cfg.media.subtitling.languagepriority', 'eng,swe', False)
        uri = self.get_uri('kms0018')
        mediautils.safePlay(self._rte, uri)

    def tearDown(self):
        self._rte.subtitlerenderer.StopCapture()
        mediautils.safeClose(self._rte)

    """
    Test subtitle renderer in normal play
    """
    def test_subtitlerenderer(self):
        time.sleep(10)

        self.assertTrue(self._rte.subtitlerenderer.GetPageCount() > 1)
        self.assertTrue(self._rte.subtitlerenderer.HasCaptured())
        print "PageCount: %d" % self._rte.subtitlerenderer.GetPageCount()
        print "Captured subtitle Position:  %d" % self._rte.subtitlerenderer.GetPosition()
        print "Captured subtitle Checksum:  %d" % self._rte.subtitlerenderer.GetChecksum()

        if self._rte.subtitlerenderer.GetChecksum() == 1694480869:
            self.assertTrue(True)
        else:
            image_location = self.dump_capture_image("/var/www/html/katt")
            print image_location

if __name__ == '__main__':
    ktestrunner.RunTests()
