# -----------------------------------------------------------------------------
#
# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
#
# This program is confidential and proprietary to Motorola Mobility, Inc and
# may not be copied, reproduced, disclosed to others, published or used, in
# whole or in part, without the expressed prior written permission of Motorola
# Mobility, Inc.
#
# -----------------------------------------------------------------------------

from subtitletestcase import SubtitleTestCase
import ktestrunner

#KATTrequirement: COMP-1, Multiple subtitle component.
#KATTrequirement: COMP-2, Deactivate subtitle components.

class TestSubtitleSelection(SubtitleTestCase):

    def test_subtitle_selection(self):
        self.safe_play_wait('kms1178')

        for lang in ('swe', 'fre'):
            comp = self.get_component_by_info(lang)

            self._player.ActivateComponent(comp)
            self.assertTrue(self.wait_active_subtitle([comp]))

            self._player.DeactivateComponent(self._player.COMPONENT_SUBTITLE)
            self.assertTrue(self.wait_active_subtitle([]))
        
        self.safe_close()


if __name__ == '__main__':
    ktestrunner.RunTests()

