# -----------------------------------------------------------------------------
#
# Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
#
# This program is confidential and proprietary to Motorola Mobility, Inc and
# may not be copied, reproduced, disclosed to others, published or used, in
# whole or in part, without the expressed prior written permission of Motorola
# Mobility, Inc.
#
# -----------------------------------------------------------------------------

from subtitletestcase import SubtitleTestCase
import ktestrunner

#KATTrequirement: COMP-6(v2), Activation of automatic subtitle selection.
#KATTrequirement: COMP-9(v2), Automatic subtitle selection - type list.

class TestSubtitleType(SubtitleTestCase):

    def test_subtitle_type(self):
        self.safe_play_wait('kms0050')

        self.set_is('autoselection', 'TRUE')
        self.set_is('languagepriority', 'nor,swe')
        self.set_is('modepriority', 'DVB,Teletext')

        # Test priority 'hearing_impaired,normal'
        self.set_is('typepriority', 'hearing_impaired,normal')
        comp = self.get_component_by_info('nor', t=self._player.SUBTITLE_HEARING_IMPAIRED,
                                          f=self._player.SUBTITLE_DVB)
        self.assertTrue(self.wait_active_subtitle([comp]))

        # Test priority 'normal,hearing_impaired'
        self.set_is('typepriority', 'normal,hearing_impaired')
        comp = self.get_component_by_info('nor', t=self._player.SUBTITLE_NORMAL,
                                          f=self._player.SUBTITLE_DVB)
        self.assertTrue(self.wait_active_subtitle([comp]))

        # Close media player.
        self.safe_close()

if __name__ == '__main__':
    ktestrunner.RunTests()

