# -----------------------------------------------------------------------------
#
# Copyright (c) 2011 Motorola, Inc. All Rights Reserved.
#
# -----------------------------------------------------------------------------

# KATTlevel: 2
# KATTtimeout: 600
# KATTdashboard: 3

import xmlrpclib
import sys

import kdashboard
import rteutils

from ktestcase import KattTestCase


class TestBlitter(KattTestCase):
    def setUp(self):
        self.rte = rteutils.createRteConnection(self.stbIp)
        self.rte.kgfxmark.Setup()
        
    def tearDown(self):
        self.rte.kgfxmark.Teardown()

    def test_blitter(self):
        testresult = 0
        for i in range(self.rte.kgfxmark.GetTestCount()):
            result = self.rte.kgfxmark.RunPerformanceTest(i)
            name = self.rte.kgfxmark.GetName(i)
            try:
                group = "%s_%s" % (self.rte.kgfxmark.GetGroup(i), name)
            except:
                group = name
            if result == 0:
                self.fail
            else:
                value = "%d %s" % (result['value'], result['unit'])
                self.tracker.note(kdashboard.format_dasboard_result(group, 
                                                                    value))


if __name__ == '__main__':
    import ktestrunner
    try:
        ktestrunner.RunTests()
    except KeyboardInterrupt:
        pass
