/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *--------------------------------------------------------------------
 *
 * main.cpp
 *
 * CA application
 * This is not how CA systems usually are integrated, but they are
 * normally platform services. This is just an easier way to demonstrate
 * the Media Session interface.
 *
 * Copyright (c) 2010 motorola inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#include "TCaApp.h"
#include "debug/TTracker.h"
#include "debug/TLogTracker.h"

static TTracker* ProcessTracker = NULL;

TTracker* TTracker::GetProcessTracker()
{
  if (ProcessTracker == NULL) {
    ProcessTracker = new TLogTracker;
  }
  return ProcessTracker;
}

int main(int /*argc*/, char* /*argv*/[])
{
  try {
    TCaApp app;
    app.Run();
  }
  catch (TException& e) {
    TTracker::GetProcessTracker()->Fatal(e.GetText());
  }
  catch (...) {
    TTracker::GetProcessTracker()->Fatal("Unknown error");
  }

  return 0;
}
