/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * main.cpp
 *
 * Recorder application
 * A head-start sample with developing recorder applications for the KreaTV
 * TV Application Platform.
 *
 * This application depends on the Scheduler Service and Asset Manager
 * Service, "kreatv-option-scheduler" and "kreatv-option-dvr" are required
 * in boot image config file.
 *
 * The file containing the main() function. The main() function initializes
 * the application object, and calls its Run() function. It also creates a
 * Tracker object, used for outputting error and informational messages to
 * the host computer.
 *
 * Copyright (c) 2010 Motorola. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#include "TRecorderApp.h"
#include "debug/TTracker.h"
#include "debug/TLogTracker.h"

static TTracker* ProcessTracker = NULL;

TTracker* TTracker::GetProcessTracker()
{
  if (ProcessTracker == NULL) {
    ProcessTracker = new TLogTracker;
  }
  return ProcessTracker;
}

int main(int /*argc*/, char* /*argv[]*/)
{
  try {
    TRecorderApp app;
    app.Run();
  }
  catch (TException& e) {
    TTracker::GetProcessTracker()->Fatal(e.GetText());
  }
  catch (...) {
    TTracker::GetProcessTracker()->Fatal("Unknown error");
  }

  return 0;
}
