/*
 * vip19xx.h
 *
 * Copyright (C) 2008 Motorola, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307 USA
 *
 */

#ifndef ASM_SH_VIP19XX_H
#define ASM_SH_VIP19XX_H

#ifdef CONFIG_CPU_SUBTYPE_STX7105
#define VIP19XX_EMI_CONFIG_BASE 0xFE700000
#else
#define VIP19XX_EMI_CONFIG_BASE 0x1A100000
#endif
#define VIP19XX_EMI_CONFIG_SIZE 0x00100000

#define VIP19XX_EMI_BANK_BASE(vbase,bank) ((vbase) + 0x100 + (bank) * 0x40)
#define VIP19XX_EMI_CFG_DATA0(vbase,bank) (VIP19XX_EMI_BANK_BASE(vbase,bank) + 0x00)
#define VIP19XX_EMI_CFG_DATA1(vbase,bank) (VIP19XX_EMI_BANK_BASE(vbase,bank) + 0x08)
#define VIP19XX_EMI_CFG_DATA2(vbase,bank) (VIP19XX_EMI_BANK_BASE(vbase,bank) + 0x10)
#define VIP19XX_EMI_CFG_DATA3(vbase,bank) (VIP19XX_EMI_BANK_BASE(vbase,bank) + 0x18)

#define VIP19XX_EMI_CFG_CSACTIVE      (0x3<<9)
#define VIP19XX_EMI_CFG_PORTSIZE_MASK (0x3<<3)
#define VIP19XX_EMI_CFG_PORTSIZE_16   (0x2<<3)

#define VIP19XX_EMI_ENABLE_CS(emi,bank) \
  writel((readl(VIP19XX_EMI_CFG_DATA0(emi, bank)) | VIP19XX_EMI_CFG_CSACTIVE), \
         VIP19XX_EMI_CFG_DATA0(emi, bank))
#define VIP19XX_EMI_DISABLE_CS(emi,bank) \
  writel((readl(VIP19XX_EMI_CFG_DATA0(emi, bank)) & ~VIP19XX_EMI_CFG_CSACTIVE), \
         VIP19XX_EMI_CFG_DATA0(emi, bank))

/* NOR flash */
#define VIP19XX_NOR_FLASH_BASE      0x00000000
#define VIP19XX_NOR_FLASH_SIZE      (4*1024*1024)
#define VIP19XX_NOR_FLASH_BANKWIDTH 2
#define VIP19XX_NOR_FLASH_FFS_SIZE  (7*64*1024)
#define VIP19XX_NOR_FLASH_EMI_BANK  0

/* NAND flash */
#define VIP19XX_NAND_FLASH_BASE     0x01000000
#define VIP19XX_NAND_FLASH_SIZE     1
#define VIP19XX_NAND_FLASH_EMI_BANK 1

#endif
