/*
 * -------------------------------------------------------------------------
 * <linux_root>/include/linux/stm/pm_notify.h
 * -------------------------------------------------------------------------
 * STMicroelectronics
 * -------------------------------------------------------------------------
 * Copyright (C) 2010  STMicroelectronics
 * Author: Francesco M. Virlinzi  <francesco.virlinzi@st.com>
 *
 * May be copied or modified under the terms of the GNU General Public
 * License V.2 ONLY.  See linux/COPYING for more information.
 *
 * ------------------------------------------------------------------------- */

#ifndef __STM_LINUX_NOTIFY__
#define __STM_LINUX_NOTIFY__

enum stm_pm_type_e {
	STM_SUSPEND,
	STM_MEMSUSPEND,
	STM_HIBERNATION,
};

enum stm_notify_return_e {
	STM_RET_OK,
	STM_RET_ERROR,
	STM_RET_AGAIN,
};

struct stm_pm_notify {

	void *private_data;

	enum stm_notify_return_e (*pre_enter)
		(enum stm_pm_type_e type, void *data);

	enum stm_notify_return_e (*pre_enter_noirq)
		(enum stm_pm_type_e type, void *data);

	enum stm_notify_return_e (*post_enter_noirq)
		(enum stm_pm_type_e type, int wkirq, void *data);

	enum stm_notify_return_e (*post_enter)
		(enum stm_pm_type_e type, int wkirq, void *data);
};

enum stm_notify_return_e
stm_pm_prepare_enter(enum stm_pm_type_e type);

enum stm_notify_return_e
stm_pm_prepare_enter_noirq(enum stm_pm_type_e type);

enum stm_notify_return_e
stm_pm_post_enter_noirq(enum stm_pm_type_e type, int wkirq);

enum stm_notify_return_e
stm_pm_post_enter(enum stm_pm_type_e type, int wkirq);

int stm_register_pm_notify(struct stm_pm_notify *notify);

#endif