/*
 *--------------------------------------------------------------------
 *
 * NonCopyable.h
 *
 * A macro for making classes non copyable. 
 * Same functionality as boost::noncopyable but without mix-in 
 * inheritance.
 * 
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef NONCOPYABLE_H
#define NONCOPYABLE_H

#define NON_COPYABLE(T) \
private:\
  T(T const&); \
  T& operator=(T const&)

#endif
