/*
 *--------------------------------------------------------------------
 *
 * base/TException.h
 *
 * An exception base class
 *
 * Copyright (c) 1996-2002 Kreatel Communications AB
 *
 *--------------------------------------------------------------------
 */

#ifndef TEXCEPTION_H
#define TEXCEPTION_H

#include <exception>
#include <string>

class TException : public std::exception
{
private:
  const std::string Message;

public:
  TException(const std::string& message) throw ();
  virtual ~TException() throw ();

  virtual const char* GetText() const throw ();
  virtual const std::string& GetString() const throw ();
  virtual const char* what () const throw ();
};

inline TException::TException(const std::string& message) throw ()
  : Message(message)
{
  
}

inline TException::~TException() throw ()
{
  
}

inline const char* TException::GetText() const throw ()
{
  return Message.c_str();
}

inline const std::string& TException::GetString() const throw ()
{
  return Message;
}

inline const char* TException::what () const throw ()
{
  return GetText();
}

#endif
