/* -*- mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * IEmioSocket.h
 *
 *
 * Copyright (c) 2008 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */


#ifndef IEMIOSOCKET_H_
#define IEMIOSOCKET_H_

class IEmioSocket
{
public:
  enum { INVALID_FILE_DESCRIPTOR = -1 };

  virtual ~IEmioSocket() { /* empty */ }

  virtual bool Close() = 0;

  virtual void SetFD(int fd) = 0;
  virtual int GetFD() const = 0;

  virtual bool IsOpen() const = 0;

  
  
  
  
  
  virtual int Read(void* buffer, unsigned long count) = 0;

  
  
  
  
  
  virtual int Write(const void* buffer, unsigned long count) = 0;

  
  
  virtual bool SetBlocking() = 0;
  virtual bool SetNonBlocking() = 0;

  
  
  
  virtual bool SetCloseOnExec() = 0;

  virtual int GetPendingError() = 0;

  
  
  virtual bool ShutdownRD() = 0;
  virtual bool ShutdownWR() = 0;
  virtual bool ShutdownRDWR() = 0;

  virtual void SetReceiveBufferSize(unsigned long size) = 0;
};

#endif /* IEMIOSOCKET_H_ */
