/* -*- mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * ITcpSocket.h
 *
 *
 * Copyright (c) 2008 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */


#ifndef ITCPSOCKET_H_
#define ITCPSOCKET_H_

#include "IStreamSocket.h"

#include <netinet/in.h>

class ITcpSocket : virtual public IStreamSocket
{
public:
  virtual ~ITcpSocket() { /* empty */ }

  virtual void Open() = 0;

  virtual bool GetSocketName(sockaddr_in& address) = 0;

  virtual bool GetPeerName(sockaddr_in& address) = 0;

  virtual bool GetPeerName(char* address, unsigned int size) = 0;

  virtual bool Bind(const char* address, unsigned short port) = 0;
  virtual bool Bind(unsigned long address, unsigned short port) = 0;
  virtual bool Bind(unsigned short port) = 0;
  virtual bool Bind(sockaddr_in& address) = 0;

  virtual bool Accept(ITcpSocket* s) = 0;
  virtual int Connect(const sockaddr_in& address) = 0;
  virtual bool SetTcpFlag(int optname, bool flag) = 0;
};


#endif /* ITCPSOCKET_H_ */
