/* -*- mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * IUnixSocket.h
 *
 *
 * Copyright (c) 2008 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */


#ifndef IUNIXSOCKET_H_
#define IUNIXSOCKET_H_

#include "IStreamSocket.h"

#include <string>

class IUnixSocket : virtual public IStreamSocket
{
public:
  virtual ~IUnixSocket() { /* Empty */ }

  virtual bool BindTempName(std::string& path, bool abstract = false) = 0;
  virtual bool Bind(const char* sun_path, bool abstract = false) = 0;
  virtual bool Accept(IUnixSocket* socket) = 0;

  
  virtual bool Connect(const char* path, bool abstract = false) = 0;
};

#endif /* IUNIXSOCKET_H_ */
