/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * comm/emio/TInetProto.h
 *
 * 
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef COMM_EMIO_TINETPROTO_H
#define COMM_EMIO_TINETPROTO_H

#include <netinet/in.h>
#include <string>

/**
 * @class TInetProto
 *
 * @brief This class contains helper functions for converting internet
 *        addresses.
 */
class TInetProto
{
private:
  TInetProto();
  ~TInetProto();

public:
  static bool CreateAddress(sockaddr_in &addr, unsigned short port);
  static bool CreateAddress(sockaddr_in &addr,
                            const char* host,
                            unsigned short port);
  static bool CreateAddress(sockaddr_in &addr,
                            unsigned long ip,
                            unsigned short port);

  
  
  static bool Bind(int fd, const char* address, unsigned short port);
  static bool Bind(int fd, unsigned long address, unsigned short port);
  static bool Bind(int fd, unsigned short port);
  static bool Bind(int fd, sockaddr_in& address);

  
  static std::string StripPaddingZeros(const std::string& address);
};

#endif 
