/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * comm/emio/TMulticastSocket.h
 *
 * 
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef COMM_EMIO_TMULTICASTSOCKET_H
#define COMM_EMIO_TMULTICASTSOCKET_H

#include "TDatagramSocket.h"

#include <netinet/in.h>



class TMulticastSocket : public TDatagramSocket
{
private:
  bool JoinedFlag;
  struct ip_mreq MulticastRequest;

public:
  TMulticastSocket(bool doOpen = true);

  void Open();

  bool Join(const char* address, uint16_t port);
  bool Leave();
  bool ReJoin();
  bool IsJoined() const;
};

inline TMulticastSocket::TMulticastSocket(bool doOpen) :
  TDatagramSocket(doOpen, PF_INET),
  JoinedFlag(false)
{
  
}

inline void TMulticastSocket::Open()
{
  TDatagramSocket::Open(PF_INET);
}

inline bool TMulticastSocket::IsJoined() const
{
  return JoinedFlag;
}

#endif 
