/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * comm/emio/TUdpSocket.h
 *
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef COMM_EMIO_TUDPSOCKET_H
#define COMM_EMIO_TUDPSOCKET_H

#include "TDatagramSocket.h"
#include "TInetProto.h"

#include <netinet/in.h>
#include <sys/times.h>


class TUdpSocket : public TDatagramSocket
{ 
protected:
  enum { BIND_RANDOM_PORT_RETRY_LIMIT = 8 };

public:
  TUdpSocket(bool doOpen = true);

  void Open();
  bool Connect(const char* address, unsigned short port); 

  
  
  bool Bind(const char* address, unsigned short port);
  bool Bind(unsigned long address, unsigned short port);
  bool Bind(unsigned short port);
  bool Bind(sockaddr_in& address);
};


inline TUdpSocket::TUdpSocket(bool doOpen)
  : TDatagramSocket(doOpen, PF_INET)
{
  
}

inline void TUdpSocket::Open()
{
  TDatagramSocket::Open(PF_INET);
}

inline bool TUdpSocket::Connect(const char* address, unsigned short port)
{
  return TInetProto::CreateAddress((sockaddr_in&) ToAddr, address, port);
}

inline bool TUdpSocket::Bind(const char* address, unsigned short port)
{
  return TInetProto::Bind(Descriptor, address, port);
}

inline bool TUdpSocket::Bind(unsigned short port)
{
  return TInetProto::Bind(Descriptor, (unsigned long) INADDR_ANY, port);	
}

inline bool TUdpSocket::Bind(unsigned long address, unsigned short port)
{
  return TInetProto::Bind(Descriptor, address, port);
}

inline bool TUdpSocket::Bind(sockaddr_in& address)
{
  return TInetProto::Bind(Descriptor, address);
}

#endif 
