/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * comm/emio/TUnixDatagramSocket.h
 *
 * Copyright (c) 2005 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef COMM_EMIO_TUNIXDATAGRAMSOCKET_H
#define COMM_EMIO_TUNIXDATAGRAMSOCKET_H

#include "TDatagramSocket.h"
#include "TUnixBase.h"

#include <sys/un.h>

class TUnixDatagramSocket : public TDatagramSocket,
                            public TUnixBase
{
private:
  sockaddr_un ToAddrUnix;
public:
  TUnixDatagramSocket(bool doOpen = true);

  void Open();

  
  bool Bind(const char* sun_path, bool abstract = false);

  
  bool Connect(const char* path, bool abstract = false);

  virtual int Write(const void* buffer, unsigned long size);
  virtual int Write(const void* buffer, unsigned long size, sockaddr_un* addr);
};


inline TUnixDatagramSocket::TUnixDatagramSocket(bool doOpen)
  : TDatagramSocket(doOpen, PF_LOCAL)
{
  
}

inline void TUnixDatagramSocket::Open()
{
  TDatagramSocket::Open(PF_LOCAL);
}

inline int TUnixDatagramSocket::Write(const void* buffer, unsigned long size)
{
  return TDatagramSocket::Write(buffer, size, &ToAddrUnix);
}

inline int TUnixDatagramSocket::Write(const void* buffer, unsigned long size,
                                      sockaddr_un* addr)
{
  return TDatagramSocket::Write(buffer, size, addr);
}


#endif 
