/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * comm/emio/TUnixSocket.h
 *
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef COMM_EMIO_TUNIXSOCKET_H
#define COMM_EMIO_TUNIXSOCKET_H

#include "TStreamSocket.h"
#include "IUnixSocket.h"
#include "TUnixBase.h"

#include <sys/un.h>


class TUnixSocket : public TStreamSocket,
                    public TUnixBase,
                    virtual public IUnixSocket
{
private:
  sockaddr_un SunAddr;
  bool NameCreated;
public:
  TUnixSocket(bool doOpen = true);
  virtual ~TUnixSocket();

  void Open();

  
  bool Bind(const char* sun_path, bool abstract = false);
  bool BindTempName(std::string& sun_path, bool abstract = false)
  { return TUnixBase::BindTempName(sun_path, abstract); }

  
  
  bool Accept(TUnixSocket& socket);

  bool Accept(IUnixSocket* socket);

  
  bool Connect(const char* path, bool abstract = false);
};


inline TUnixSocket::TUnixSocket(bool doOpen)
  : TStreamSocket(doOpen, PF_LOCAL),
    NameCreated(false)
{
  
}

inline void TUnixSocket::Open()
{
  TStreamSocket::Open(PF_LOCAL);
}

inline bool TUnixSocket::Accept(TUnixSocket& socket)
{
  return Accept(&socket);
}

#endif 
