









#ifndef DEBUG_KDEBUG_H
#define DEBUG_KDEBUG_H

#ifndef KDEBUG_TRACKER
#define KDEBUG_TRACKER TTracker::GetProcessTracker()
#include "debug/TTracker.h"
#endif

#ifndef KDEBUG_PREFIX
#define KDEBUG_PREFIX
#endif

#define KDEBUG_STR(x) KDEBUG_ ## x
#define KDEBUG_LEVEL_MODULE(x) KDEBUG_STR(x)

#ifndef KDEBUG_TRACE_PREFIX
#define KDEBUG_TRACE_PREFIX KDEBUG_PREFIX
#endif

#if !defined(KDEBUG_TRACE_PREFIX_ARGS) && defined(KDEBUG_PREFIX_ARGS)
#define KDEBUG_TRACE_PREFIX_ARGS KDEBUG_PREFIX_ARGS
#endif

#ifdef KDEBUG_MODULE

#define KDEBUG_LEVEL KDEBUG_LEVEL_MODULE(KDEBUG_MODULE)

int KDEBUG_LEVEL = 0;

#ifdef KDEBUG_TRACE_PREFIX_ARGS
#define KTRACE(fmt, args...)                                          \
  do {                                                                \
    if (KDEBUG_LEVEL >= 1) {                                          \
      KDEBUG_TRACKER->Debug(                                          \
        KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, ## args);  \
    }                                                                 \
  } while (false)
#define KTRACE1(fmt, args...)                                         \
  do {                                                                \
    if (KDEBUG_LEVEL >= 1) {                                          \
      KDEBUG_TRACKER->Debug(                                          \
        KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, ## args);  \
    }                                                                 \
  } while (false)
#define KTRACE2(fmt, args...)                                         \
  do {                                                                \
    if (KDEBUG_LEVEL >= 2) {                                          \
      KDEBUG_TRACKER->Debug(                                          \
        KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, ## args);  \
    }                                                                 \
  } while (false)
#define KTRACE3(fmt, args...)                                         \
  do {                                                                \
    if (KDEBUG_LEVEL >= 3) {                                          \
      KDEBUG_TRACKER->Debug(                                          \
        KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, ## args);  \
    }                                                                 \
  } while (false)
#else
#define KTRACE(fmt, args...)                                    \
  do {                                                          \
    if (KDEBUG_LEVEL >= 1) {                                    \
      KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args);  \
    }                                                           \
  } while (false)
#define KTRACE1(fmt, args...)                                   \
  do {                                                          \
    if (KDEBUG_LEVEL >= 1) {                                    \
      KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args);  \
    }                                                           \
  } while (false)
#define KTRACE2(fmt, args...)                                   \
  do {                                                          \
    if (KDEBUG_LEVEL >= 2) {                                    \
      KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args);  \
    }                                                           \
  } while (false)
#define KTRACE3(fmt, args...)                                   \
  do {                                                          \
    if (KDEBUG_LEVEL >= 3) {                                    \
      KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args);  \
    }                                                           \
  } while (false)
#endif

#else 

#ifndef KDEBUG_LEVEL
#define KDEBUG_LEVEL 1
#endif

#define KTRACE(fmt, args...)
#define KTRACE1(fmt, args...)
#define KTRACE2(fmt, args...)
#define KTRACE3(fmt, args...)

#ifdef KDEBUG
#ifdef KDEBUG_TRACE_PREFIX_ARGS
#if KDEBUG_LEVEL >= 1
#undef KTRACE
#define KTRACE(fmt, args...)                                            \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, \
                        ## args)
#endif
#if KDEBUG_LEVEL >= 1
#undef KTRACE1
#define KTRACE1(fmt, args...)                                           \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, \
                        ## args)
#endif
#if KDEBUG_LEVEL >= 2
#undef KTRACE2
#define KTRACE2(fmt, args...)                                           \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, \
                        ## args)
#endif
#if KDEBUG_LEVEL >= 3
#undef KTRACE3
#define KTRACE3(fmt, args...)                                           \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, KDEBUG_TRACE_PREFIX_ARGS, \
                        ## args)
#endif
#else 
#if KDEBUG_LEVEL >= 1
#undef KTRACE
#define KTRACE(fmt, args...)                                    \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args)
#endif
#if KDEBUG_LEVEL >= 1
#undef KTRACE1
#define KTRACE1(fmt, args...)                                   \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args)
#endif
#if KDEBUG_LEVEL >= 2
#undef KTRACE2
#define KTRACE2(fmt, args...)                                   \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args)
#endif
#if KDEBUG_LEVEL >= 3
#undef KTRACE3
#define KTRACE3(fmt, args...)                                   \
  KDEBUG_TRACKER->Debug(KDEBUG_TRACE_PREFIX fmt, ## args)
#endif
#endif 
#endif 

#endif 

#ifdef KDEBUG_PREFIX_ARGS
#define KNOTE(fmt, args...)                                             \
  KDEBUG_TRACKER->Note(KDEBUG_PREFIX fmt, KDEBUG_PREFIX_ARGS, ## args)
#define KWARNING(fmt, args...)                                          \
  KDEBUG_TRACKER->Warning(KDEBUG_PREFIX fmt, KDEBUG_PREFIX_ARGS, ## args)
#define KERROR(fmt, args...)                                            \
  KDEBUG_TRACKER->Error(KDEBUG_PREFIX fmt, KDEBUG_PREFIX_ARGS, ## args)
#define KFATAL(fmt, args...)                                            \
  KDEBUG_TRACKER->Fatal(KDEBUG_PREFIX fmt, KDEBUG_PREFIX_ARGS, ## args)
#else
#define KNOTE(fmt, args...)                             \
  KDEBUG_TRACKER->Note(KDEBUG_PREFIX fmt, ## args)
#define KWARNING(fmt, args...)                          \
  KDEBUG_TRACKER->Warning(KDEBUG_PREFIX fmt, ## args)
#define KERROR(fmt, args...)                            \
  KDEBUG_TRACKER->Error(KDEBUG_PREFIX fmt, ## args)
#define KFATAL(fmt, args...)                            \
  KDEBUG_TRACKER->Fatal(KDEBUG_PREFIX fmt, ## args)
#endif

#define KDEBUG_ENABLE(module)                   \
  do {                                          \
    extern int KDEBUG_LEVEL_MODULE(module);     \
    KDEBUG_LEVEL_MODULE(module) = 1;            \
  } while (false)

#define KDEBUG_ENABLE_LEVEL(module, level)      \
  do {                                          \
    extern int KDEBUG_LEVEL_MODULE(module);     \
    KDEBUG_LEVEL_MODULE(module) = level;        \
  } while (false)

#endif 
