/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TLogLevel.h
 *
 * The enumeration of log levels.
 *
 * Copyright (c) 2004 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TLOGLEVEL_H
#define DEBUG_TLOGLEVEL_H

/** The TLogLevel enum is used for two purposes: to set the output
    filter to discard output that is less important, and to label each
    entry with a severity label to assist in later analysis. In the
    second case, only the range TrackDebug to TrackFatal is used. */

enum TLogLevelEnum {
  LOG_LEVEL_NONE,    /* No log level defined, used for stderr logging. */
  LOG_LEVEL_FATAL,   /* Severe events that prevent continued execution. */
  LOG_LEVEL_ERROR,   /* Failures that the process can handle. */
  LOG_LEVEL_WARNING, /* Extraordinary or unexpected, but manageable, behavior. */
  LOG_LEVEL_NOTE,    /* Important state changes. */
  LOG_LEVEL_DEBUG,   /* Particular passages of general interest in the code. */
  LOG_LEVEL_ALL      /* Output everything. */
};
typedef enum TLogLevelEnum TLogLevel;

#endif
