/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TLogTracker.h
 *
 * A TTracker specialization that prints all trace output to the
 * specially designated log pipe.
 *
 * Copyright (c) 2004 Kreatel Communications AB. All Rights Reserved.
 * Copyright (c) 2007 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TLOGTRACKER_H
#define DEBUG_TLOGTRACKER_H

#include "debug/TTracker.h"



class TLogTracker : public TTracker
{
private:
  int Descriptor;
  int SequenceNumber;
  
  
#ifdef PROFILE
  unsigned int FormatMisses;
  unsigned int TotalLength;
  unsigned int LongestLine;
#endif

  virtual void Output(TLevel level, const char* format, va_list ap) throw ();

public:
  enum { LOG_FD = 4 };

  TLogTracker() throw ();

  
  void SetDescriptor(int fd) { Descriptor = fd; }

  
  void OverrideLogLevel(TLevel level) { Level = level; }
};

#endif 
