/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TNullTracker.h
 *
 * A TTracker specialization that ignores all trace output.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TNULLTRACKER_H
#define DEBUG_TNULLTRACKER_H

#include "TTracker.h"

class TNullTracker : public TTracker
{
protected:
  virtual void Output(TLevel level, const char *format, va_list ap) throw ();

public:
  TNullTracker() throw ();
};

inline void TNullTracker::Output(TLevel /*level*/, const char */*format*/,
                          va_list /*ap*/) throw ()
{
  
}

inline TNullTracker::TNullTracker() throw () :
  TTracker(TTracker::TrackNone)
{
  
}

#endif 
