/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TStderrTracker.h
 *
 * A TTracker specialization that prints all trace output to the stderr.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TSTDERRTRACKER_H
#define DEBUG_TSTDERRTRACKER_H

#include "TTracker.h"

#include "unix-wrappers/TTimeVal.h"

class TStderrTracker : public TTracker
{
private:
  TSystemTime StartTime;
  bool TimeStampFlag;

protected:
  virtual void Output(TLevel level, const char* format, va_list ap) throw ();

public:
  TStderrTracker(TLevel level, bool printTimeStamp = true) throw ();
};

#endif 
