/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TStdoutLogger.cpp
 *
 * This is a minimal logger used for performance measurements when the
 * normal logger is turned off.
 *
 * Copyright (c) 2007 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TSTDOUTLOGGER_H
#define DEBUG_TSTDOUTLOGGER_H

#include <ctime>
#include <sys/time.h>
#include <cstdio>

class TStdoutLogger
{
 public:
  static void Log(const char* text) {
    struct timeval tv;
    ::gettimeofday(&tv, NULL);
    struct tm* tm = ::localtime(&tv.tv_sec);
    fprintf(stdout, "0 %02d:%02d:%02d.%03ld dummyprocess(0): %s\n", 
            tm->tm_hour, tm->tm_min, tm->tm_sec, tv.tv_usec / 1000, text);
  }
};

#endif
