/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TSwitchableTracker.h
 *
 * A TTracker specialization that ignores all trace output.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef DEBUG_TSWITCHABLETRACKER_H
#define DEBUG_TSWITCHABLETRACKER_H

#include "TTracker.h"

#include <cstddef>

class TSwitchableTracker : public TTracker
{
private:
  TTracker* Tracker;

protected:
  void AdjustLevel() throw ();
  virtual void Output(TLevel level, const char* format, va_list ap) throw ();

public:
  TSwitchableTracker(TTracker* defaultTracker = NULL) throw ();

  void Switch(TTracker* tracker) throw ();
};

#endif 
