/*
 *--------------------------------------------------------------------
 *
 * common/cpp/debug/TTrackerLine.h
 *
 * A class representing one line of tracker output.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TTRACKERLINE
#define TTRACKERLINE

#include <stdint.h>
#include <string>

class TTrackerLine
{
protected:
  std::string Buffer;
public:
  TTrackerLine();
  ~TTrackerLine();

  void Append(const char* format, ...)
    throw () __attribute__((format(printf, 2, 3)));
  void Clear() throw ();

  const char* GetText() const throw ();
  uint32_t GetLength() const throw ();
};

#endif
