/*
 *---------------------------------------------------------------------------
 *
 * TrackerSplit.h
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef TRACKERUTIL_H
#define TRACKERUTIL_H

#include "debug/TTracker.h"

#include <string>

namespace TrackerUtil
{
  
void Split(TTracker* tracker, TTracker::TLevel level,
           const std::string& dump) throw ()
{
  std::string::size_type start = 0;
  std::string::size_type next = 0;
  while (start < dump.size() && next != std::string::npos) {
    next = dump.find('\n', start);
    tracker->Track(level, "%s", dump.substr(start, next - start).c_str());
    start = next + 1;
  }
}

void TraceSplit(const std::string& dump) throw ()
{
  Split(TTracker::GetProcessTracker(), TTracker::TrackDebug, dump);
}

}

#endif
