/*
 *--------------------------------------------------------------------
 *
 * debug/debuglog.h
 *
 * A header file provided for compatibility with older software which
 * uses TRACE, ERROR, ... and such macros.
 *
 * Copyright (c) 2004 Kreatel Communications AB. All rights reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef DEBUG_DEBUGLOG_H
#define DEBUG_DEBUGLOG_H

#ifdef __cplusplus


#include "debug/TTracker.h"

#define FATAL(message, args...) \
  TTracker::GetProcessTracker()->Fatal(message, ##args);

#define ERROR(message, args...) \
  TTracker::GetProcessTracker()->Error(message, ##args);

#define WARNING(message, args...) \
  TTracker::GetProcessTracker()->Warning(message, ##args);

#define NOTE(message, args...) \
  TTracker::GetProcessTracker()->Note(message, ##args);

#define TRACE(message, args...) \
  TTracker::GetProcessTracker()->Debug(message, ##args);


#else /* i.e. not __cplusplus below */


#include "logoutput.h"

#define FATAL(message, args...) \
  LogOutput(LOG_LEVEL_FATAL, message, ##args);

#define ERROR(message, args...) \
  LogOutput(LOG_LEVEL_ERROR, message, ##args);

#define WARNING(message, args...) \
  LogOutput(LOG_LEVEL_WARNING, message, ##args);

#define NOTE(message, args...) \
  LogOutput(LOG_LEVEL_NOTE, message, ##args);

#define TRACE(message, args...) \
  LogOutput(LOG_LEVEL_DEBUG, message, ##args);


#endif /* __cplusplus */

#endif /* DEBUG_DEBUGLOG_H */
