/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IIOEventHandler.h
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 * Copyright (c) 2007 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef IIOEVENTHANDLER_H
#define IIOEVENTHANDLER_H

#include "IIOEventLoop.h"

/** Callback interface registered with IIOEventLoop::AddDescriptor(). */
class IIOEventHandler
{
protected:
  virtual ~IIOEventHandler() { /* Empty */ }

public:
  /** Callback method for I/O events. This method is called when an
      event is signalled on a file descriptor that was added through
      the event loop interface. Note that unless data is read or
      written from within the event handler (for read and write events
      respectively), it will be called again immediately.

      \param fd         File descriptor number.

      \param event      The event that was signalled.
  */
  virtual void HandleEvent(int fd, uint32_t event) throw () = 0;
};

#endif
