/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IIOTimeoutHandler.h
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 * Copyright (c) 2007 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef IIOTIMEOUTHANDLER_H
#define IIOTIMEOUTHANDLER_H

#include "IIOEventLoop.h"

/** Callback interface registered with IIOEventLoop::AddTimer(). */
class IIOTimeoutHandler
{
protected:
  virtual ~IIOTimeoutHandler() { /* Empty */ }
public:
  /** Callback method for timer events. It is called at the end of
      each interval. It is possible to emulate a single-shot timer by
      removing the timer from the event loop before returning.

      \param timerId    The timer identifier.
  */
  virtual void HandleTimeout(int timerId) throw () = 0;
};

#endif
