





#ifndef event_THandlerSet_h
#define event_THandlerSet_h

#include "event/IIOEventLoop.h"

#include <stdint.h>
#include <poll.h>

#include <map>

class IIOEventHandler;
class TTracker;

class THandlerSet
{
public:
  THandlerSet();
  ~THandlerSet();

  int AddDescriptor(int fd,
                    uint32_t eventMask,
                    IIOEventLoop::TPriority priority,
                    IIOEventHandler* handler);

  int RemoveDescriptor(int fd);

  bool IsModified() const;

  std::pair<pollfd*, nfds_t> GetPollArray();

  void HandleEvent(const pollfd& pollEvent);

private:
  struct TEventHandler
  {
    int16_t PollMask;
    IIOEventLoop::TPriority Priority;
    IIOEventHandler* EventHandler;

    TEventHandler(int16_t pollMask,
                  IIOEventLoop::TPriority prio,
                  IIOEventHandler* handler)
      : PollMask(pollMask), Priority(prio), EventHandler(handler) {}
  };

  typedef std::map<int, TEventHandler> THandlerMap;
  typedef std::map<IIOEventLoop::TPriority, THandlerMap> TPrioMap;

  THandlerMap Handlers;
  TPrioMap PrioMap;

  bool Modified;
  pollfd* FdArray;
  nfds_t FdArraySize;
  TTracker* Tracker;
};

#endif
