






#ifndef EVENT_TTIMER_H
#define EVENT_TTIMER_H

#include "base/NonCopyable.h"
#include "event/IIOTimeoutHandler.h"

class IIOEventLoop;
class ITimerHandler;

class TTimer : public IIOTimeoutHandler
{
private:
  NON_COPYABLE(TTimer);

  static const int INVALID_TIMER_ID = -1;

  IIOEventLoop& EventLoop;
  ITimerHandler& TimerHandler;
  int TimerId;
  bool SingleShot;

  
  virtual void HandleTimeout(int timerId) throw ();

public:
  TTimer(IIOEventLoop& eventLoop, ITimerHandler& timerHandler);
  ~TTimer();
  bool operator==(TTimer& rightHandSide) const
  { return this == &rightHandSide; }

  void Start(uint32_t interval);
  void StartSingleShot(uint32_t interval);
  void Stop();

  bool IsStarted() const { return TimerId != INVALID_TIMER_ID; }
};

#endif
