/* -*- mode: c++; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * TUnixSignalPropagator.h
 *
 * Copyright (c) 2009 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef EVENT_TUNIXSIGNALPROPAGATOR_H
#define EVENT_TUNIXSIGNALPROPAGATOR_H

#include "base/NonCopyable.h"
#include "event/IIOEventHandler.h"
#include "IUnixSignalHandler.h"

#include <algorithm>
#include <vector>

class IIOEventLoop;
class TTracker;









class TUnixSignalPropagator : public IIOEventHandler
{
private:
  NON_COPYABLE(TUnixSignalPropagator);

  TTracker& Tracker;
  IIOEventLoop& EventLoop;

  
  typedef std::pair<int, IUnixSignalHandler*> TSignalHandlerPair;
  typedef std::vector<TSignalHandlerPair> THandlers;
  THandlers Handlers;

public:
  TUnixSignalPropagator(IIOEventLoop& eventLoop);
  virtual ~TUnixSignalPropagator();

  void AddHandler(int signalNumber, IUnixSignalHandler* handler);
  void RemoveHandler(int signalNumber, IUnixSignalHandler* handler);

  
  virtual void HandleEvent(int fd, uint32_t event) throw ();
};

#endif
