#ifndef IREGIONBUFFER_H
#define IREGIONBUFFER_H

#include "utils/TRect.h"
#include <vector>
#include <stdint.h>

union TClutEntry
{
  struct
  {
    uint8_t b;
    uint8_t g;
    uint8_t r;
    uint8_t a;
  } Bytes;
  uint32_t Value;
};
typedef std::vector<TClutEntry> TClut;

class IRegionBuffer
{
public:
  virtual ~IRegionBuffer() { /* Empty */ };

  virtual void SetClut(const TClut& clut, TClut::size_type clearIndex) = 0;
  virtual const TRect& GetBoundingRect() = 0;
};

#endif
