/*
 *---------------------------------------------------------------------------
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 * Copyright (c) 2011 Motorola Mobility, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef ISUBTITLEPAGE_H
#define ISUBTITLEPAGE_H

#include "IRegionBuffer.h"

#include "utils/TBitStream.h"
#include <stdint.h>

class ISubtitlePageQueue;

class ISubtitlePage
{
public:
  virtual ~ISubtitlePage() { /* Empty */ }

  virtual ISubtitlePage* Clone() throw () = 0;
  virtual bool Render(IRegionBuffer& buffer) throw () = 0;
  virtual uint64_t GetPts() throw () = 0;
  virtual void SetPts(uint64_t pts) throw () = 0;
  virtual uint32_t GetTimeout() throw () = 0;
  virtual void GetSubtitleSize(uint32_t& width, uint32_t& height)
    throw () = 0;
  virtual void GetClut(TClut& clut) throw () = 0;
  virtual void HandleSubtitleData(TBitStream& payload,
                                  uint64_t pts,
                                  ISubtitlePageQueue* pageQueue) throw () = 0;
};

#endif
