/*
 *---------------------------------------------------------------------------
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef ISUBTITLEPAGEQUEUE_H
#define ISUBTITLEPAGEQUEUE_H

#include "interface/kreatvgfx/IKreaTvGfxPixmap.h"
#include "ISubtitlePage.h"

class ISubtitlePageQueue
{
public:
  virtual ~ISubtitlePageQueue() { /* Empty */ }

  virtual void Clear() throw () = 0;
  virtual void AddPage(ISubtitlePage* page) throw () = 0;

  virtual ISubtitlePage* GetCurrentPage() throw () = 0;
  virtual bool HasNewGraphics() const throw () = 0;
  virtual TKreaTvGfxRectangle GetRegion() throw() = 0;
  virtual void CopyBufferToFullscreenPixmap(const TKreaTvGfxPixmapPointer& pixmap,
                                            TKreaTvGfxRectangle& damageRectangle)
    throw () = 0;
};

#endif
