/*
 *---------------------------------------------------------------------------
 *
 * Copyright (c) 2011 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef TPIXMAPWRAPPER_H
#define TPIXMAPWRAPPER_H

#include "IRegionBuffer.h"
#include "interface/kreatvgfx/KreaTvGfxTypes.h"
#include "interface/kreatvgfx/IKreaTvGfxPixmap.h"

class TPixmapWrapper : public IRegionBuffer
{
private:
  const TKreaTvGfxPixmapPointer& Pixmap;
  TRect Region;

public:
  TPixmapWrapper(const TKreaTvGfxPixmapPointer& pixmap);

  bool SetRegion(const TRect& rect, const uint8_t* const data);

  
  virtual void SetClut(const TClut& clut, TClut::size_type clearIndex);
  virtual const TRect& GetBoundingRect();
};

#endif
