/*
 *-----------------------------------------------------------------------------
 *
 * IApplicationService.h
 *
 * This file was created from IApplicationService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef IAPPLICATIONSERVICE_H
#define IAPPLICATIONSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>



// This block is generated from the InterfaceHeader.tpl template.


class IApplicationService
  : public virtual IToiApplicationService
{
public:
  
  typedef unsigned int TObserverId;
  
  virtual ~IApplicationService() { /* Empty */ }
  virtual void RegisterObserverInternal(const std::string& address, TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserverInternal(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReportInstanceFailure(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void StartInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetEnvironment(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetApplicationPid(const IToiApplicationService::TToiApplicationId& applicationId, int& pid) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterFactoryResetHandler(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void FactoryResetHandlerDone(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException) = 0;
};

// End of the InterfaceHeader.tpl template.

#define IMPLEMENTS_IAPPLICATIONSERVICE \
virtual void RegisterObserverInternal(const std::string& address, TObserverId& observerId) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserverInternal(const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReportInstanceFailure(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException); \
virtual void StartInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TObserverId& observerId) throw (TToiInvalidArgumentException); \
virtual void ReleaseInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TObserverId& observerId) throw (TToiInvalidArgumentException); \
virtual void SetEnvironment(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException); \
virtual void GetApplicationPid(const IToiApplicationService::TToiApplicationId& applicationId, int& pid) throw (TToiInvalidArgumentException); \
virtual void RegisterFactoryResetHandler(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void FactoryResetHandlerDone(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException);

#endif // IAPPLICATIONSERVICE_H

