/*
 *-----------------------------------------------------------------------------
 *
 * IMediaService.h
 *
 * This file was created from IMediaService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef IMEDIASERVICE_H
#define IMEDIASERVICE_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/IToiMediaService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>



// This block is generated from the InterfaceHeader.tpl template.


class IMediaService
  : public virtual IToiMediaService
{
public:
  
  
  virtual ~IMediaService() { /* Empty */ }
  virtual void OpenSessionInternal(const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreateRecorderInstanceInternal(std::string& recorderAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void CreateDistributorInstanceInternal(std::string& distributorAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void RegisterObserverInternal(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreateConsumerInstanceInternal(std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void CreatePlayerInstanceInternal(std::string& playerAddress) throw (TToiNotEnoughResourcesException, TIpcException) = 0;
};

// End of the InterfaceHeader.tpl template.

#define IMPLEMENTS_IMEDIASERVICE \
virtual void OpenSessionInternal(const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException); \
virtual void CreateRecorderInstanceInternal(std::string& recorderAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException); \
virtual void CreateDistributorInstanceInternal(std::string& distributorAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException); \
virtual void RegisterObserverInternal(const std::string& address) throw (TToiInvalidArgumentException); \
virtual void CreateConsumerInstanceInternal(std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void CreatePlayerInstanceInternal(std::string& playerAddress) throw (TToiNotEnoughResourcesException);

#endif // IMEDIASERVICE_H

