/*
 *-----------------------------------------------------------------------------
 *
 * IPlatformService.h
 *
 * This file was created from IPlatformService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef IPLATFORMSERVICE_H
#define IPLATFORMSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/IToiPlatformService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>



// This block is generated from the InterfaceHeader.tpl template.


class IPlatformService
  : public virtual IToiPlatformService
{
public:
  
  enum TStartupType
  {
    STARTUP_TYPE_POWER_ON = 0 ,
    STARTUP_TYPE_REBOOT = 1 ,
    STARTUP_TYPE_WAKE_UP = 2 ,
    STARTUP_TYPE_PLATFORM_FAILURE = 3 ,
    STARTUP_TYPE_PLATFORM_RESTART = 4 
  };
  
  virtual ~IPlatformService() { /* Empty */ }
  virtual void ReportComponent(const int& serviceId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void UnloadDone(const int& serviceId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReportPing(const int& serviceId) throw (TIpcException) = 0;
  virtual void ClearFlash() throw (TIpcException) = 0;
  virtual void IsInStandby(bool& value) throw (TIpcException) = 0;
  virtual void GetStartupType(TStartupType& type) throw (TIpcException) = 0;
  virtual void RestartPlatformNow() throw (TIpcException) = 0;
  virtual void RegisterFactoryResetHandler(const std::string& address, int& handlerId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void UnregisterFactoryResetHandler(const int& handlerId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void FactoryResetHandlerDone(const int& handlerId) throw (TIpcException) = 0;
};

// End of the InterfaceHeader.tpl template.

#define IMPLEMENTS_IPLATFORMSERVICE \
virtual void ReportComponent(const int& serviceId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void UnloadDone(const int& serviceId) throw (TToiInvalidArgumentException); \
virtual void ReportPing(const int& serviceId) throw (); \
virtual void ClearFlash() throw (); \
virtual void IsInStandby(bool& value) throw (); \
virtual void GetStartupType(TStartupType& type) throw (); \
virtual void RestartPlatformNow() throw (); \
virtual void RegisterFactoryResetHandler(const std::string& address, int& handlerId) throw (TToiInvalidArgumentException); \
virtual void UnregisterFactoryResetHandler(const int& handlerId) throw (TToiInvalidArgumentException); \
virtual void FactoryResetHandlerDone(const int& handlerId) throw ();

#endif // IPLATFORMSERVICE_H

