/*
 *-----------------------------------------------------------------------------
 *
 * IToiAssetManagerObserver.h
 *
 * This file was created from .idlcpp/IToiAssetManagerObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIASSETMANAGEROBSERVER_H
#define ITOIASSETMANAGEROBSERVER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/IToiAssetManagerService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiAssetManagerObserver
{
public:
  
  
  virtual ~IToiAssetManagerObserver() { /* Empty */ }
  virtual void OnAssetsAdded(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (TIpcException) = 0;
  virtual void OnAssetsRemoved(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (TIpcException) = 0;
  virtual void OnAssetsChanged(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (TIpcException) = 0;
  virtual void OnDirectoriesAdded(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw (TIpcException) = 0;
  virtual void OnDirectoriesRemoved(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw (TIpcException) = 0;
  virtual void OnDirectoriesChanged(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIASSETMANAGEROBSERVER \
virtual void OnAssetsAdded(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (); \
virtual void OnAssetsRemoved(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (); \
virtual void OnAssetsChanged(const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (); \
virtual void OnDirectoriesAdded(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw (); \
virtual void OnDirectoriesRemoved(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw (); \
virtual void OnDirectoriesChanged(const IToiAssetManagerService::TToiDirectoryIdSequence& dirIds) throw ();

#endif 

