/*
 *-----------------------------------------------------------------------------
 *
 * IToiAssetManagerService.h
 *
 * This file was created from .idlcpp/IToiAssetManagerService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIASSETMANAGERSERVICE_H
#define ITOIASSETMANAGERSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiNoDataException.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>





#define PROPERTY_SYSTEM_DURATION "system.duration"
#define PROPERTY_SYSTEM_FILESIZE "system.filesize"
#define PROPERTY_SYSTEM_PLAYBACKURI "system.playbackuri"
#define PROPERTY_SYSTEM_FILENAME "system.filename"
#define PROPERTY_SYSTEM_TYPE "system.type"
#define PROPERTY_SYSTEM_INTEGRITY_STATUS "system.integritystatus"
#define PROPERTY_INFO_TITLE "info.title"
#define PROPERTY_INFO_DATE "info.date"
#define PROPERTY_INFO_DESCRIPTION "info.description"
#define PROPERTY_INFO_LONGDESCRIPTION "info.longdescription"
#define PROPERTY_INFO_CHANNELNAME "info.channelname"
#define PROPERTY_INFO_RECORDINGSTATUS "info.recordingstatus"
#define PROPERTY_INFO_MATURITYRATING "info.maturityrating"
#define PROPERTY_INFO_SHARED "info.shared"
#define PROPERTY_INFO_COVER "info.cover"
#define PROPERTY_INFO_CHILDREN "info.children"
#define PROPERTY_INFO_LOST_AND_FOUND "info.lostandfound"

class IToiAssetManagerService
{
public:
  enum { OP_RESULT_ASSET_INFO = 1 };
  enum { OP_RESULT_LONG = 2 };
  enum { ROOT_DIRECTORY = -1 };
  struct TToiPropertyDefinition;
  struct TToiProperty;
  struct TToiAssetInfo;
  struct TToiDirectoryInfo;
  struct TToiSortCondition;
  struct TToiQueryCondition;
  
  enum TToiConditionOperation
  {
    EQUALS = 0,
    NOT_EQUAL = 1,
    GREATER = 2,
    LESS = 3,
    GREATER_OR_EQUAL = 4,
    LESS_OR_EQUAL = 5,
    CONTAINS = 6
  };
  enum TToiPropertyType
  {
    TYPE_BOOLEAN = 0,
    TYPE_STRING = 1,
    TYPE_INTEGER = 2,
    TYPE_DATE = 3,
    TYPE_ASSETLINK = 4
  };
  enum TToiAssetType
  {
    ASSET_PVR = 0,
    ASSET_IMAGE = 1,
    ASSET_AUDIO = 2,
    ASSET_VIDEO = 3
  };
  enum TToiAssetIntegrityStatus
  {
    INTEGRITY_UNKNOWN = 0,
    INTEGRITY_OK = 1,
    INTEGRITY_COULD_NOT_UPGRADE = 2,
    INTEGRITY_COULD_NOT_REPAIR = 3
  };
  enum TToiImportPolicy
  {
    IMPORT_POLICY_COPY = 0,
    IMPORT_POLICY_MOVE = 1
  };
  typedef int TToiQueryId;
  typedef std::string TToiAssetId;
  typedef std::vector< TToiAssetId > TToiAssetIdSequence;
  typedef std::string TToiPropertyId;
  typedef std::vector< TToiPropertyId > TToiPropertyIdSequence;
  typedef std::vector< std::string > TToiPropertyValueSequence;
  typedef std::vector< TToiProperty > TToiPropertySequence;
  typedef std::vector< TToiAssetInfo > TToiAssetInfoSequence;
  typedef int TToiDirectoryId;
  typedef std::vector< TToiDirectoryId > TToiDirectoryIdSequence;
  typedef std::vector< TToiSortCondition > TToiSortConditionSequence;
  typedef std::vector< TToiQueryCondition > TToiQueryConditionSequence;
  
  struct TToiPropertyDefinition {
    TToiPropertyId PropertyId;
    TToiPropertyType Type;
    bool HasMultipleValueSupport;
    bool IsSystemDefined;
    
    TToiPropertyDefinition() :
      PropertyId(""), 
      Type(TYPE_BOOLEAN), 
      HasMultipleValueSupport(false), 
      IsSystemDefined(false)  {   }
    
    TToiPropertyDefinition(
      const TToiPropertyId& _PropertyId, 
      const TToiPropertyType& _Type, 
      const bool& _HasMultipleValueSupport, 
      const bool& _IsSystemDefined) :
        PropertyId(_PropertyId), 
        Type(_Type), 
        HasMultipleValueSupport(_HasMultipleValueSupport), 
        IsSystemDefined(_IsSystemDefined)
    {
    }
    
  };
  
  struct TToiProperty {
    TToiPropertyId Id;
    std::string Value;
    
    TToiProperty() :
      Id(""), 
      Value("")  {   }
    
    TToiProperty(
      const TToiPropertyId& _Id, 
      const std::string& _Value) :
        Id(_Id), 
        Value(_Value)
    {
    }
    
  };
  
  struct TToiAssetInfo {
    TToiAssetId AssetId;
    TToiPropertySequence Properties;
    
    TToiAssetInfo() :
      AssetId("")  {   }
    
    TToiAssetInfo(
      const TToiAssetId& _AssetId, 
      const TToiPropertySequence& _Properties) :
        AssetId(_AssetId), 
        Properties(_Properties)
    {
    }
    
  };
  
  struct TToiDirectoryInfo {
    TToiDirectoryId DirectoryId;
    TToiDirectoryId ParentDirectoryId;
    TToiPropertySequence Properties;
    
    TToiDirectoryInfo() :
      DirectoryId(0), 
      ParentDirectoryId(0)  {   }
    
    TToiDirectoryInfo(
      const TToiDirectoryId& _DirectoryId, 
      const TToiDirectoryId& _ParentDirectoryId, 
      const TToiPropertySequence& _Properties) :
        DirectoryId(_DirectoryId), 
        ParentDirectoryId(_ParentDirectoryId), 
        Properties(_Properties)
    {
    }
    
  };
  
  struct TToiSortCondition {
    TToiPropertyId SortProperty;
    bool SortAscending;
    
    TToiSortCondition() :
      SortProperty(""), 
      SortAscending(false)  {   }
    
    TToiSortCondition(
      const TToiPropertyId& _SortProperty, 
      const bool& _SortAscending) :
        SortProperty(_SortProperty), 
        SortAscending(_SortAscending)
    {
    }
    
  };
  
  struct TToiQueryCondition {
    TToiPropertyId PropertyId;
    TToiConditionOperation Operation;
    std::string Value;
    
    TToiQueryCondition() :
      PropertyId(""), 
      Operation(EQUALS), 
      Value("")  {   }
    
    TToiQueryCondition(
      const TToiPropertyId& _PropertyId, 
      const TToiConditionOperation& _Operation, 
      const std::string& _Value) :
        PropertyId(_PropertyId), 
        Operation(_Operation), 
        Value(_Value)
    {
    }
    
  };
  
  virtual ~IToiAssetManagerService() { /* Empty */ }
  virtual void GetAssetOperationManager(std::string& address) throw (TIpcException) = 0;
  virtual void CreateDirectory(const TToiDirectoryId& parentId, const std::string& title, TToiDirectoryId& dirId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void MoveDirectory(const TToiDirectoryId& dirId, const TToiDirectoryId& newParentId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetDirectoryProperties(const TToiDirectoryId& dirId, const TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RemoveDirectoryProperties(const TToiDirectoryId& dirId, const TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RemoveDirectory(const TToiDirectoryId& dirId, const bool& recursiveFlag, const bool& removeAssetsFlag) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void GetDirectoryInfo(const TToiDirectoryId& dirId, TToiDirectoryInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetDirectories(const TToiDirectoryId& dirId, TToiDirectoryIdSequence& childDirIds) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetDefinedProperties(TToiPropertyIdSequence& properties) throw (TIpcException) = 0;
  virtual void GetPropertyDefinition(const TToiPropertyId& propertyId, TToiPropertyDefinition& definition) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreatePropertyDefinition(const TToiPropertyId& propertyId, const TToiPropertyType& type, const bool& hasMultipleValueSupport) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RemovePropertyDefinition(const TToiPropertyId& propertyId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreateAsset(const TToiAssetType& assetType, TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void ImportAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& assetId, const std::string& uri, const TToiImportPolicy& importPolicy) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void RemoveAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNoDataException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void CopyAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& sourceAssetId, const unsigned int& startOffset, const unsigned int& duration, const TToiAssetId& destinationAssetId) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void LinkAssets(const TToiDirectoryId& dirId, const TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void UnlinkAssets(const TToiDirectoryId& dirId, const TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RunQuery(const IToiOperationManager::TToiOperationId& operationId, const TToiQueryConditionSequence& queryConditions, const TToiPropertyIdSequence& requestedProperties, const TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void RunQueryForDirectory(const IToiOperationManager::TToiOperationId& operationId, const TToiDirectoryId& directoryId, const TToiQueryConditionSequence& queryConditions, const TToiPropertyIdSequence& requestedProperties, const TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void RunCountQuery(const IToiOperationManager::TToiOperationId& operationId, const TToiQueryConditionSequence& queryConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void GetAssetInfoResult(const IToiOperationManager::TToiOperationId& operationId, const unsigned int& maxCount, TToiAssetInfoSequence& objects, bool& hasMore) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void GetLongResult(const IToiOperationManager::TToiOperationId& operationId, unsigned int& value) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void GetProperties(const TToiAssetId& assetId, const TToiPropertyIdSequence& requestedProperties, TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void GetAllProperties(const TToiAssetId& assetId, TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void SetProperties(const TToiAssetId& id, const TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void RemoveProperties(const TToiAssetId& id, const TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void RemoveMultiValuedPropertyValue(const TToiAssetId& id, const TToiProperty& property) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIASSETMANAGERSERVICE \
virtual void GetAssetOperationManager(std::string& address) throw (); \
virtual void CreateDirectory(const TToiDirectoryId& parentId, const std::string& title, TToiDirectoryId& dirId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void MoveDirectory(const TToiDirectoryId& dirId, const TToiDirectoryId& newParentId) throw (TToiInvalidArgumentException); \
virtual void SetDirectoryProperties(const TToiDirectoryId& dirId, const TToiPropertySequence& properties) throw (TToiInvalidArgumentException); \
virtual void RemoveDirectoryProperties(const TToiDirectoryId& dirId, const TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException); \
virtual void RemoveDirectory(const TToiDirectoryId& dirId, const bool& recursiveFlag, const bool& removeAssetsFlag) throw (TToiInvalidArgumentException, TToiPermissionDeniedException); \
virtual void GetDirectoryInfo(const TToiDirectoryId& dirId, TToiDirectoryInfo& info) throw (TToiInvalidArgumentException); \
virtual void GetDirectories(const TToiDirectoryId& dirId, TToiDirectoryIdSequence& childDirIds) throw (TToiInvalidArgumentException); \
virtual void GetDefinedProperties(TToiPropertyIdSequence& properties) throw (); \
virtual void GetPropertyDefinition(const TToiPropertyId& propertyId, TToiPropertyDefinition& definition) throw (TToiInvalidArgumentException); \
virtual void CreatePropertyDefinition(const TToiPropertyId& propertyId, const TToiPropertyType& type, const bool& hasMultipleValueSupport) throw (TToiInvalidArgumentException); \
virtual void RemovePropertyDefinition(const TToiPropertyId& propertyId) throw (TToiInvalidArgumentException); \
virtual void CreateAsset(const TToiAssetType& assetType, TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void ImportAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& assetId, const std::string& uri, const TToiImportPolicy& importPolicy) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void RemoveAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNoDataException, TToiPermissionDeniedException); \
virtual void CopyAsset(const IToiOperationManager::TToiOperationId& operationId, const TToiAssetId& sourceAssetId, const unsigned int& startOffset, const unsigned int& duration, const TToiAssetId& destinationAssetId) throw (TToiInvalidArgumentException, TToiPermissionDeniedException); \
virtual void LinkAssets(const TToiDirectoryId& dirId, const TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException); \
virtual void UnlinkAssets(const TToiDirectoryId& dirId, const TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException); \
virtual void RunQuery(const IToiOperationManager::TToiOperationId& operationId, const TToiQueryConditionSequence& queryConditions, const TToiPropertyIdSequence& requestedProperties, const TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void RunQueryForDirectory(const IToiOperationManager::TToiOperationId& operationId, const TToiDirectoryId& directoryId, const TToiQueryConditionSequence& queryConditions, const TToiPropertyIdSequence& requestedProperties, const TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void RunCountQuery(const IToiOperationManager::TToiOperationId& operationId, const TToiQueryConditionSequence& queryConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void GetAssetInfoResult(const IToiOperationManager::TToiOperationId& operationId, const unsigned int& maxCount, TToiAssetInfoSequence& objects, bool& hasMore) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void GetLongResult(const IToiOperationManager::TToiOperationId& operationId, unsigned int& value) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void GetProperties(const TToiAssetId& assetId, const TToiPropertyIdSequence& requestedProperties, TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException); \
virtual void GetAllProperties(const TToiAssetId& assetId, TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException); \
virtual void SetProperties(const TToiAssetId& id, const TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException); \
virtual void RemoveProperties(const TToiAssetId& id, const TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException); \
virtual void RemoveMultiValuedPropertyValue(const TToiAssetId& id, const TToiProperty& property) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

