/*
 *-----------------------------------------------------------------------------
 *
 * IToiAudioOutputConfigurationSession.h
 *
 * This file was created from .idlcpp/IToiAudioOutputConfigurationSession.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIAUDIOOUTPUTCONFIGURATIONSESSION_H
#define ITOIAUDIOOUTPUTCONFIGURATIONSESSION_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiAudioOutputService.h"
#include "interface/IToiAudioOutputConfiguration.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiAudioOutputConfigurationSession
  : public virtual IToiAudioOutputConfiguration
{
public:
  
  
  virtual ~IToiAudioOutputConfigurationSession() { /* Empty */ }
  virtual void ResetFormatMapping(const IToiAudioOutputConfiguration::TToiAudioFormat& inputFormat) throw (TIpcException) = 0;
  virtual void SetFormatMapping(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, const IToiAudioOutputConfiguration::TToiAudioFormat& inputFormat, const IToiAudioOutputConfiguration::TToiAudioFormatOption& outputFormatOption) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void Apply() throw (TIpcException) = 0;
  virtual void Revert() throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIAUDIOOUTPUTCONFIGURATIONSESSION \
virtual void ResetFormatMapping(const IToiAudioOutputConfiguration::TToiAudioFormat& inputFormat) throw (); \
virtual void SetFormatMapping(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, const IToiAudioOutputConfiguration::TToiAudioFormat& inputFormat, const IToiAudioOutputConfiguration::TToiAudioFormatOption& outputFormatOption) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void Apply() throw (); \
virtual void Revert() throw ();

#endif 

