/*
 *-----------------------------------------------------------------------------
 *
 * IToiAudioOutputObserver.h
 *
 * This file was created from .idlcpp/IToiAudioOutputObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIAUDIOOUTPUTOBSERVER_H
#define ITOIAUDIOOUTPUTOBSERVER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiAudioOutputService.h"
#include "interface/IToiAudioOutputConfiguration.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiAudioOutputObserver
{
public:
  
  
  virtual ~IToiAudioOutputObserver() { /* Empty */ }
  virtual void OnConfigurationChanged() throw (TIpcException) = 0;
  virtual void OnVolumeChanged(const unsigned int& connectionId, const unsigned int& level) throw (TIpcException) = 0;
  virtual void OnMuteStateChanged(const unsigned int& connectionId, const bool& state) throw (TIpcException) = 0;
  virtual void OnHdmiConnectionStatusChanged(const unsigned int& connectionId, const IToiAudioOutputConfiguration::TToiHdmiSinkInfo& sinkInfo) throw (TIpcException) = 0;
  virtual void OnLatencyChanged(const unsigned int& connectionId, const int& latency) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIAUDIOOUTPUTOBSERVER \
virtual void OnConfigurationChanged() throw (); \
virtual void OnVolumeChanged(const unsigned int& connectionId, const unsigned int& level) throw (); \
virtual void OnMuteStateChanged(const unsigned int& connectionId, const bool& state) throw (); \
virtual void OnHdmiConnectionStatusChanged(const unsigned int& connectionId, const IToiAudioOutputConfiguration::TToiHdmiSinkInfo& sinkInfo) throw (); \
virtual void OnLatencyChanged(const unsigned int& connectionId, const int& latency) throw ();

#endif 

