/*
 *-----------------------------------------------------------------------------
 *
 * IToiAudioOutputService.h
 *
 * This file was created from .idlcpp/IToiAudioOutputService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIAUDIOOUTPUTSERVICE_H
#define ITOIAUDIOOUTPUTSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiAudioOutputService
{
public:
  struct TToiAudioConnectionDescriptor;
  
  enum TToiAudioConnectionType
  {
    AUDIO_CONNECTION_TYPE_ANALOG = 0,
    AUDIO_CONNECTION_TYPE_SPDIF = 1,
    AUDIO_CONNECTION_TYPE_HDMI = 2,
    AUDIO_CONNECTION_TYPE_DECODER = 3,
    AUDIO_CONNECTION_TYPE_BUFFER = 4,
    AUDIO_CONNECTION_TYPE_I2S = 5
  };
  enum TToiAudioConnectionDirection
  {
    AUDIO_CONNECTION_DIRECTION_INPUT = 0,
    AUDIO_CONNECTION_DIRECTION_OUTPUT = 1
  };
  typedef int TToiAudioConnectionId;
  typedef std::vector< TToiAudioConnectionDescriptor > TToiAudioConnectionDescriptorSequence;
  
  struct TToiAudioConnectionDescriptor {
    TToiAudioConnectionId Id;
    TToiAudioConnectionType Type;
    TToiAudioConnectionDirection Direction;
    unsigned int Index;
    bool IsMutable;
    bool IsAdjustable;
    bool IsLatencyAdjustable;
    
    TToiAudioConnectionDescriptor() :
      Id(0), 
      Type(AUDIO_CONNECTION_TYPE_ANALOG), 
      Direction(AUDIO_CONNECTION_DIRECTION_INPUT), 
      Index(0), 
      IsMutable(false), 
      IsAdjustable(false), 
      IsLatencyAdjustable(false)  {   }
    
    TToiAudioConnectionDescriptor(
      const TToiAudioConnectionId& _Id, 
      const TToiAudioConnectionType& _Type, 
      const TToiAudioConnectionDirection& _Direction, 
      const unsigned int& _Index, 
      const bool& _IsMutable, 
      const bool& _IsAdjustable, 
      const bool& _IsLatencyAdjustable) :
        Id(_Id), 
        Type(_Type), 
        Direction(_Direction), 
        Index(_Index), 
        IsMutable(_IsMutable), 
        IsAdjustable(_IsAdjustable), 
        IsLatencyAdjustable(_IsLatencyAdjustable)
    {
    }
    
  };
  
  virtual ~IToiAudioOutputService() { /* Empty */ }
  virtual void GetConnections(TToiAudioConnectionDescriptorSequence& connectionList) throw (TIpcException) = 0;
  virtual void GetConfiguration(std::string& address) throw (TIpcException) = 0;
  virtual void CreateConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void SetVolume(const TToiAudioConnectionId& connectionId, const unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetVolume(const TToiAudioConnectionId& connectionId, unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void SetMuteState(const TToiAudioConnectionId& connectionId, const bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetMuteState(const TToiAudioConnectionId& connectionId, bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void SetLatency(const TToiAudioConnectionId& connectionId, const int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetLatency(const TToiAudioConnectionId& connectionId, int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIAUDIOOUTPUTSERVICE \
virtual void GetConnections(TToiAudioConnectionDescriptorSequence& connectionList) throw (); \
virtual void GetConfiguration(std::string& address) throw (); \
virtual void CreateConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void SetVolume(const TToiAudioConnectionId& connectionId, const unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetVolume(const TToiAudioConnectionId& connectionId, unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void SetMuteState(const TToiAudioConnectionId& connectionId, const bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetMuteState(const TToiAudioConnectionId& connectionId, bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void SetLatency(const TToiAudioConnectionId& connectionId, const int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetLatency(const TToiAudioConnectionId& connectionId, int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

