/*
 *-----------------------------------------------------------------------------
 *
 * IToiDiagnosticsDataModel.h
 *
 * This file was created from .idlcpp/IToiDiagnosticsDataModel.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDIAGNOSTICSDATAMODEL_H
#define ITOIDIAGNOSTICSDATAMODEL_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDiagnosticsDataModel
{
public:
  struct TToiObjectParameter;
  struct TToiObjectInfo;
  
  typedef std::string TToiObjectIdentifier;
  typedef std::vector< TToiObjectParameter > TToiObjectParameterSequence;
  typedef std::vector< TToiObjectIdentifier > TToiObjectIdentifierSequence;
  typedef std::vector< TToiObjectInfo > TToiObjectInfoSequence;
  
  struct TToiObjectParameter {
    std::string Name;
    std::string Value;
    
    TToiObjectParameter() :
      Name(""), 
      Value("")  {   }
    
    TToiObjectParameter(
      const std::string& _Name, 
      const std::string& _Value) :
        Name(_Name), 
        Value(_Value)
    {
    }
    
  };
  
  struct TToiObjectInfo {
    TToiObjectIdentifier ObjectId;
    TToiObjectParameterSequence Parameters;
    TToiObjectIdentifierSequence Children;
    
    TToiObjectInfo() :
      ObjectId("")  {   }
    
    TToiObjectInfo(
      const TToiObjectIdentifier& _ObjectId, 
      const TToiObjectParameterSequence& _Parameters, 
      const TToiObjectIdentifierSequence& _Children) :
        ObjectId(_ObjectId), 
        Parameters(_Parameters), 
        Children(_Children)
    {
    }
    
  };
  
  virtual ~IToiDiagnosticsDataModel() { /* Empty */ }
  virtual void GetObject(const TToiObjectIdentifier& objectId, TToiObjectInfo& infoObject) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetObject(const TToiObjectInfo& infoObject) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void SubscribeObject(const std::string& address, const TToiObjectIdentifier& objectId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void UnsubscribeObject(const std::string& address, const TToiObjectIdentifier& objectId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDIAGNOSTICSDATAMODEL \
virtual void GetObject(const TToiObjectIdentifier& objectId, TToiObjectInfo& infoObject) throw (TToiInvalidArgumentException); \
virtual void SetObject(const TToiObjectInfo& infoObject) throw (TToiInvalidArgumentException, TToiPermissionDeniedException); \
virtual void SubscribeObject(const std::string& address, const TToiObjectIdentifier& objectId) throw (TToiInvalidArgumentException); \
virtual void UnsubscribeObject(const std::string& address, const TToiObjectIdentifier& objectId) throw (TToiInvalidArgumentException); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

