/*
 *-----------------------------------------------------------------------------
 *
 * IToiDlnaContentDirectoryService.h
 *
 * This file was created from .idlcpp/IToiDlnaContentDirectoryService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDLNACONTENTDIRECTORYSERVICE_H
#define ITOIDLNACONTENTDIRECTORYSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDlnaContentDirectoryService
{
public:
  enum { OP_RESULT_OBJECT = 1 };
  enum { OP_RESULT_CAPABILITY = 2 };
  enum { OP_ERROR_INVALID_ARGUMENTS = -3 };
  enum { OP_ERROR_INVALID_ACTION = -4 };
  enum { OP_ERROR_UNSUPPORTED_SEARCH_CRITERIA = -5 };
  enum { OP_ERROR_UNSUPPORTED_SORT_CRITERIA = -6 };
  enum { OP_ERROR_NO_SUCH_CONTAINER = -7 };
  enum { OP_ERROR_RESTRICTED = -8 };
  enum { OP_ERROR_CAN_NOT_PROCESS_REQUEST = -9 };
  enum { PROPERTY_OBJECT_ATTR_CHILD_COUNT = 11 };
  enum { PROPERTY_OBJECT_ATTR_SEARCHABLE = 12 };
  enum { PROPERTY_OBJECT_ATTR_REF_ID = 13 };
  enum { PROPERTY_OBJECT_ATTR_RESTRICTED = 14 };
  enum { PROPERTY_CREATE_CLASS = 20 };
  enum { PROPERTY_CREATE_CLASS_ATTR_INCLUDE_DERIVED = 21 };
  enum { PROPERTY_CREATE_CLASS_ATTR_NAME = 22 };
  enum { PROPERTY_CREATOR = 30 };
  enum { PROPERTY_DATE = 40 };
  enum { PROPERTY_DESCRIPTION = 50 };
  enum { PROPERTY_LANGUAGE = 60 };
  enum { PROPERTY_RES = 70 };
  enum { PROPERTY_RES_ATTR_BITRATE = 71 };
  enum { PROPERTY_RES_ATTR_BITS_PER_SAMPLE = 72 };
  enum { PROPERTY_RES_ATTR_COLOR_DEPTH = 73 };
  enum { PROPERTY_RES_ATTR_DURATION = 74 };
  enum { PROPERTY_RES_ATTR_IMPORT_URI = 75 };
  enum { PROPERTY_RES_ATTR_AUDIO_CHANNELS_COUNT = 76 };
  enum { PROPERTY_RES_ATTR_PROTOCOL_INFO = 77 };
  enum { PROPERTY_RES_ATTR_RESOLUTION = 78 };
  enum { PROPERTY_RES_ATTR_SAMPLE_FREQUENCY = 79 };
  enum { PROPERTY_RES_ATTR_SIZE = 80 };
  enum { PROPERTY_RES_ATTR_PROTECTION = 81 };
  enum { PROPERTY_RES_RENDER_SUPPORTED = 82 };
  enum { PROPERTY_SEARCH_CLASS = 90 };
  enum { PROPERTY_SEARCH_CLASS_ATTR_INCLUDE_DERIVED = 91 };
  enum { PROPERTY_SEARCH_CLASS_ATTR_NAME = 92 };
  enum { PROPERTY_ACTOR = 100 };
  enum { PROPERTY_ALBUM = 110 };
  enum { PROPERTY_ARTIST = 120 };
  enum { PROPERTY_AUTHOR = 130 };
  enum { PROPERTY_PRODUCER = 140 };
  enum { PROPERTY_DIRECTOR = 150 };
  enum { PROPERTY_PUBLISHER = 160 };
  enum { PROPERTY_CONTRIBUTOR = 170 };
  enum { PROPERTY_GENRE = 180 };
  enum { PROPERTY_ICON = 190 };
  enum { PROPERTY_ORIGINAL_TRACK_NUMBER = 200 };
  enum { PROPERTY_PLAYLIST = 210 };
  enum { PROPERTY_RATING = 220 };
  enum { PROPERTY_SCHEDULED_START_TIME = 230 };
  enum { PROPERTY_SCHEDULED_END_TIME = 240 };
  enum { PROPERTY_CHANNEL_NAME = 250 };
  enum { PROPERTY_CHANNEL_NR = 260 };
  enum { PROPERTY_STORAGE_FREE = 270 };
  enum { PROPERTY_STORAGE_MAX_PARTITION = 280 };
  enum { PROPERTY_STORAGE_MEDIUM = 290 };
  enum { PROPERTY_STORAGE_TOTAL = 300 };
  enum { PROPERTY_STORAGE_USED = 310 };
  enum { PROPERTY_WRITE_STATUS = 320 };
  enum { PROPERTY_REGION = 330 };
  enum { PROPERTY_LONG_DESCRIPTION = 340 };
  enum { PROPERTY_RADIO_CALL_SIGN = 350 };
  enum { PROPERTY_RADIO_STATION_ID = 360 };
  enum { PROPERTY_RADIO_BAND = 370 };
  enum { PROPERTY_USER_ANNOTATION = 380 };
  enum { PROPERTY_CLASS = 390 };
  enum { PROPERTY_TITLE = 400 };
  enum { PROPERTY_RES_PI_PROTOCOL = 410 };
  enum { PROPERTY_RES_PI_MIME_TYPE = 411 };
  enum { PROPERTY_RES_PI_PROFILE_NAME = 412 };
  enum { PROPERTY_RES_PI_OPERATIONS = 413 };
  enum { PROPERTY_RES_PI_PLAY_SPEED = 414 };
  enum { PROPERTY_RES_PI_CONVERSION_INDICATOR = 415 };
  enum { PROPERTY_RES_PI_FLAGS = 416 };
  enum { PROPERTY_RES_PI_MAX_RTSP_SPEED = 417 };
  struct TToiProperty;
  struct TToiCdsObject;
  struct TToiCdsCapabilities;
  
  enum TToiPropertyType
  {
    TYPE_STRING = 0,
    TYPE_INTEGER = 1,
    TYPE_BOOLEAN = 2,
    TYPE_DATE = 3,
    TYPE_RESOLUTION = 4,
    TYPE_DURATION = 5
  };
  enum TToiCdsActionCapability
  {
    CDS_CAPABILITY_CREATE_OBJECT = 0x1,
    CDS_CAPABILITY_DESTROY_OBJECT = 0x2,
    CDS_CAPABILITY_SEARCH = 0x4,
    CDS_CAPABILITY_IMPORT_RESOURCE = 0x8,
    CDS_CAPABILITY_EXPORT_RESOURCE = 0x10,
    CDS_CAPABILITY_STOP_TRANSFER_PROGRESS = 0x20,
    CDS_CAPABILITY_GET_TRANSFER_PROGRESS = 0x40,
    CDS_CAPABILITY_IMAGE_UPLOAD = 0x80,
    CDS_CAPABILITY_AUDIO_UPLOAD = 0x100,
    CDS_CAPABILITY_AV_UPLOAD = 0x200,
    CDS_CAPABILITY_X_GET_DLNA_UPLOAD_PROFILES = 0x400
  };
  typedef int TToiPropertyId;
  typedef std::vector< TToiPropertyId > TToiPropertyIdSequence;
  typedef std::vector< TToiProperty > TToiPropertySequence;
  typedef std::vector< int > TToiSortIdSequence;
  typedef std::vector< TToiCdsObject > TToiCdsObjectSequence;
  
  struct TToiProperty {
    TToiPropertyId Id;
    int SubIndex;
    std::string Value;
    
    TToiProperty() :
      Id(0), 
      SubIndex(0), 
      Value("")  {   }
    
    TToiProperty(
      const TToiPropertyId& _Id, 
      const int& _SubIndex, 
      const std::string& _Value) :
        Id(_Id), 
        SubIndex(_SubIndex), 
        Value(_Value)
    {
    }
    
  };
  
  struct TToiCdsObject {
    std::string ObjectId;
    std::string ParentId;
    std::string ObjectClass;
    std::string Title;
    int ServerIndex;
    TToiPropertySequence Properties;
    
    TToiCdsObject() :
      ObjectId(""), 
      ParentId(""), 
      ObjectClass(""), 
      Title(""), 
      ServerIndex(0)  {   }
    
    TToiCdsObject(
      const std::string& _ObjectId, 
      const std::string& _ParentId, 
      const std::string& _ObjectClass, 
      const std::string& _Title, 
      const int& _ServerIndex, 
      const TToiPropertySequence& _Properties) :
        ObjectId(_ObjectId), 
        ParentId(_ParentId), 
        ObjectClass(_ObjectClass), 
        Title(_Title), 
        ServerIndex(_ServerIndex), 
        Properties(_Properties)
    {
    }
    
  };
  
  struct TToiCdsCapabilities {
    TToiPropertyIdSequence SearchingCapabilities;
    TToiPropertyIdSequence SortingCapabilities;
    int ActionCapabilities;
    
    TToiCdsCapabilities() :
      ActionCapabilities(0)  {   }
    
    TToiCdsCapabilities(
      const TToiPropertyIdSequence& _SearchingCapabilities, 
      const TToiPropertyIdSequence& _SortingCapabilities, 
      const int& _ActionCapabilities) :
        SearchingCapabilities(_SearchingCapabilities), 
        SortingCapabilities(_SortingCapabilities), 
        ActionCapabilities(_ActionCapabilities)
    {
    }
    
  };
  
  virtual ~IToiDlnaContentDirectoryService() { /* Empty */ }
  virtual void GetRootContainerId(std::string& objectId) throw (TIpcException) = 0;
  virtual void GetCapabilities(const IToiOperationManager::TToiOperationId& operationId) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void Browse(const IToiOperationManager::TToiOperationId& operationId, const std::string& containerId, const TToiPropertyIdSequence& propertyFilter, const TToiSortIdSequence& sortCriteria, const int& startIndex, const int& count) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetObjectById(const IToiOperationManager::TToiOperationId& operationId, const std::string& objectId, const TToiPropertyIdSequence& propertyFilter) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void Search(const IToiOperationManager::TToiOperationId& operationId, const std::string& containerId, const std::string& searchCriteria, const TToiPropertyIdSequence& propertyFilter, const TToiSortIdSequence& sortCriteria, const int& startIndex, const int& count) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetPropertyInfoById(const TToiPropertyId& id, std::string& name, TToiPropertyType& type) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetPropertyIdByName(const std::string& name, TToiPropertyId& id) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetOperationObjectResult(const IToiOperationManager::TToiOperationId& operationId, const int& maxCount, TToiCdsObjectSequence& objects, bool& hasMore) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void GetOperationCapabilityResult(const IToiOperationManager::TToiOperationId& operationId, TToiCdsCapabilities& capabilities) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void GetCdsOperationManager(std::string& address) throw (TIpcException) = 0;
  virtual void GetServerUuid(std::string& uuid) throw (TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDLNACONTENTDIRECTORYSERVICE \
virtual void GetRootContainerId(std::string& objectId) throw (); \
virtual void GetCapabilities(const IToiOperationManager::TToiOperationId& operationId) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void Browse(const IToiOperationManager::TToiOperationId& operationId, const std::string& containerId, const TToiPropertyIdSequence& propertyFilter, const TToiSortIdSequence& sortCriteria, const int& startIndex, const int& count) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetObjectById(const IToiOperationManager::TToiOperationId& operationId, const std::string& objectId, const TToiPropertyIdSequence& propertyFilter) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void Search(const IToiOperationManager::TToiOperationId& operationId, const std::string& containerId, const std::string& searchCriteria, const TToiPropertyIdSequence& propertyFilter, const TToiSortIdSequence& sortCriteria, const int& startIndex, const int& count) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetPropertyInfoById(const TToiPropertyId& id, std::string& name, TToiPropertyType& type) throw (TToiInvalidArgumentException); \
virtual void GetPropertyIdByName(const std::string& name, TToiPropertyId& id) throw (TToiInvalidArgumentException); \
virtual void GetOperationObjectResult(const IToiOperationManager::TToiOperationId& operationId, const int& maxCount, TToiCdsObjectSequence& objects, bool& hasMore) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void GetOperationCapabilityResult(const IToiOperationManager::TToiOperationId& operationId, TToiCdsCapabilities& capabilities) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void GetCdsOperationManager(std::string& address) throw (); \
virtual void GetServerUuid(std::string& uuid) throw (); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

