/*
 *-----------------------------------------------------------------------------
 *
 * IToiDlnaRendererManager.h
 *
 * This file was created from .idlcpp/IToiDlnaRendererManager.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDLNARENDERERMANAGER_H
#define ITOIDLNARENDERERMANAGER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiDlnaContentDirectoryService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDlnaRendererManager
{
public:
  struct TToiRendererSessionInfo;
  
  enum TToiRendererState
  {
    STATE_SESSION_REQUEST = 0,
    STATE_SESSION_ACTIVE = 1,
    STATE_SESSION_CLOSED = 2
  };
  enum TToiRendererStatus
  {
    RENDERER_SUCCESS = 0,
    RENDERER_UNAVAILABLE = 1,
    RENDERER_FAILURE = 2
  };
  typedef int TToiRendererSessionId;
  typedef std::vector< TToiRendererSessionId > TToiRendererSessionIdSequence;
  
  struct TToiRendererSessionInfo {
    TToiRendererSessionId Id;
    TToiRendererState State;
    std::string Uri;
    std::string MimeType;
    IToiDlnaContentDirectoryService::TToiPropertySequence MediaProperties;
    
    TToiRendererSessionInfo() :
      Id(0), 
      State(STATE_SESSION_REQUEST), 
      Uri(""), 
      MimeType("")  {   }
    
    TToiRendererSessionInfo(
      const TToiRendererSessionId& _Id, 
      const TToiRendererState& _State, 
      const std::string& _Uri, 
      const std::string& _MimeType, 
      const IToiDlnaContentDirectoryService::TToiPropertySequence& _MediaProperties) :
        Id(_Id), 
        State(_State), 
        Uri(_Uri), 
        MimeType(_MimeType), 
        MediaProperties(_MediaProperties)
    {
    }
    
  };
  
  virtual ~IToiDlnaRendererManager() { /* Empty */ }
  virtual void UpdateSessionStatus(const TToiRendererSessionId& id, const TToiRendererStatus& status) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetSessionInfo(const TToiRendererSessionId& id, TToiRendererSessionInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetRendererSessions(TToiRendererSessionIdSequence& ids) throw (TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDLNARENDERERMANAGER \
virtual void UpdateSessionStatus(const TToiRendererSessionId& id, const TToiRendererStatus& status) throw (TToiInvalidArgumentException); \
virtual void GetSessionInfo(const TToiRendererSessionId& id, TToiRendererSessionInfo& info) throw (TToiInvalidArgumentException); \
virtual void GetRendererSessions(TToiRendererSessionIdSequence& ids) throw (); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

