/*
 *-----------------------------------------------------------------------------
 *
 * IToiDlnaService.h
 *
 * This file was created from .idlcpp/IToiDlnaService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDLNASERVICE_H
#define ITOIDLNASERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDlnaService
{
public:
  struct TToiMediaServerIconInfo;
  struct TToiMediaServerInfo;
  
  enum TToiServiceType
  {
    SERVICE_TYPE_CONTENT_DIRECTORY = 0
  };
  enum TToiMediaFormatProfile
  {
    MEDIA_FORMAT_PROFILE_JPEG_LRG_ICO = 0,
    MEDIA_FORMAT_PROFILE_JPEG_SM_ICO = 1,
    MEDIA_FORMAT_PROFILE_PNG_LRG_ICO = 2,
    MEDIA_FORMAT_PROFILE_PNG_SM_ICO = 3
  };
  typedef std::string TToiMediaServerUuid;
  typedef std::vector< TToiMediaServerUuid > TToiMediaServerUuidSequence;
  typedef std::vector< TToiServiceType > TToiServiceTypeSequence;
  typedef std::vector< TToiMediaServerIconInfo > TToiMediaServerIconInfoSequence;
  
  struct TToiMediaServerIconInfo {
    std::string Url;
    TToiMediaFormatProfile Profile;
    
    TToiMediaServerIconInfo() :
      Url(""), 
      Profile(MEDIA_FORMAT_PROFILE_JPEG_LRG_ICO)  {   }
    
    TToiMediaServerIconInfo(
      const std::string& _Url, 
      const TToiMediaFormatProfile& _Profile) :
        Url(_Url), 
        Profile(_Profile)
    {
    }
    
  };
  
  struct TToiMediaServerInfo {
    TToiMediaServerUuid Uuid;
    std::string Name;
    std::string Vendor;
    TToiServiceTypeSequence SupportedServices;
    bool IsLocal;
    TToiMediaServerIconInfoSequence Icons;
    
    TToiMediaServerInfo() :
      Uuid(""), 
      Name(""), 
      Vendor(""), 
      IsLocal(false)  {   }
    
    TToiMediaServerInfo(
      const TToiMediaServerUuid& _Uuid, 
      const std::string& _Name, 
      const std::string& _Vendor, 
      const TToiServiceTypeSequence& _SupportedServices, 
      const bool& _IsLocal, 
      const TToiMediaServerIconInfoSequence& _Icons) :
        Uuid(_Uuid), 
        Name(_Name), 
        Vendor(_Vendor), 
        SupportedServices(_SupportedServices), 
        IsLocal(_IsLocal), 
        Icons(_Icons)
    {
    }
    
  };
  
  virtual ~IToiDlnaService() { /* Empty */ }
  virtual void GetMediaServers(TToiMediaServerUuidSequence& uuids) throw (TIpcException) = 0;
  virtual void GetMediaServerInfo(const TToiMediaServerUuid& uuid, TToiMediaServerInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreateContentDirectoryInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TToiMediaServerUuid& uuid, std::string& address) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void CreateRendererInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDLNASERVICE \
virtual void GetMediaServers(TToiMediaServerUuidSequence& uuids) throw (); \
virtual void GetMediaServerInfo(const TToiMediaServerUuid& uuid, TToiMediaServerInfo& info) throw (TToiInvalidArgumentException); \
virtual void CreateContentDirectoryInstance(const IToiApplicationService::TToiApplicationId& applicationId, const TToiMediaServerUuid& uuid, std::string& address) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException); \
virtual void CreateRendererInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

