/*
 *-----------------------------------------------------------------------------
 *
 * IToiDrmService.h
 *
 * This file was created from .idlcpp/IToiDrmService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDRMSERVICE_H
#define ITOIDRMSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDrmService
{
public:
  struct TToiOutputControl;
  
  enum TToiCopyPermission
  {
    COPY_FREE = 0,
    COPY_NO_MORE = 1,
    COPY_10 = 2,
    COPY_NEVER = 3
  };
  
  struct TToiOutputControl {
    bool RecordingAllowed;
    bool RecordingForMobileAllowed;
    
    TToiOutputControl() :
      RecordingAllowed(false), 
      RecordingForMobileAllowed(false)  {   }
    
    TToiOutputControl(
      const bool& _RecordingAllowed, 
      const bool& _RecordingForMobileAllowed) :
        RecordingAllowed(_RecordingAllowed), 
        RecordingForMobileAllowed(_RecordingForMobileAllowed)
    {
    }
    
  };
  
  virtual ~IToiDrmService() { /* Empty */ }
  virtual void GetCurrentOutputControl(const int& mediaSessionId, TToiOutputControl& outputControl) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void QueryCopyPermission(const std::string& assetUrl, TToiCopyPermission& copyPermission, int& remainingCopies) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDRMSERVICE \
virtual void GetCurrentOutputControl(const int& mediaSessionId, TToiOutputControl& outputControl) throw (TToiInvalidArgumentException); \
virtual void QueryCopyPermission(const std::string& assetUrl, TToiCopyPermission& copyPermission, int& remainingCopies) throw (TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

