/*
 *-----------------------------------------------------------------------------
 *
 * IToiDvbCScanner.h
 *
 * This file was created from .idlcpp/IToiDvbCScanner.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDVBCSCANNER_H
#define ITOIDVBCSCANNER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiFrontendService.h"
#include "interface/IToiScanner.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDvbCScanner
  : public virtual IToiScanner
{
public:
  struct TToiDvbCFrontendParameters;
  
  enum TToiDvbCModulation
  {
    MODULATION_ANY = 0,
    MODULATION_16_QAM = 1,
    MODULATION_32_QAM = 2,
    MODULATION_64_QAM = 3,
    MODULATION_128_QAM = 4,
    MODULATION_256_QAM = 5
  };
  
  struct TToiDvbCFrontendParameters {
    TToiDvbCModulation Modulation;
    int SymbolRate;
    
    TToiDvbCFrontendParameters() :
      Modulation(MODULATION_ANY), 
      SymbolRate(0)  {   }
    
    TToiDvbCFrontendParameters(
      const TToiDvbCModulation& _Modulation, 
      const int& _SymbolRate) :
        Modulation(_Modulation), 
        SymbolRate(_SymbolRate)
    {
    }
    
  };
  
  virtual ~IToiDvbCScanner() { /* Empty */ }
  virtual void AddFrequencyScanParameters(const TToiDvbCFrontendParameters& frontendParameters, const int& startFrequency, const int& endFrequency, const int& step) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void AddNitScanParametersByNetworkId(const TToiDvbCFrontendParameters& frontendParameters, const int& frequency, const int& networkId) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDVBCSCANNER \
virtual void AddFrequencyScanParameters(const TToiDvbCFrontendParameters& frontendParameters, const int& startFrequency, const int& endFrequency, const int& step) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException); \
virtual void AddNitScanParametersByNetworkId(const TToiDvbCFrontendParameters& frontendParameters, const int& frequency, const int& networkId) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException);

#endif 

