/*
 *-----------------------------------------------------------------------------
 *
 * IToiDvbEitCache.h
 *
 * This file was created from .idlcpp/IToiDvbEitCache.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDVBEITCACHE_H
#define ITOIDVBEITCACHE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDvbEitCache
{
public:
  enum { NO_EVENT_ID = 2147483647 };
  enum { FILTER_MODE_PF_ONLY = 1 };
  enum { FILTER_MODE_PF_AND_SCHEDULE = 2 };
  struct TToiServiceItem;
  struct TToiEventInfo;
  struct TToiExtendedEventInfo;
  struct TToiEventItemInfo;
  struct TToiDvbEitUpdateInfo;
  struct TToiComponent;
  
  typedef std::vector< TToiEventInfo > TToiEventInfoSequence;
  typedef std::vector< TToiEventItemInfo > TToiEventItemInfoSequence;
  typedef uint8_t* Binary;
  typedef std::vector< TToiDvbEitUpdateInfo > TToiDvbEitUpdateInfoSequence;
  typedef std::string TToiLanguageCode;
  typedef std::vector< TToiComponent > TToiComponentSequence;
  
  struct TToiServiceItem {
    int OriginalNetworkId;
    int TransportStreamId;
    int ServiceId;
    
    TToiServiceItem() :
      OriginalNetworkId(0), 
      TransportStreamId(0), 
      ServiceId(0)  {   }
    
    TToiServiceItem(
      const int& _OriginalNetworkId, 
      const int& _TransportStreamId, 
      const int& _ServiceId) :
        OriginalNetworkId(_OriginalNetworkId), 
        TransportStreamId(_TransportStreamId), 
        ServiceId(_ServiceId)
    {
    }
    
  };
  
  struct TToiEventInfo {
    int EventId;
    std::string Name;
    unsigned int Time;
    int Duration;
    int ContentNibbles;
    int ParentalRating;
    bool FreeCaMode;
    
    TToiEventInfo() :
      EventId(0), 
      Name(""), 
      Time(0), 
      Duration(0), 
      ContentNibbles(0), 
      ParentalRating(0), 
      FreeCaMode(false)  {   }
    
    TToiEventInfo(
      const int& _EventId, 
      const std::string& _Name, 
      const unsigned int& _Time, 
      const int& _Duration, 
      const int& _ContentNibbles, 
      const int& _ParentalRating, 
      const bool& _FreeCaMode) :
        EventId(_EventId), 
        Name(_Name), 
        Time(_Time), 
        Duration(_Duration), 
        ContentNibbles(_ContentNibbles), 
        ParentalRating(_ParentalRating), 
        FreeCaMode(_FreeCaMode)
    {
    }
    
  };
  
  struct TToiExtendedEventInfo {
    int EventId;
    std::string ShortInfo;
    std::string ExtendedInfo;
    
    TToiExtendedEventInfo() :
      EventId(0), 
      ShortInfo(""), 
      ExtendedInfo("")  {   }
    
    TToiExtendedEventInfo(
      const int& _EventId, 
      const std::string& _ShortInfo, 
      const std::string& _ExtendedInfo) :
        EventId(_EventId), 
        ShortInfo(_ShortInfo), 
        ExtendedInfo(_ExtendedInfo)
    {
    }
    
  };
  
  struct TToiEventItemInfo {
    std::string Description;
    std::string Value;
    
    TToiEventItemInfo() :
      Description(""), 
      Value("")  {   }
    
    TToiEventItemInfo(
      const std::string& _Description, 
      const std::string& _Value) :
        Description(_Description), 
        Value(_Value)
    {
    }
    
  };
  
  struct TToiDvbEitUpdateInfo {
    int OriginalNetworkId;
    int TransportStreamId;
    int ServiceId;
    unsigned int Time;
    int Duration;
    
    TToiDvbEitUpdateInfo() :
      OriginalNetworkId(0), 
      TransportStreamId(0), 
      ServiceId(0), 
      Time(0), 
      Duration(0)  {   }
    
    TToiDvbEitUpdateInfo(
      const int& _OriginalNetworkId, 
      const int& _TransportStreamId, 
      const int& _ServiceId, 
      const unsigned int& _Time, 
      const int& _Duration) :
        OriginalNetworkId(_OriginalNetworkId), 
        TransportStreamId(_TransportStreamId), 
        ServiceId(_ServiceId), 
        Time(_Time), 
        Duration(_Duration)
    {
    }
    
  };
  
  struct TToiComponent {
    int StreamContent;
    int ComponentType;
    int Tag;
    TToiLanguageCode LanguageCode;
    std::string Description;
    
    TToiComponent() :
      StreamContent(0), 
      ComponentType(0), 
      Tag(0), 
      LanguageCode(""), 
      Description("")  {   }
    
    TToiComponent(
      const int& _StreamContent, 
      const int& _ComponentType, 
      const int& _Tag, 
      const TToiLanguageCode& _LanguageCode, 
      const std::string& _Description) :
        StreamContent(_StreamContent), 
        ComponentType(_ComponentType), 
        Tag(_Tag), 
        LanguageCode(_LanguageCode), 
        Description(_Description)
    {
    }
    
  };
  
  virtual ~IToiDvbEitCache() { /* Empty */ }
  virtual void SetFilterMode(const int& filterMode) throw (TIpcException) = 0;
  virtual void ClearServices() throw (TIpcException) = 0;
  virtual void ClearEvents() throw (TIpcException) = 0;
  virtual void AddService(const TToiServiceItem& service) throw (TIpcException) = 0;
  virtual void GetEvents(const TToiServiceItem& service, const unsigned int& time, const int& duration, TToiEventInfoSequence& infoSequence, bool& more) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetPresentEvent(const TToiServiceItem& service, TToiEventInfo& event) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetFollowingEvent(const TToiServiceItem& service, TToiEventInfo& event) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetPrivateData(const TToiServiceItem& service, const int& eventId, uint8_t* privData, int& privDataDataSize, const int& privDataMaxSize) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetExtendedEventInfo(const TToiServiceItem& service, const int& eventId, TToiExtendedEventInfo& eventInfo) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetEventItemInfo(const TToiServiceItem& service, const int& eventId, TToiEventItemInfoSequence& eventItems) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetVideoComponentList(const TToiServiceItem& service, const int& eventId, TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetAudioComponentList(const TToiServiceItem& service, const int& eventId, const TToiLanguageCode& languageCode, TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetSubtitleComponentList(const TToiServiceItem& service, const int& eventId, const TToiLanguageCode& languageCode, TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDVBEITCACHE \
virtual void SetFilterMode(const int& filterMode) throw (); \
virtual void ClearServices() throw (); \
virtual void ClearEvents() throw (); \
virtual void AddService(const TToiServiceItem& service) throw (); \
virtual void GetEvents(const TToiServiceItem& service, const unsigned int& time, const int& duration, TToiEventInfoSequence& infoSequence, bool& more) throw (TToiInvalidArgumentException); \
virtual void GetPresentEvent(const TToiServiceItem& service, TToiEventInfo& event) throw (TToiInvalidArgumentException); \
virtual void GetFollowingEvent(const TToiServiceItem& service, TToiEventInfo& event) throw (TToiInvalidArgumentException); \
virtual void GetPrivateData(const TToiServiceItem& service, const int& eventId, uint8_t* privData, int& privDataDataSize, const int& privDataMaxSize) throw (TToiInvalidArgumentException); \
virtual void GetExtendedEventInfo(const TToiServiceItem& service, const int& eventId, TToiExtendedEventInfo& eventInfo) throw (TToiInvalidArgumentException); \
virtual void GetEventItemInfo(const TToiServiceItem& service, const int& eventId, TToiEventItemInfoSequence& eventItems) throw (TToiInvalidArgumentException); \
virtual void GetVideoComponentList(const TToiServiceItem& service, const int& eventId, TToiComponentSequence& components) throw (TToiInvalidArgumentException); \
virtual void GetAudioComponentList(const TToiServiceItem& service, const int& eventId, const TToiLanguageCode& languageCode, TToiComponentSequence& components) throw (TToiInvalidArgumentException); \
virtual void GetSubtitleComponentList(const TToiServiceItem& service, const int& eventId, const TToiLanguageCode& languageCode, TToiComponentSequence& components) throw (TToiInvalidArgumentException); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

