/*
 *-----------------------------------------------------------------------------
 *
 * IToiDvbTScanner.h
 *
 * This file was created from .idlcpp/IToiDvbTScanner.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIDVBTSCANNER_H
#define ITOIDVBTSCANNER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiFrontendService.h"
#include "interface/IToiScanner.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiDvbTScanner
  : public virtual IToiScanner
{
public:
  struct TToiDvbTFrontendParameters;
  
  enum TToiDvbTBandwidth
  {
    BANDWIDTH_ANY = 0,
    BANDWIDTH_8MHZ = 1,
    BANDWIDTH_7MHZ = 2,
    BANDWIDTH_6MHZ = 3,
    BANDWIDTH_5MHZ = 4
  };
  
  struct TToiDvbTFrontendParameters {
    TToiDvbTBandwidth Bandwidth;
    bool UseHighPriority;
    
    TToiDvbTFrontendParameters() :
      Bandwidth(BANDWIDTH_ANY), 
      UseHighPriority(false)  {   }
    
    TToiDvbTFrontendParameters(
      const TToiDvbTBandwidth& _Bandwidth, 
      const bool& _UseHighPriority) :
        Bandwidth(_Bandwidth), 
        UseHighPriority(_UseHighPriority)
    {
    }
    
  };
  
  virtual ~IToiDvbTScanner() { /* Empty */ }
  virtual void AddFrequencyScanParameters(const TToiDvbTFrontendParameters& tunerParams, const int& startFrequency, const int& endFrequency, const int& step) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIDVBTSCANNER \
virtual void AddFrequencyScanParameters(const TToiDvbTFrontendParameters& tunerParams, const int& startFrequency, const int& endFrequency, const int& step) throw (TToiInvalidPreconditionException, TToiInvalidArgumentException);

#endif 

