/*
 *-----------------------------------------------------------------------------
 *
 * IToiFrontPanelService.h
 *
 * This file was created from .idlcpp/IToiFrontPanelService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIFRONTPANELSERVICE_H
#define ITOIFRONTPANELSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiOperationNotSupportedException.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiFrontPanelService
{
public:
  struct TToiLedState;
  struct TToiLedInfo;
  struct TToiSegmentDisplayState;
  struct TToiSegmentDisplayInfo;
  
  enum TToiColor
  {
    COLOR_OFF = 0,
    COLOR_GREEN = 1,
    COLOR_RED = 2,
    COLOR_ORANGE = 3,
    COLOR_BLUE = 4,
    COLOR_YELLOW = 5
  };
  enum TToiSegmentDisplayModes
  {
    SEGMENT_DISPLAY_MODE_TEXT = 0,
    SEGMENT_DISPLAY_MODE_CLOCK = 1
  };
  typedef std::vector< TToiColor > TToiColorSequence;
  
  struct TToiLedState {
    TToiColor Color;
    double BlinkFrequency;
    
    TToiLedState() :
      Color(COLOR_OFF), 
      BlinkFrequency(0)  {   }
    
    TToiLedState(
      const TToiColor& _Color, 
      const double& _BlinkFrequency) :
        Color(_Color), 
        BlinkFrequency(_BlinkFrequency)
    {
    }
    
  };
  
  struct TToiLedInfo {
    int Index;
    TToiColorSequence SupportedColors;
    
    TToiLedInfo() :
      Index(0)  {   }
    
    TToiLedInfo(
      const int& _Index, 
      const TToiColorSequence& _SupportedColors) :
        Index(_Index), 
        SupportedColors(_SupportedColors)
    {
    }
    
  };
  
  struct TToiSegmentDisplayState {
    std::string Text;
    bool ColonState;
    int Intensity;
    TToiSegmentDisplayModes CurrentMode;
    
    TToiSegmentDisplayState() :
      Text(""), 
      ColonState(false), 
      Intensity(0), 
      CurrentMode(SEGMENT_DISPLAY_MODE_TEXT)  {   }
    
    TToiSegmentDisplayState(
      const std::string& _Text, 
      const bool& _ColonState, 
      const int& _Intensity, 
      const TToiSegmentDisplayModes& _CurrentMode) :
        Text(_Text), 
        ColonState(_ColonState), 
        Intensity(_Intensity), 
        CurrentMode(_CurrentMode)
    {
    }
    
  };
  
  struct TToiSegmentDisplayInfo {
    int NumberOfBlocks;
    bool SupportsColon;
    bool SupportsIntensity;
    
    TToiSegmentDisplayInfo() :
      NumberOfBlocks(0), 
      SupportsColon(false), 
      SupportsIntensity(false)  {   }
    
    TToiSegmentDisplayInfo(
      const int& _NumberOfBlocks, 
      const bool& _SupportsColon, 
      const bool& _SupportsIntensity) :
        NumberOfBlocks(_NumberOfBlocks), 
        SupportsColon(_SupportsColon), 
        SupportsIntensity(_SupportsIntensity)
    {
    }
    
  };
  
  virtual ~IToiFrontPanelService() { /* Empty */ }
  virtual void GetLedCount(int& numberOfLeds) throw (TIpcException) = 0;
  virtual void GetLedInfo(const int& index, TToiLedInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetLedState(const int& index, const TToiLedState& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetLedState(const int& index, TToiLedState& state) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetSegmentDisplayInfo(TToiSegmentDisplayInfo& info) throw (TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void SetSegmentDisplayState(const TToiSegmentDisplayState& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void GetSegmentDisplayState(TToiSegmentDisplayState& state) throw (TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void IsSegmentDisplaySupported(bool& isSupported) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIFRONTPANELSERVICE \
virtual void GetLedCount(int& numberOfLeds) throw (); \
virtual void GetLedInfo(const int& index, TToiLedInfo& info) throw (TToiInvalidArgumentException); \
virtual void SetLedState(const int& index, const TToiLedState& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetLedState(const int& index, TToiLedState& state) throw (TToiInvalidArgumentException); \
virtual void GetSegmentDisplayInfo(TToiSegmentDisplayInfo& info) throw (TToiOperationNotSupportedException); \
virtual void SetSegmentDisplayState(const TToiSegmentDisplayState& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException); \
virtual void GetSegmentDisplayState(TToiSegmentDisplayState& state) throw (TToiOperationNotSupportedException); \
virtual void IsSegmentDisplaySupported(bool& isSupported) throw ();

#endif 

