/*
 *-----------------------------------------------------------------------------
 *
 * IToiFrontendDownloader.h
 *
 * This file was created from .idlcpp/IToiFrontendDownloader.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIFRONTENDDOWNLOADER_H
#define ITOIFRONTENDDOWNLOADER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNoDataException.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiFrontendDownloader
{
public:
  enum { OP_RESULT_DOWNLOAD_INFO = 1 };
  struct TToiDownloadInfo;
  
  enum TToiDownloadType
  {
    DOWNLOAD_TYPE_SOFTWARE = 0,
    DOWNLOAD_TYPE_SPLASH = 1
  };
  enum TToiDownloadAvailability
  {
    DOWNLOAD_NOT_AVAILABLE = 0,
    DOWNLOAD_AVAILABLE = 1
  };
  typedef std::string TToiDownloadVersion;
  
  struct TToiDownloadInfo {
    TToiDownloadType DownloadType;
    TToiDownloadAvailability DownloadAvailability;
    TToiDownloadVersion DownloadVersion;
    
    TToiDownloadInfo() :
      DownloadType(DOWNLOAD_TYPE_SOFTWARE), 
      DownloadAvailability(DOWNLOAD_NOT_AVAILABLE), 
      DownloadVersion("")  {   }
    
    TToiDownloadInfo(
      const TToiDownloadType& _DownloadType, 
      const TToiDownloadAvailability& _DownloadAvailability, 
      const TToiDownloadVersion& _DownloadVersion) :
        DownloadType(_DownloadType), 
        DownloadAvailability(_DownloadAvailability), 
        DownloadVersion(_DownloadVersion)
    {
    }
    
  };
  
  virtual ~IToiFrontendDownloader() { /* Empty */ }
  virtual void StartSearch(const IToiOperationManager::TToiOperationId& operationId, const TToiDownloadType& downloadType) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void StartDownload(const IToiOperationManager::TToiOperationId& operationId, const TToiDownloadType& downloadType) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void Install(const IToiOperationManager::TToiOperationId& operationId) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void GetDownloadInfoResult(const IToiOperationManager::TToiOperationId& operationId, TToiDownloadInfo& downloadInfo) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIFRONTENDDOWNLOADER \
virtual void StartSearch(const IToiOperationManager::TToiOperationId& operationId, const TToiDownloadType& downloadType) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void StartDownload(const IToiOperationManager::TToiOperationId& operationId, const TToiDownloadType& downloadType) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void Install(const IToiOperationManager::TToiOperationId& operationId) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void GetDownloadInfoResult(const IToiOperationManager::TToiOperationId& operationId, TToiDownloadInfo& downloadInfo) throw (TToiInvalidArgumentException, TToiNoDataException); \
virtual void ReleaseInstance() throw ();

#endif 

