/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaConsumer.h
 *
 * This file was created from .idlcpp/IToiMediaConsumer.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIACONSUMER_H
#define ITOIMEDIACONSUMER_H

#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/IToiMediaService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaConsumer
{
public:
  
  enum TToiState
  {
    STATE_IDLE = 0,
    STATE_CONNECTING = 1,
    STATE_PAUSED = 2,
    STATE_CONSUMING = 3,
    STATE_FAILED = 4
  };
  
  virtual ~IToiMediaConsumer() { /* Empty */ }
  virtual void GetState(TToiState& state) throw (TIpcException) = 0;
  virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void Open(const std::string& url) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void Close() throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void Consume() throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIACONSUMER \
virtual void GetState(TToiState& state) throw (); \
virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException); \
virtual void GetUrl(std::string& url) throw (TToiSessionViolationException); \
virtual void Open(const std::string& url) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void Close() throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void Consume() throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

