/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaPlayer.h
 *
 * This file was created from .idlcpp/IToiMediaPlayer.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIAPLAYER_H
#define ITOIMEDIAPLAYER_H

#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiAssetManagerService.h"
#include "interface/IToiMediaPlayerBase.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaPlayer
  : public virtual IToiMediaPlayerBase
{
public:
  
  
  virtual ~IToiMediaPlayer() { /* Empty */ }
  virtual void Open(const std::string& url) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void Close() throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void Play(const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException) = 0;
  virtual void PlayFromPosition(const int& position, const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void StartTimeshiftBuffering(const int& maxBufferLength) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiInvalidPreconditionException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException) = 0;
  virtual void StopTimeshiftBuffering() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException, TIpcException) = 0;
  virtual void DiscardTimeshiftBuffer() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException, TIpcException) = 0;
  virtual void ActivateComponent(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void DeactivateComponent(const IToiMediaPlayerBase::TToiComponentType& mediaType) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void SetAudioChannelMode(const int& streamId, const IToiMediaPlayerBase::TToiAudioChannelMode& channelMode) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException, TIpcException) = 0;
  virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIAPLAYER \
virtual void Open(const std::string& url) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void Close() throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void Play(const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException); \
virtual void PlayFromPosition(const int& position, const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void StartTimeshiftBuffering(const int& maxBufferLength) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiInvalidPreconditionException, TToiOperationNotSupportedException, TToiUnavailableException); \
virtual void StopTimeshiftBuffering() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException); \
virtual void DiscardTimeshiftBuffer() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException); \
virtual void ActivateComponent(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void DeactivateComponent(const IToiMediaPlayerBase::TToiComponentType& mediaType) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void SetAudioChannelMode(const int& streamId, const IToiMediaPlayerBase::TToiAudioChannelMode& channelMode) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException); \
virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException);

#endif 

