/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaPlayerBase.h
 *
 * This file was created from .idlcpp/IToiMediaPlayerBase.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIAPLAYERBASE_H
#define ITOIMEDIAPLAYERBASE_H

#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiAssetManagerService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaPlayerBase
{
public:
  enum { PACE_PAUSE = 0 };
  enum { PACE_PLAY = 1000 };
  enum { PACE_FASTFORWARD = 5000 };
  enum { PACE_REWIND = -5000 };
  enum { POSITION_LIVE = -1616928864 };
  enum { CAPABILITY_PAUSE = 1 };
  enum { CAPABILITY_REWIND = 2 };
  enum { CAPABILITY_FASTFORWARD = 4 };
  enum { CAPABILITY_GETPOSITION = 8 };
  enum { CAPABILITY_SETPOSITION = 16 };
  enum { CAPABILITY_FREEZE = 32 };
  enum { CAPABILITY_TIMESHIFT = 64 };
  struct TToiComponentEntry;
  struct TToiError;
  struct TToiTimeshiftInfo;
  struct TToiAudioStreamInfo;
  struct TToiVideoStreamInfo;
  struct TToiSubtitleStreamInfo;
  struct TToiStreamInfo;
  struct TToiTeletextStreamInfo;
  
  enum TToiComponentType
  {
    COMPONENT_AUDIO = 0,
    COMPONENT_VIDEO = 1,
    COMPONENT_SUBTITLE = 2,
    COMPONENT_SUBTITLE_CAPTION = 3,
    COMPONENT_SUBTITLE_SUPERIMPOSE = 4,
    COMPONENT_TELETEXT_VBI = 5
  };
  enum TToiErrorSource
  {
    SOURCE_UNKNOWN = 0,
    SOURCE_INTERNAL = 1,
    SOURCE_BITBAND = 2
  };
  enum TToiState
  {
    STATE_IDLE = 0,
    STATE_CONNECTING = 1,
    STATE_PAUSED = 2,
    STATE_PLAYING = 3,
    STATE_FASTFORWARDING = 4,
    STATE_REWINDING = 5,
    STATE_FAILED = 6
  };
  enum TToiTimeshiftState
  {
    TIMESHIFT_STATE_INACTIVE = 0,
    TIMESHIFT_STATE_BUFFERING = 1,
    TIMESHIFT_STATE_STOPPED = 2,
    TIMESHIFT_STATE_BUFFERING_FAILED = 3
  };
  enum TToiAudioAudienceType
  {
    AUDIO_AUDIENCE_TYPE_UNKNOWN = 0,
    AUDIO_AUDIENCE_TYPE_NORMAL = 1,
    AUDIO_AUDIENCE_TYPE_VISUALLY_IMPAIRED = 2,
    AUDIO_AUDIENCE_TYPE_HEARING_IMPAIRED = 3
  };
  enum TToiAudioChannelFormat
  {
    AUDIO_CHANNEL_FORMAT_UNKNOWN = 0,
    AUDIO_CHANNEL_FORMAT_SINGLE_MONO = 1,
    AUDIO_CHANNEL_FORMAT_DUAL_MONO = 2,
    AUDIO_CHANNEL_FORMAT_STEREO = 3,
    AUDIO_CHANNEL_FORMAT_3_FRONT_1_BACK = 4,
    AUDIO_CHANNEL_FORMAT_3_FRONT_2_BACK = 5,
    AUDIO_CHANNEL_FORMAT_3_FRONT_2_BACK_LFE = 6,
    AUDIO_CHANNEL_FORMAT_3_FRONT_2_SIDE_2_BACK_LFE = 7
  };
  enum TToiAudioChannelMode
  {
    AUDIO_CHANNEL_MODE_NORMAL = 0,
    AUDIO_CHANNEL_MODE_DUAL_MONO_LEFT_ONLY = 1,
    AUDIO_CHANNEL_MODE_DUAL_MONO_RIGHT_ONLY = 2,
    AUDIO_CHANNEL_MODE_DUAL_MONO_STEREO = 3,
    AUDIO_CHANNEL_MODE_DUAL_MONO_MIXED = 4
  };
  enum TToiAspectRatio
  {
    ASPECT_RATIO_UNKNOWN = 0,
    ASPECT_RATIO_4_3 = 1,
    ASPECT_RATIO_16_9 = 2
  };
  enum TToiActiveFormatDescriptor
  {
    ACTIVE_FORMAT_UNKNOWN = 0,
    ACTIVE_FORMAT_16_9_TOP = 1,
    ACTIVE_FORMAT_14_9_TOP = 2,
    ACTIVE_FORMAT_MORE_THAN_16_9_CENTRE = 3,
    ACTIVE_FORMAT_SAME_AS_CODED = 4,
    ACTIVE_FORMAT_4_3_CENTRE = 5,
    ACTIVE_FORMAT_16_9_CENTRE = 6,
    ACTIVE_FORMAT_14_9_CENTRE = 7,
    ACTIVE_FORMAT_4_3_SHOOT_AND_PROTECT_14_9_CENTRE = 8,
    ACTIVE_FORMAT_16_9_SHOOT_AND_PROTECT_14_9_CENTRE = 9,
    ACTIVE_FORMAT_16_9_SHOOT_AND_PROTECT_4_3_CENTRE = 10
  };
  enum TToiSubtitleType
  {
    SUBTITLE_UNKNOWN = 0,
    SUBTITLE_NORMAL = 1,
    SUBTITLE_HEARING_IMPAIRED = 2
  };
  enum TToiSubtitleFormat
  {
    SUBTITLE_DVB = 0,
    SUBTITLE_ARIB = 1,
    SUBTITLE_TELETEXT = 2,
    SUBTITLE_DVD = 3,
    SUBTITLE_XSUB = 4
  };
  enum TToiReceiveDmfMode
  {
    RECEIVE_DMF_MODE_AUTO = 0,
    RECEIVE_DMF_MODE_NON_AUTO = 1,
    RECEIVE_DMF_MODE_SELECT = 2,
    RECEIVE_DMF_MODE_SPECIAL = 3
  };
  enum TToiRecordDmfMode
  {
    RECORD_DMF_MODE_AUTO = 0,
    RECORD_DMF_MODE_NON_AUTO = 1,
    RECORD_DMF_MODE_SELECT = 2
  };
  typedef std::vector< TToiComponentEntry > TToiComponentSequence;
  typedef std::vector< int > TToiPaceSequence;
  
  struct TToiComponentEntry {
    TToiComponentType Type;
    int Id;
    
    TToiComponentEntry() :
      Type(COMPONENT_AUDIO), 
      Id(0)  {   }
    
    TToiComponentEntry(
      const TToiComponentType& _Type, 
      const int& _Id) :
        Type(_Type), 
        Id(_Id)
    {
    }
    
  };
  
  struct TToiError {
    TToiErrorSource Source;
    int Details;
    
    TToiError() :
      Source(SOURCE_UNKNOWN), 
      Details(0)  {   }
    
    TToiError(
      const TToiErrorSource& _Source, 
      const int& _Details) :
        Source(_Source), 
        Details(_Details)
    {
    }
    
  };
  
  struct TToiTimeshiftInfo {
    TToiTimeshiftState State;
    int BufferCapacity;
    int BufferUsed;
    int BufferStartPosition;
    IToiMediaSession::TToiSessionId RecorderSessionId;
    IToiAssetManagerService::TToiAssetId AssetId;
    
    TToiTimeshiftInfo() :
      State(TIMESHIFT_STATE_INACTIVE), 
      BufferCapacity(0), 
      BufferUsed(0), 
      BufferStartPosition(0), 
      RecorderSessionId(0), 
      AssetId("")  {   }
    
    TToiTimeshiftInfo(
      const TToiTimeshiftState& _State, 
      const int& _BufferCapacity, 
      const int& _BufferUsed, 
      const int& _BufferStartPosition, 
      const IToiMediaSession::TToiSessionId& _RecorderSessionId, 
      const IToiAssetManagerService::TToiAssetId& _AssetId) :
        State(_State), 
        BufferCapacity(_BufferCapacity), 
        BufferUsed(_BufferUsed), 
        BufferStartPosition(_BufferStartPosition), 
        RecorderSessionId(_RecorderSessionId), 
        AssetId(_AssetId)
    {
    }
    
  };
  
  struct TToiAudioStreamInfo {
    std::string Encoding;
    int SampleRate;
    TToiAudioChannelFormat ChannelFormat;
    TToiAudioChannelMode ChannelMode;
    std::string Language;
    std::string SubLanguage;
    TToiAudioAudienceType AudienceType;
    int ComponentTag;
    
    TToiAudioStreamInfo() :
      Encoding(""), 
      SampleRate(0), 
      ChannelFormat(AUDIO_CHANNEL_FORMAT_UNKNOWN), 
      ChannelMode(AUDIO_CHANNEL_MODE_NORMAL), 
      Language(""), 
      SubLanguage(""), 
      AudienceType(AUDIO_AUDIENCE_TYPE_UNKNOWN), 
      ComponentTag(0)  {   }
    
    TToiAudioStreamInfo(
      const std::string& _Encoding, 
      const int& _SampleRate, 
      const TToiAudioChannelFormat& _ChannelFormat, 
      const TToiAudioChannelMode& _ChannelMode, 
      const std::string& _Language, 
      const std::string& _SubLanguage, 
      const TToiAudioAudienceType& _AudienceType, 
      const int& _ComponentTag) :
        Encoding(_Encoding), 
        SampleRate(_SampleRate), 
        ChannelFormat(_ChannelFormat), 
        ChannelMode(_ChannelMode), 
        Language(_Language), 
        SubLanguage(_SubLanguage), 
        AudienceType(_AudienceType), 
        ComponentTag(_ComponentTag)
    {
    }
    
  };
  
  struct TToiVideoStreamInfo {
    std::string Encoding;
    int ResolutionX;
    int ResolutionY;
    TToiAspectRatio AspectRatio;
    TToiActiveFormatDescriptor ActiveFormatDescriptor;
    int FrameRate;
    int ComponentTag;
    
    TToiVideoStreamInfo() :
      Encoding(""), 
      ResolutionX(0), 
      ResolutionY(0), 
      AspectRatio(ASPECT_RATIO_UNKNOWN), 
      ActiveFormatDescriptor(ACTIVE_FORMAT_UNKNOWN), 
      FrameRate(0), 
      ComponentTag(0)  {   }
    
    TToiVideoStreamInfo(
      const std::string& _Encoding, 
      const int& _ResolutionX, 
      const int& _ResolutionY, 
      const TToiAspectRatio& _AspectRatio, 
      const TToiActiveFormatDescriptor& _ActiveFormatDescriptor, 
      const int& _FrameRate, 
      const int& _ComponentTag) :
        Encoding(_Encoding), 
        ResolutionX(_ResolutionX), 
        ResolutionY(_ResolutionY), 
        AspectRatio(_AspectRatio), 
        ActiveFormatDescriptor(_ActiveFormatDescriptor), 
        FrameRate(_FrameRate), 
        ComponentTag(_ComponentTag)
    {
    }
    
  };
  
  struct TToiSubtitleStreamInfo {
    std::string Language;
    TToiSubtitleType Type;
    TToiSubtitleFormat Format;
    TToiAspectRatio AspectRatio;
    TToiReceiveDmfMode ReceiveDmfMode;
    TToiRecordDmfMode RecordDmfMode;
    
    TToiSubtitleStreamInfo() :
      Language(""), 
      Type(SUBTITLE_UNKNOWN), 
      Format(SUBTITLE_DVB), 
      AspectRatio(ASPECT_RATIO_UNKNOWN), 
      ReceiveDmfMode(RECEIVE_DMF_MODE_AUTO), 
      RecordDmfMode(RECORD_DMF_MODE_AUTO)  {   }
    
    TToiSubtitleStreamInfo(
      const std::string& _Language, 
      const TToiSubtitleType& _Type, 
      const TToiSubtitleFormat& _Format, 
      const TToiAspectRatio& _AspectRatio, 
      const TToiReceiveDmfMode& _ReceiveDmfMode, 
      const TToiRecordDmfMode& _RecordDmfMode) :
        Language(_Language), 
        Type(_Type), 
        Format(_Format), 
        AspectRatio(_AspectRatio), 
        ReceiveDmfMode(_ReceiveDmfMode), 
        RecordDmfMode(_RecordDmfMode)
    {
    }
    
  };
  
  struct TToiStreamInfo {
    std::string Title;
    TToiComponentSequence AvailableComponents;
    TToiComponentSequence ActiveComponents;
    int PlayTime;
    TToiPaceSequence Paces;
    
    TToiStreamInfo() :
      Title(""), 
      PlayTime(0)  {   }
    
    TToiStreamInfo(
      const std::string& _Title, 
      const TToiComponentSequence& _AvailableComponents, 
      const TToiComponentSequence& _ActiveComponents, 
      const int& _PlayTime, 
      const TToiPaceSequence& _Paces) :
        Title(_Title), 
        AvailableComponents(_AvailableComponents), 
        ActiveComponents(_ActiveComponents), 
        PlayTime(_PlayTime), 
        Paces(_Paces)
    {
    }
    
  };
  
  struct TToiTeletextStreamInfo {
    std::string Language;
    
    TToiTeletextStreamInfo() :
      Language("")  {   }
    
    TToiTeletextStreamInfo(
      const std::string& _Language) :
        Language(_Language)
    {
    }
    
  };
  
  virtual ~IToiMediaPlayerBase() { /* Empty */ }
  virtual void GetState(TToiState& state) throw (TIpcException) = 0;
  virtual void GetError(TToiError& error) throw (TIpcException) = 0;
  virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetStreamInfo(TToiStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetVideoStreamInfo(const TToiComponentEntry& mediaComponent, TToiVideoStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetAudioStreamInfo(const TToiComponentEntry& mediaComponent, TToiAudioStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetSubtitleStreamInfo(const TToiComponentEntry& mediaComponent, TToiSubtitleStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetTeletextStreamInfo(const TToiComponentEntry& mediaComponent, TToiTeletextStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetCapabilities(int& capabilityMask) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetPosition(int& position) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetPace(int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException) = 0;
  virtual void IsTimeshiftPlayback(bool& timeshiftPlayback) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetTimeshiftInfo(TToiTimeshiftInfo& timeshiftInfo) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetTimeshiftError(TToiError& timeshiftError) throw (TIpcException) = 0;
  virtual void GetActiveComponents(TToiComponentSequence& components) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException) = 0;
  virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIAPLAYERBASE \
virtual void GetState(TToiState& state) throw (); \
virtual void GetError(TToiError& error) throw (); \
virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException); \
virtual void GetUrl(std::string& url) throw (TToiSessionViolationException); \
virtual void GetStreamInfo(TToiStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void GetVideoStreamInfo(const TToiComponentEntry& mediaComponent, TToiVideoStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void GetAudioStreamInfo(const TToiComponentEntry& mediaComponent, TToiAudioStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void GetSubtitleStreamInfo(const TToiComponentEntry& mediaComponent, TToiSubtitleStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void GetTeletextStreamInfo(const TToiComponentEntry& mediaComponent, TToiTeletextStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException); \
virtual void GetCapabilities(int& capabilityMask) throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void GetPosition(int& position) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException); \
virtual void GetPace(int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException); \
virtual void IsTimeshiftPlayback(bool& timeshiftPlayback) throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void GetTimeshiftInfo(TToiTimeshiftInfo& timeshiftInfo) throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void GetTimeshiftError(TToiError& timeshiftError) throw (); \
virtual void GetActiveComponents(TToiComponentSequence& components) throw (TToiSessionViolationException, TToiUnavailableException); \
virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TToiUnavailableException); \
virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException); \
virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

