/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaPlayerObserver.h
 *
 * This file was created from .idlcpp/IToiMediaPlayerObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIAPLAYEROBSERVER_H
#define ITOIMEDIAPLAYEROBSERVER_H

#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiAssetManagerService.h"
#include "interface/IToiMediaPlayerBase.h"
#include "interface/IToiMediaPlayer.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaPlayerObserver
{
public:
  
  
  virtual ~IToiMediaPlayerObserver() { /* Empty */ }
  virtual void OnStateChanged(const IToiMediaPlayerBase::TToiState& state, const std::string& reason) throw (TIpcException) = 0;
  virtual void OnDataAvailable(const bool& status) throw (TIpcException) = 0;
  virtual void OnPositionChanged(const int& position, const int& pace) throw (TIpcException) = 0;
  virtual void OnStreamInfoChanged(const IToiMediaPlayerBase::TToiComponentSequence& availableComponents, const IToiMediaPlayerBase::TToiComponentSequence& activeComponents, const IToiMediaPlayerBase::TToiComponentSequence& changedComponents) throw (TIpcException) = 0;
  virtual void OnActiveComponentChanged(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent) throw (TIpcException) = 0;
  virtual void OnParameterChanged(const std::string& name) throw (TIpcException) = 0;
  virtual void OnTimeshiftStateChanged(const IToiMediaPlayerBase::TToiTimeshiftState& state, const std::string& reason) throw (TIpcException) = 0;
  virtual void OnCapabilitiesChanged(const int& capabilityMask) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIAPLAYEROBSERVER \
virtual void OnStateChanged(const IToiMediaPlayerBase::TToiState& state, const std::string& reason) throw (); \
virtual void OnDataAvailable(const bool& status) throw (); \
virtual void OnPositionChanged(const int& position, const int& pace) throw (); \
virtual void OnStreamInfoChanged(const IToiMediaPlayerBase::TToiComponentSequence& availableComponents, const IToiMediaPlayerBase::TToiComponentSequence& activeComponents, const IToiMediaPlayerBase::TToiComponentSequence& changedComponents) throw (); \
virtual void OnActiveComponentChanged(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent) throw (); \
virtual void OnParameterChanged(const std::string& name) throw (); \
virtual void OnTimeshiftStateChanged(const IToiMediaPlayerBase::TToiTimeshiftState& state, const std::string& reason) throw (); \
virtual void OnCapabilitiesChanged(const int& capabilityMask) throw ();

#endif 

