/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaRecorder.h
 *
 * This file was created from .idlcpp/IToiMediaRecorder.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIARECORDER_H
#define ITOIMEDIARECORDER_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiBusyException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiAssetManagerService.h"
#include "interface/IToiMediaPlayerBase.h"
#include "interface/IToiMediaPlayer.h"
#include "interface/IToiMediaRecorderBase.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaRecorder
  : public virtual IToiMediaRecorderBase
{
public:
  
  
  virtual ~IToiMediaRecorder() { /* Empty */ }
  virtual void Open(const std::string& url, const std::string& assetId) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiBusyException, TToiUnavailableException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void Close() throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void Record() throw (TToiSessionViolationException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void RecordAt(const unsigned int& offset) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIARECORDER \
virtual void Open(const std::string& url, const std::string& assetId) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiBusyException, TToiUnavailableException, TToiInvalidPreconditionException); \
virtual void Close() throw (TToiSessionViolationException); \
virtual void Record() throw (TToiSessionViolationException, TToiOperationNotSupportedException); \
virtual void RecordAt(const unsigned int& offset) throw (TToiSessionViolationException, TToiOperationNotSupportedException); \
virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException); \
virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException);

#endif 

