/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaRecorderBase.h
 *
 * This file was created from .idlcpp/IToiMediaRecorderBase.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIARECORDERBASE_H
#define ITOIMEDIARECORDERBASE_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnavailableException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiBusyException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/IToiOperationManager.h"
#include "interface/IToiAssetManagerService.h"
#include "interface/IToiMediaPlayerBase.h"
#include "interface/IToiMediaPlayer.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiMediaRecorderBase
{
public:
  
  enum TToiMediaRecorderState
  {
    STATE_IDLE = 0,
    STATE_CONNECTING = 1,
    STATE_PAUSED = 2,
    STATE_RECORDING = 3,
    STATE_FAILED = 4
  };
  typedef TToiMediaRecorderState TState;
  
  virtual ~IToiMediaRecorderBase() { /* Empty */ }
  virtual void GetState(TToiMediaRecorderState& state) throw (TIpcException) = 0;
  virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetAssetId(std::string& assetId) throw (TToiSessionViolationException, TIpcException) = 0;
  virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIARECORDERBASE \
virtual void GetState(TToiMediaRecorderState& state) throw (); \
virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException); \
virtual void GetUrl(std::string& url) throw (TToiSessionViolationException); \
virtual void GetAssetId(std::string& assetId) throw (TToiSessionViolationException); \
virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException); \
virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException); \
virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException); \
virtual void ReleaseInstance() throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

