/*
 *-----------------------------------------------------------------------------
 *
 * IToiMediaService.h
 *
 * This file was created from .idlcpp/IToiMediaService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIMEDIASERVICE_H
#define ITOIMEDIASERVICE_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiNoDataException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiSessionViolationException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiMediaSession.h"
#include "interface/TToiPermissionDeniedException.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>





#define REASON_UNKNOWN "Unknown"
#define REASON_COMMAND_OPEN "CommandOpen"
#define REASON_COMMAND_CLOSE "CommandClose"
#define REASON_COMMAND_PAUSE "CommandPause"
#define REASON_COMMAND_PLAY "CommandPlay"
#define REASON_COMMAND_FASTFORWARD "CommandFastForward"
#define REASON_COMMAND_REWIND "CommandRewind"
#define REASON_COMMAND_PLAYFROMPOSITION "CommandPlayFromPosition"
#define REASON_COMMAND_RECORD "CommandRecord"
#define REASON_COMMAND_CONSUME "CommandConsume"
#define REASON_POSITION_END "PositionEnd"
#define REASON_POSITION_START "PositionStart"
#define REASON_TIMESHIFT_BUFFER_OPEN "TimeshiftBufferOpen"
#define REASON_TIMESHIFT_BUFFER_FULL "TimeshiftBufferFull"
#define REASON_TIMESHIFT_BUFFER_DISCARDED "TimeshiftBufferDiscarded"
#define REASON_ERROR_COMMAND_NOT_SUPPORTED "ErrorCommandNotSupported"
#define REASON_ERROR_STREAM_CLIENT "ErrorStreamClient"
#define REASON_ERROR_CONNECTION_FAILED "ErrorConnectionFailed"
#define REASON_ERROR_INVALID_PRECONDITION "ErrorInvalidPrecondition"
#define REASON_ERROR_PERMISSION_DENIED "ErrorPermissionDenied"
#define REASON_ERROR_INVALID_DISKASSET "ErrorInvalidDiskasset"
#define REASON_ERROR_UNSUPPORTED_DISKASSET_VERSION "ErrorUnsupportedDiskAssetVersion"
#define REASON_ERROR_DISK_FULL "ErrorStorageFull"
#define REASON_ERROR_LOWLEVEL_IO_FAILURE "ErrorLowlevelIOFailure"
#define REASON_ERROR_POSITION_INVALID "ErrorPositionInvalid"
#define REASON_ERROR_DISK_OVERHEATED "ErrorStorageOverheated"
#define REASON_ERROR_HOST_UNREACHABLE "ErrorHostUnreachable"
#define REASON_ERROR_UNEXISTING_RESOURCE "ErrorUnexistingResource"
#define REASON_ERROR_NO_EXTERNAL_INPUT_SIGNAL "ErrorNoExternalInputSignal"

class IToiMediaService
{
public:
  struct TToiSessionInfo;
  
  typedef std::vector< TToiSessionInfo > TToiSessionSequence;
  
  struct TToiSessionInfo {
    IToiMediaSession::TToiSessionId Id;
    IToiMediaSession::TToiSessionType Type;
    std::string Url;
    IToiMediaSession::TToiState State;
    
    TToiSessionInfo() :
      Id(0), 
      Type(0), 
      Url(""), 
      State(IToiMediaSession::STATE_CONNECTING)  {   }
    
    TToiSessionInfo(
      const IToiMediaSession::TToiSessionId& _Id, 
      const IToiMediaSession::TToiSessionType& _Type, 
      const std::string& _Url, 
      const IToiMediaSession::TToiState& _State) :
        Id(_Id), 
        Type(_Type), 
        Url(_Url), 
        State(_State)
    {
    }
    
  };
  
  virtual ~IToiMediaService() { /* Empty */ }
  virtual void CreatePlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& playerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void CreatePipPlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& pipAddress) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TToiPermissionDeniedException, TIpcException) = 0;
  virtual void CreateRecorderInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& recorderAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void CreateConsumerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void EnumerateSessions(const IToiMediaSession::TToiSessionType& type, TToiSessionSequence& sessions) throw (TIpcException) = 0;
  virtual void OpenSession(const IToiApplicationService::TToiApplicationId& applicationId, const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIMEDIASERVICE \
virtual void CreatePlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& playerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiPermissionDeniedException); \
virtual void CreatePipPlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& pipAddress) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TToiPermissionDeniedException); \
virtual void CreateRecorderInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& recorderAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException); \
virtual void CreateConsumerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException); \
virtual void EnumerateSessions(const IToiMediaSession::TToiSessionType& type, TToiSessionSequence& sessions) throw (); \
virtual void OpenSession(const IToiApplicationService::TToiApplicationId& applicationId, const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

