/*
 *-----------------------------------------------------------------------------
 *
 * IToiOperationManager.h
 *
 * This file was created from .idlcpp/IToiOperationManager.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIOPERATIONMANAGER_H
#define ITOIOPERATIONMANAGER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiOperationManager
{
public:
  enum { OP_ERROR_FAILED = -1 };
  enum { OP_ERROR_CANCELLED = -2 };
  enum { OP_RESULT_NONE = 0 };
  struct TToiProperty;
  struct TToiOperationInfo;
  
  enum TToiOperationState
  {
    OPERATION_PENDING = 0,
    OPERATION_COMPLETED = 1,
    OPERATION_FAILED = 2
  };
  typedef int TToiOperationId;
  typedef int TToiOperationResult;
  typedef int TToiOperationError;
  typedef int TToiPropertyId;
  typedef std::string TToiPropertyValue;
  typedef std::vector< TToiProperty > TToiPropertySequence;
  
  struct TToiProperty {
    TToiPropertyId Id;
    TToiPropertyValue Value;
    
    TToiProperty() :
      Id(0), 
      Value("")  {   }
    
    TToiProperty(
      const TToiPropertyId& _Id, 
      const TToiPropertyValue& _Value) :
        Id(_Id), 
        Value(_Value)
    {
    }
    
  };
  
  struct TToiOperationInfo {
    TToiOperationId Id;
    std::string UserData;
    TToiOperationState State;
    int Progress;
    TToiOperationError ErrorCode;
    TToiPropertySequence Properties;
    
    TToiOperationInfo() :
      Id(0), 
      UserData(""), 
      State(OPERATION_PENDING), 
      Progress(0), 
      ErrorCode(0)  {   }
    
    TToiOperationInfo(
      const TToiOperationId& _Id, 
      const std::string& _UserData, 
      const TToiOperationState& _State, 
      const int& _Progress, 
      const TToiOperationError& _ErrorCode, 
      const TToiPropertySequence& _Properties) :
        Id(_Id), 
        UserData(_UserData), 
        State(_State), 
        Progress(_Progress), 
        ErrorCode(_ErrorCode), 
        Properties(_Properties)
    {
    }
    
  };
  
  virtual ~IToiOperationManager() { /* Empty */ }
  virtual void CreateOperation(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& userData, TToiOperationId& operationId) throw (TToiNotEnoughResourcesException, TIpcException) = 0;
  virtual void CancelOperation(const TToiOperationId& operationId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseOperation(const TToiOperationId& operationId) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetOperationInfo(const TToiOperationId& operationId, TToiOperationInfo& operationInfo) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIOPERATIONMANAGER \
virtual void CreateOperation(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& userData, TToiOperationId& operationId) throw (TToiNotEnoughResourcesException); \
virtual void CancelOperation(const TToiOperationId& operationId) throw (TToiInvalidArgumentException); \
virtual void ReleaseOperation(const TToiOperationId& operationId) throw (TToiInvalidArgumentException); \
virtual void GetOperationInfo(const TToiOperationId& operationId, TToiOperationInfo& operationInfo) throw (TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

