/*
 *-----------------------------------------------------------------------------
 *
 * IToiPlatformService.h
 *
 * This file was created from .idlcpp/IToiPlatformService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIPLATFORMSERVICE_H
#define ITOIPLATFORMSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidPreconditionException.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiPlatformService
{
public:
  struct TToiComponentInfo;
  
  enum TToiResetFlag
  {
    REFORMAT_INTERNAL_HDD = 0x1,
    REMOVE_PERSISTENT_COOKIES = 0x2,
    REMOVE_PORTAL_DATABASES = 0x4,
    REMOVE_PERSISTENT_INFORMATION_OBJECTS = 0x8,
    RESET_TR069_DATA_MODEL = 0x10,
    CUSTOM_POST_PROCEDURE = 0x20,
    REMOVE_CHANNELS = 0x40,
    FULL_RESET = 0xff
  };
  enum TToiComponentState
  {
    COMPONENT_STATE_INACTIVE = 0x1,
    COMPONENT_STATE_PENDING_INACTIVE = 0x2,
    COMPONENT_STATE_PENDING_ACTIVE = 0x3,
    COMPONENT_STATE_ACTIVE = 0x4
  };
  typedef std::vector< TToiComponentInfo > TToiComponentInfoSequence;
  
  struct TToiComponentInfo {
    std::string Name;
    bool IsDynamic;
    TToiComponentState State;
    
    TToiComponentInfo() :
      Name(""), 
      IsDynamic(false), 
      State(COMPONENT_STATE_INACTIVE)  {   }
    
    TToiComponentInfo(
      const std::string& _Name, 
      const bool& _IsDynamic, 
      const TToiComponentState& _State) :
        Name(_Name), 
        IsDynamic(_IsDynamic), 
        State(_State)
    {
    }
    
  };
  
  virtual ~IToiPlatformService() { /* Empty */ }
  virtual void RebootNow() throw (TIpcException) = 0;
  virtual void RebootAtNextStandby() throw (TIpcException) = 0;
  virtual void SetStandby(const bool& mode) throw (TIpcException) = 0;
  virtual void FactoryReset(const int& flags) throw (TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void RegisterComponentUsage(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& componentName, bool& active) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void ReleaseComponentUsage(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& componentName, bool& active) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void GetComponentsInfo(TToiComponentInfoSequence& infoSequence) throw (TIpcException) = 0;
  virtual void GetComponentInfo(const std::string& componentName, TToiComponentInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIPLATFORMSERVICE \
virtual void RebootNow() throw (); \
virtual void RebootAtNextStandby() throw (); \
virtual void SetStandby(const bool& mode) throw (); \
virtual void FactoryReset(const int& flags) throw (TToiOperationNotSupportedException); \
virtual void RegisterComponentUsage(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& componentName, bool& active) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void ReleaseComponentUsage(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& componentName, bool& active) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void GetComponentsInfo(TToiComponentInfoSequence& infoSequence) throw (); \
virtual void GetComponentInfo(const std::string& componentName, TToiComponentInfo& info) throw (TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

