/*
 *-----------------------------------------------------------------------------
 *
 * IToiSchedulerObserver.h
 *
 * This file was created from .idlcpp/IToiSchedulerObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOISCHEDULEROBSERVER_H
#define ITOISCHEDULEROBSERVER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiSchedulerService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiSchedulerObserver
{
public:
  
  
  virtual ~IToiSchedulerObserver() { /* Empty */ }
  virtual void OnScheduledStart(const IToiSchedulerService::TToiBooking& booking) throw (TIpcException) = 0;
  virtual void OnScheduledStop(const IToiSchedulerService::TToiBooking& booking) throw (TIpcException) = 0;
  virtual void OnScheduledTrigger(const IToiSchedulerService::TToiBooking& booking, const IToiSchedulerService::TToiDelta& delta) throw (TIpcException) = 0;
  virtual void OnBookingsAdded(const IToiSchedulerService::TToiBookingSequence& bookings) throw (TIpcException) = 0;
  virtual void OnBookingsRemoved(const IToiSchedulerService::TToiBookingSequence& bookings) throw (TIpcException) = 0;
  virtual void OnBookingsChanged(const IToiSchedulerService::TToiBookingSequence& bookings) throw (TIpcException) = 0;
  virtual void OnSeriesChanged(const IToiSchedulerService::TToiSeries& series) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOISCHEDULEROBSERVER \
virtual void OnScheduledStart(const IToiSchedulerService::TToiBooking& booking) throw (); \
virtual void OnScheduledStop(const IToiSchedulerService::TToiBooking& booking) throw (); \
virtual void OnScheduledTrigger(const IToiSchedulerService::TToiBooking& booking, const IToiSchedulerService::TToiDelta& delta) throw (); \
virtual void OnBookingsAdded(const IToiSchedulerService::TToiBookingSequence& bookings) throw (); \
virtual void OnBookingsRemoved(const IToiSchedulerService::TToiBookingSequence& bookings) throw (); \
virtual void OnBookingsChanged(const IToiSchedulerService::TToiBookingSequence& bookings) throw (); \
virtual void OnSeriesChanged(const IToiSchedulerService::TToiSeries& series) throw ();

#endif 

