/*
 *-----------------------------------------------------------------------------
 *
 * IToiSoftwareObserver.h
 *
 * This file was created from .idlcpp/IToiSoftwareObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOISOFTWAREOBSERVER_H
#define ITOISOFTWAREOBSERVER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiSoftwareService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiSoftwareObserver
{
public:
  
  enum TToiAddRefResult
  {
    ADDREF_COMPLETED = 0,
    ADDREF_REDUNDANT = 1,
    ADDREF_FAILED = 2
  };
  enum TToiReleaseResult
  {
    RELEASE_COMPLETED = 0,
    RELEASE_REDUNDANT = 1,
    RELEASE_FAILED = 2
  };
  
  virtual ~IToiSoftwareObserver() { /* Empty */ }
  virtual void OnIipAvailable(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType) throw (TIpcException) = 0;
  virtual void OnAddRefResponse(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType, const TToiAddRefResult& addRefResult) throw (TIpcException) = 0;
  virtual void OnReleaseResponse(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType, const TToiReleaseResult& releaseResult) throw (TIpcException) = 0;
  virtual void OnAddIipsResponse(const std::string& url, const bool& success) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOISOFTWAREOBSERVER \
virtual void OnIipAvailable(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType) throw (); \
virtual void OnAddRefResponse(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType, const TToiAddRefResult& addRefResult) throw (); \
virtual void OnReleaseResponse(const std::string& name, const IToiSoftwareService::TToiDependencyType& dependencyType, const TToiReleaseResult& releaseResult) throw (); \
virtual void OnAddIipsResponse(const std::string& url, const bool& success) throw ();

#endif 

