/*
 *-----------------------------------------------------------------------------
 *
 * IToiSoftwareService.h
 *
 * This file was created from .idlcpp/IToiSoftwareService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOISOFTWARESERVICE_H
#define ITOISOFTWARESERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiSoftwareService
{
public:
  
  enum TToiDependencyType
  {
    ROOTDISK = 0,
    EXECUTION = 1
  };
  
  virtual ~IToiSoftwareService() { /* Empty */ }
  virtual void AddIips(const std::string& iipDistributionUrl) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetIipFilter(const std::string& address, const std::string& iip) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void AreDependenciesFulfilled(const std::string& iipName, const TToiDependencyType& dependencyType, bool& fulfilled) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void AddRef(const std::string& iipName, const TToiDependencyType& dependencyType) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void Release(const std::string& iipName, const TToiDependencyType& dependencyType) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetContentVersion(const std::string& iipName, std::string& installedVersion, std::string& availableVersion) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOISOFTWARESERVICE \
virtual void AddIips(const std::string& iipDistributionUrl) throw (TToiInvalidArgumentException); \
virtual void SetIipFilter(const std::string& address, const std::string& iip) throw (TToiInvalidArgumentException); \
virtual void AreDependenciesFulfilled(const std::string& iipName, const TToiDependencyType& dependencyType, bool& fulfilled) throw (TToiInvalidArgumentException); \
virtual void AddRef(const std::string& iipName, const TToiDependencyType& dependencyType) throw (TToiInvalidArgumentException); \
virtual void Release(const std::string& iipName, const TToiDependencyType& dependencyType) throw (TToiInvalidArgumentException); \
virtual void GetContentVersion(const std::string& iipName, std::string& installedVersion, std::string& availableVersion) throw (TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

