/*
 *-----------------------------------------------------------------------------
 *
 * IToiStorageObserver.h
 *
 * This file was created from .idlcpp/IToiStorageObserver.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOISTORAGEOBSERVER_H
#define ITOISTORAGEOBSERVER_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/IToiStorageDevice.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiStorageObserver
{
public:
  
  
  virtual ~IToiStorageObserver() { /* Empty */ }
  virtual void OnDeviceConnected(const IToiStorageDevice::TToiStorageInfo& info) throw (TIpcException) = 0;
  virtual void OnDeviceDisconnected(const IToiStorageDevice::TToiStorageInfo& info) throw (TIpcException) = 0;
  virtual void OnDeviceSpinningChanged(const IToiStorageDevice::TToiStorageInfo& info) throw (TIpcException) = 0;
  virtual void OnDevicePartitionsChanged(const IToiStorageDevice::TToiStorageInfo& info) throw (TIpcException) = 0;
  virtual void OnDevicePartitionMountChanged(const IToiStorageDevice::TToiStorageInfo& info, const IToiStorageDevice::TToiPartitionInfo& partitionInfo) throw (TIpcException) = 0;
  virtual void OnDevicePartitionFull(const IToiStorageDevice::TToiStorageInfo& info, const IToiStorageDevice::TToiPartitionInfo& partitionInfo, const int64_t& spaceRequired) throw (TIpcException) = 0;
  virtual void OnDeviceTemperatureThresholdReached(const IToiStorageDevice::TToiStorageInfo& info, const std::string& thresholdName) throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOISTORAGEOBSERVER \
virtual void OnDeviceConnected(const IToiStorageDevice::TToiStorageInfo& info) throw (); \
virtual void OnDeviceDisconnected(const IToiStorageDevice::TToiStorageInfo& info) throw (); \
virtual void OnDeviceSpinningChanged(const IToiStorageDevice::TToiStorageInfo& info) throw (); \
virtual void OnDevicePartitionsChanged(const IToiStorageDevice::TToiStorageInfo& info) throw (); \
virtual void OnDevicePartitionMountChanged(const IToiStorageDevice::TToiStorageInfo& info, const IToiStorageDevice::TToiPartitionInfo& partitionInfo) throw (); \
virtual void OnDevicePartitionFull(const IToiStorageDevice::TToiStorageInfo& info, const IToiStorageDevice::TToiPartitionInfo& partitionInfo, const int64_t& spaceRequired) throw (); \
virtual void OnDeviceTemperatureThresholdReached(const IToiStorageDevice::TToiStorageInfo& info, const std::string& thresholdName) throw ();

#endif 

