/*
 *-----------------------------------------------------------------------------
 *
 * IToiStorageService.h
 *
 * This file was created from .idlcpp/IToiStorageService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOISTORAGESERVICE_H
#define ITOISTORAGESERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiOperationManager.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/IToiStorageDevice.h"
#include "interface/TToiFileException.h"
#include "interface/IToiStorageFile.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiStorageService
{
public:
  
  typedef std::vector< IToiStorageDevice::TToiStorageDeviceId > TToiStorageDeviceIdSequence;
  
  virtual ~IToiStorageService() { /* Empty */ }
  virtual void GetStorageOperationManager(std::string& address) throw (TIpcException) = 0;
  virtual void GetStorageDeviceIds(TToiStorageDeviceIdSequence& identifiers) throw (TIpcException) = 0;
  virtual void GetStorageDevice(const IToiStorageDevice::TToiStorageDeviceId& id, std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void Copy(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void Move(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void CreateFile(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& fileName, const IToiStorageFile::TToiStorageFileType& fileType, std::string& address) throw (TToiInvalidArgumentException, TToiFileException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOISTORAGESERVICE \
virtual void GetStorageOperationManager(std::string& address) throw (); \
virtual void GetStorageDeviceIds(TToiStorageDeviceIdSequence& identifiers) throw (); \
virtual void GetStorageDevice(const IToiStorageDevice::TToiStorageDeviceId& id, std::string& address) throw (TToiInvalidArgumentException); \
virtual void Copy(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException); \
virtual void Move(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException); \
virtual void CreateFile(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& fileName, const IToiStorageFile::TToiStorageFileType& fileType, std::string& address) throw (TToiInvalidArgumentException, TToiFileException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

