/*
 *-----------------------------------------------------------------------------
 *
 * IToiVideoOutputConfiguration.h
 *
 * This file was created from .idlcpp/IToiVideoOutputConfiguration.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIVIDEOOUTPUTCONFIGURATION_H
#define ITOIVIDEOOUTPUTCONFIGURATION_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiVideoOutputConfiguration
{
public:
  struct TToiVideoOutputCapabilityInfo;
  struct TToiVideoOutputInfo;
  struct TToiDisplayInfo;
  
  enum TToiColorSystem
  {
    COLOR_SYSTEM_NTSC_M = 0,
    COLOR_SYSTEM_NTSC_J = 1,
    COLOR_SYSTEM_PAL_B = 2,
    COLOR_SYSTEM_PAL_M = 3,
    COLOR_SYSTEM_PAL_N = 4,
    COLOR_SYSTEM_PAL_NC = 5
  };
  enum TToiVideoMode
  {
    NO_VIDEO_MODE = 0,
    VIDEO_MODE_480I60 = 1,
    VIDEO_MODE_576I50 = 2,
    VIDEO_MODE_480P60 = 3,
    VIDEO_MODE_576P50 = 4,
    VIDEO_MODE_720P50 = 5,
    VIDEO_MODE_720P60 = 6,
    VIDEO_MODE_1080I50 = 7,
    VIDEO_MODE_1080I60 = 8,
    VIDEO_MODE_1080P23976 = 9,
    VIDEO_MODE_1080P24 = 10,
    VIDEO_MODE_1080P25 = 11,
    VIDEO_MODE_1080P29970 = 12,
    VIDEO_MODE_1080P30 = 13,
    VIDEO_MODE_1080P50 = 14,
    VIDEO_MODE_1080P59940 = 15,
    VIDEO_MODE_1080P60 = 16
  };
  enum TToiScartMode
  {
    NO_SCART_MODE = 0,
    SCART_MODE_CVBS = 1,
    SCART_MODE_YC = 2,
    SCART_MODE_RGB_CVBS = 3
  };
  enum TToiColorSpace
  {
    NO_COLOR_SPACE = 0,
    DIGITAL_COLOR_SPACE_SRGB = 1,
    DIGITAL_COLOR_SPACE_YCBCR_444 = 2,
    DIGITAL_COLOR_SPACE_YCBCR_422 = 3,
    DIGITAL_COLOR_SPACE_XVYCC = 4,
    ANALOG_COLOR_SPACE_YPBPR = 5
  };
  enum TToiValueMode
  {
    NO_VALUE_MODE = 0,
    VALUE_MODE_ENABLED = 1,
    VALUE_MODE_DISABLED = 2
  };
  enum TToiVideoConnectionType
  {
    VIDEO_CONNECTION_TYPE_HDMI = 0,
    VIDEO_CONNECTION_TYPE_COMPONENT = 1,
    VIDEO_CONNECTION_TYPE_SCART = 2,
    VIDEO_CONNECTION_TYPE_COMPOSITE = 3,
    VIDEO_CONNECTION_TYPE_SVIDEO = 4,
    VIDEO_CONNECTION_TYPE_RF = 5
  };
  enum TToiVideoOutputType
  {
    VIDEO_OUTPUT_TYPE_HD = 0,
    VIDEO_OUTPUT_TYPE_SD = 1
  };
  enum TToiAspectRatio
  {
    ASPECT_RATIO_UNKNOWN = 0,
    ASPECT_RATIO_4_3 = 1,
    ASPECT_RATIO_16_9 = 2,
    ASPECT_RATIO_16_10 = 3
  };
  enum TToiDisplayStatus
  {
    DISPLAY_STATUS_UNKNOWN = 0,
    DISPLAY_STATUS_CONNECTED = 1,
    DISPLAY_STATUS_CONNECTED_CAPABILITIES_UNKNOWN = 2,
    DISPLAY_STATUS_DISCONNECTED = 3
  };
  enum TToiActiveFormatDescriptor
  {
    ACTIVE_FORMAT_UNKNOWN = 0,
    ACTIVE_FORMAT_16_9_TOP = 1,
    ACTIVE_FORMAT_14_9_TOP = 2,
    ACTIVE_FORMAT_MORE_THAN_16_9_CENTRE = 3,
    ACTIVE_FORMAT_SAME_AS_CODED = 4,
    ACTIVE_FORMAT_4_3_CENTRE = 5,
    ACTIVE_FORMAT_16_9_CENTRE = 6,
    ACTIVE_FORMAT_14_9_CENTRE = 7,
    ACTIVE_FORMAT_4_3_SHOOT_AND_PROTECT_14_9_CENTRE = 8,
    ACTIVE_FORMAT_16_9_SHOOT_AND_PROTECT_14_9_CENTRE = 9,
    ACTIVE_FORMAT_16_9_SHOOT_AND_PROTECT_4_3_CENTRE = 10
  };
  typedef std::vector< TToiColorSystem > TToiColorSystemSequence;
  typedef std::vector< TToiVideoMode > TToiVideoModeSequence;
  typedef std::vector< TToiScartMode > TToiScartModeSequence;
  typedef std::vector< TToiColorSpace > TToiColorSpaceSequence;
  typedef std::vector< TToiValueMode > TToiValueModeSequence;
  typedef unsigned int TToiVideoOutputId;
  typedef std::vector< TToiVideoOutputId > TToiVideoOutputIdSequence;
  
  struct TToiVideoOutputCapabilityInfo {
    TToiVideoOutputId Id;
    TToiVideoModeSequence VideoModes;
    TToiColorSpaceSequence ColorSpaceModes;
    TToiScartModeSequence ScartModes;
    TToiValueModeSequence ScartLoopThroughModes;
    TToiValueModeSequence DviModes;
    
    TToiVideoOutputCapabilityInfo() :
      Id(0)  {   }
    
    TToiVideoOutputCapabilityInfo(
      const TToiVideoOutputId& _Id, 
      const TToiVideoModeSequence& _VideoModes, 
      const TToiColorSpaceSequence& _ColorSpaceModes, 
      const TToiScartModeSequence& _ScartModes, 
      const TToiValueModeSequence& _ScartLoopThroughModes, 
      const TToiValueModeSequence& _DviModes) :
        Id(_Id), 
        VideoModes(_VideoModes), 
        ColorSpaceModes(_ColorSpaceModes), 
        ScartModes(_ScartModes), 
        ScartLoopThroughModes(_ScartLoopThroughModes), 
        DviModes(_DviModes)
    {
    }
    
  };
  
  struct TToiVideoOutputInfo {
    TToiVideoOutputId Id;
    TToiVideoOutputType OutputType;
    TToiVideoConnectionType ConnectionType;
    unsigned int Index;
    TToiVideoModeSequence AllowedVideoModes;
    TToiVideoMode VideoMode;
    TToiColorSpaceSequence AllowedColorSpaceModes;
    TToiColorSpace ColorSpace;
    TToiScartModeSequence AllowedScartModes;
    TToiScartMode ScartMode;
    TToiValueModeSequence AllowedScartLoopThroughModes;
    TToiValueMode ScartLoopThroughMode;
    TToiValueModeSequence AllowedDviModes;
    TToiValueMode DviMode;
    
    TToiVideoOutputInfo() :
      Id(0), 
      OutputType(VIDEO_OUTPUT_TYPE_HD), 
      ConnectionType(VIDEO_CONNECTION_TYPE_HDMI), 
      Index(0), 
      VideoMode(NO_VIDEO_MODE), 
      ColorSpace(NO_COLOR_SPACE), 
      ScartMode(NO_SCART_MODE), 
      ScartLoopThroughMode(NO_VALUE_MODE), 
      DviMode(NO_VALUE_MODE)  {   }
    
    TToiVideoOutputInfo(
      const TToiVideoOutputId& _Id, 
      const TToiVideoOutputType& _OutputType, 
      const TToiVideoConnectionType& _ConnectionType, 
      const unsigned int& _Index, 
      const TToiVideoModeSequence& _AllowedVideoModes, 
      const TToiVideoMode& _VideoMode, 
      const TToiColorSpaceSequence& _AllowedColorSpaceModes, 
      const TToiColorSpace& _ColorSpace, 
      const TToiScartModeSequence& _AllowedScartModes, 
      const TToiScartMode& _ScartMode, 
      const TToiValueModeSequence& _AllowedScartLoopThroughModes, 
      const TToiValueMode& _ScartLoopThroughMode, 
      const TToiValueModeSequence& _AllowedDviModes, 
      const TToiValueMode& _DviMode) :
        Id(_Id), 
        OutputType(_OutputType), 
        ConnectionType(_ConnectionType), 
        Index(_Index), 
        AllowedVideoModes(_AllowedVideoModes), 
        VideoMode(_VideoMode), 
        AllowedColorSpaceModes(_AllowedColorSpaceModes), 
        ColorSpace(_ColorSpace), 
        AllowedScartModes(_AllowedScartModes), 
        ScartMode(_ScartMode), 
        AllowedScartLoopThroughModes(_AllowedScartLoopThroughModes), 
        ScartLoopThroughMode(_ScartLoopThroughMode), 
        AllowedDviModes(_AllowedDviModes), 
        DviMode(_DviMode)
    {
    }
    
  };
  
  struct TToiDisplayInfo {
    std::string VendorId;
    TToiVideoOutputId VideoOutputId;
    TToiVideoModeSequence SupportedVideoModes;
    TToiVideoMode PreferredVideoMode;
    TToiAspectRatio AspectRatio;
    TToiDisplayStatus Status;
    bool HasOverriddenValues;
    TToiColorSpaceSequence SupportedColorSpaces;
    
    TToiDisplayInfo() :
      VendorId(""), 
      VideoOutputId(0), 
      PreferredVideoMode(NO_VIDEO_MODE), 
      AspectRatio(ASPECT_RATIO_UNKNOWN), 
      Status(DISPLAY_STATUS_UNKNOWN), 
      HasOverriddenValues(false)  {   }
    
    TToiDisplayInfo(
      const std::string& _VendorId, 
      const TToiVideoOutputId& _VideoOutputId, 
      const TToiVideoModeSequence& _SupportedVideoModes, 
      const TToiVideoMode& _PreferredVideoMode, 
      const TToiAspectRatio& _AspectRatio, 
      const TToiDisplayStatus& _Status, 
      const bool& _HasOverriddenValues, 
      const TToiColorSpaceSequence& _SupportedColorSpaces) :
        VendorId(_VendorId), 
        VideoOutputId(_VideoOutputId), 
        SupportedVideoModes(_SupportedVideoModes), 
        PreferredVideoMode(_PreferredVideoMode), 
        AspectRatio(_AspectRatio), 
        Status(_Status), 
        HasOverriddenValues(_HasOverriddenValues), 
        SupportedColorSpaces(_SupportedColorSpaces)
    {
    }
    
  };
  
  virtual ~IToiVideoOutputConfiguration() { /* Empty */ }
  virtual void GetDisplayInfo(const TToiVideoOutputId& outputId, TToiDisplayInfo& info) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetColorSystems(TToiColorSystemSequence& colorSystems) throw (TIpcException) = 0;
  virtual void GetColorSystem(TToiColorSystem& colorSystem) throw (TIpcException) = 0;
  virtual void GetVideoOutputs(TToiVideoOutputIdSequence& identifiers) throw (TIpcException) = 0;
  virtual void GetVideoOutputInfo(const TToiVideoOutputId& outputId, TToiVideoOutputInfo& info) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetVideoOutputCapabilityInfo(const TToiVideoOutputId& outputId, TToiVideoOutputCapabilityInfo& info) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIVIDEOOUTPUTCONFIGURATION \
virtual void GetDisplayInfo(const TToiVideoOutputId& outputId, TToiDisplayInfo& info) throw (TToiInvalidArgumentException); \
virtual void GetColorSystems(TToiColorSystemSequence& colorSystems) throw (); \
virtual void GetColorSystem(TToiColorSystem& colorSystem) throw (); \
virtual void GetVideoOutputs(TToiVideoOutputIdSequence& identifiers) throw (); \
virtual void GetVideoOutputInfo(const TToiVideoOutputId& outputId, TToiVideoOutputInfo& info) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void GetVideoOutputCapabilityInfo(const TToiVideoOutputId& outputId, TToiVideoOutputCapabilityInfo& info) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

