/*
 *-----------------------------------------------------------------------------
 *
 * IToiVideoOutputConfigurationSession.h
 *
 * This file was created from .idlcpp/IToiVideoOutputConfigurationSession.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIVIDEOOUTPUTCONFIGURATIONSESSION_H
#define ITOIVIDEOOUTPUTCONFIGURATIONSESSION_H

#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiVideoOutputConfiguration.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiVideoOutputConfigurationSession
  : public virtual IToiVideoOutputConfiguration
{
public:
  
  
  virtual ~IToiVideoOutputConfigurationSession() { /* Empty */ }
  virtual void SetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoModeSequence& modes, const IToiVideoOutputConfiguration::TToiAspectRatio& aspectRatio) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ResetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId) throw (TIpcException) = 0;
  virtual void SetDefaultVideoMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetColorSpace(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiColorSpace& colorSpace) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetScartMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiScartMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetScartLoopThroughMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetDviMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void SetColorSystem(const IToiVideoOutputConfiguration::TToiColorSystem& colorSystem) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void Revert() throw (TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void Clear() throw (TIpcException) = 0;
  virtual void Apply() throw (TToiOperationNotSupportedException, TIpcException) = 0;
  virtual void ReleaseInstance() throw (TIpcException) = 0;
};



#define IMPLEMENTS_ITOIVIDEOOUTPUTCONFIGURATIONSESSION \
virtual void SetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoModeSequence& modes, const IToiVideoOutputConfiguration::TToiAspectRatio& aspectRatio) throw (TToiInvalidArgumentException); \
virtual void ResetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId) throw (); \
virtual void SetDefaultVideoMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void SetColorSpace(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiColorSpace& colorSpace) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void SetScartMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiScartMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void SetScartLoopThroughMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void SetDviMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void SetColorSystem(const IToiVideoOutputConfiguration::TToiColorSystem& colorSystem) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException); \
virtual void Revert() throw (TToiOperationNotSupportedException); \
virtual void Clear() throw (); \
virtual void Apply() throw (TToiOperationNotSupportedException); \
virtual void ReleaseInstance() throw ();

#endif 

