/*
 *-----------------------------------------------------------------------------
 *
 * IToiVideoOutputService.h
 *
 * This file was created from .idlcpp/IToiVideoOutputService.idl
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the AbstractHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef ITOIVIDEOOUTPUTSERVICE_H
#define ITOIVIDEOOUTPUTSERVICE_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiInvalidPreconditionException.h"
#include "interface/TToiNotEnoughResourcesException.h"
#include "interface/TToiOperationNotSupportedException.h"
#include "interface/TToiUnhandledValueException.h"
#include "interface/IToiApplicationService.h"
#include "interface/IToiVideoOutputConfiguration.h"

#include "ipc/TDispatchableExceptionTemplate.h"
#include "ipc/TIpcException.h"

#include <stdint.h>
#include <cstring>
#include <string>
#include <vector>






class IToiVideoOutputService
{
public:
  struct TToiAdaptiveTransition;
  
  typedef std::vector< TToiAdaptiveTransition > TToiAdaptiveTransitionSequence;
  typedef std::vector< std::string > TToiAdaptiveRuleSetNameSequence;
  
  struct TToiAdaptiveTransition {
    bool Matched;
    std::string RuleSetName;
    std::string RuleName;
    
    TToiAdaptiveTransition() :
      Matched(false), 
      RuleSetName(""), 
      RuleName("")  {   }
    
    TToiAdaptiveTransition(
      const bool& _Matched, 
      const std::string& _RuleSetName, 
      const std::string& _RuleName) :
        Matched(_Matched), 
        RuleSetName(_RuleSetName), 
        RuleName(_RuleName)
    {
    }
    
  };
  
  virtual ~IToiVideoOutputService() { /* Empty */ }
  virtual void GetVideoConfiguration(std::string& address) throw (TIpcException) = 0;
  virtual void CreateVideoConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void SetVideoSafeMode() throw (TToiInvalidPreconditionException, TIpcException) = 0;
  virtual void LoadAdaptiveRuleSets(const TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TToiNotEnoughResourcesException, TToiInvalidArgumentException, TIpcException) = 0;
  virtual void GetAvailableAdaptiveRuleSetNames(TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TIpcException) = 0;
  virtual void GetLoadedAdaptiveRuleSetNames(TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TIpcException) = 0;
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException) = 0;
};



#define IMPLEMENTS_ITOIVIDEOOUTPUTSERVICE \
virtual void GetVideoConfiguration(std::string& address) throw (); \
virtual void CreateVideoConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException); \
virtual void SetVideoSafeMode() throw (TToiInvalidPreconditionException); \
virtual void LoadAdaptiveRuleSets(const TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TToiNotEnoughResourcesException, TToiInvalidArgumentException); \
virtual void GetAvailableAdaptiveRuleSetNames(TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (); \
virtual void GetLoadedAdaptiveRuleSetNames(TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (); \
virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException); \
virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException);

#endif 

