/*
 *-----------------------------------------------------------------------------
 *
 * TApplicationServiceCaller.h
 * 
 * This file was created from "IApplicationService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TAPPLICATIONSERVICECALLER_H
#define TAPPLICATIONSERVICECALLER_H

#include "interface/IApplicationService.h"
#include "interface/TToiApplicationServiceCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TApplicationServiceCaller : public TToiApplicationServiceCaller, public virtual IApplicationService
{
private:
  static const char* const _InterfaceName;
public:
  TApplicationServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  // IApplicationService
  virtual void RegisterObserverInternal(const std::string& address, IApplicationService::TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserverInternal(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReportInstanceFailure(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void StartInstance(const IToiApplicationService::TToiApplicationId& applicationId, const IApplicationService::TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseInstance(const IToiApplicationService::TToiApplicationId& applicationId, const IApplicationService::TObserverId& observerId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetEnvironment(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetApplicationPid(const IToiApplicationService::TToiApplicationId& applicationId, int& pid) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RegisterFactoryResetHandler(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void FactoryResetHandlerDone(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
};

#endif // TAPPLICATIONSERVICECALLER_H
