/*
 *-----------------------------------------------------------------------------
 *
 * TMediaServiceCaller.h
 * 
 * This file was created from "IMediaService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TMEDIASERVICECALLER_H
#define TMEDIASERVICECALLER_H

#include "interface/IMediaService.h"
#include "interface/TToiMediaServiceCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TMediaServiceCaller : public TToiMediaServiceCaller, public virtual IMediaService
{
private:
  static const char* const _InterfaceName;
public:
  TMediaServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  // IMediaService
  virtual void OpenSessionInternal(const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException, TIpcException);
  virtual void CreateRecorderInstanceInternal(std::string& recorderAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void CreateDistributorInstanceInternal(std::string& distributorAddress) throw (TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void RegisterObserverInternal(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void CreateConsumerInstanceInternal(std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void CreatePlayerInstanceInternal(std::string& playerAddress) throw (TToiNotEnoughResourcesException, TIpcException);
};

#endif // TMEDIASERVICECALLER_H
