/*
 *-----------------------------------------------------------------------------
 *
 * TPlatformServiceCaller.h
 * 
 * This file was created from "IPlatformService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TPLATFORMSERVICECALLER_H
#define TPLATFORMSERVICECALLER_H

#include "interface/IPlatformService.h"
#include "interface/TToiPlatformServiceCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TPlatformServiceCaller : public TToiPlatformServiceCaller, public virtual IPlatformService
{
private:
  static const char* const _InterfaceName;
public:
  TPlatformServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  // IPlatformService
  virtual void ReportComponent(const int& serviceId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnloadDone(const int& serviceId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReportPing(const int& serviceId) throw (TIpcException);
  virtual void ClearFlash() throw (TIpcException);
  virtual void IsInStandby(bool& value) throw (TIpcException);
  virtual void GetStartupType(IPlatformService::TStartupType& type) throw (TIpcException);
  virtual void RestartPlatformNow() throw (TIpcException);
  virtual void RegisterFactoryResetHandler(const std::string& address, int& handlerId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnregisterFactoryResetHandler(const int& handlerId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void FactoryResetHandlerDone(const int& handlerId) throw (TIpcException);
};

#endif // TPLATFORMSERVICECALLER_H
