/*
 *-----------------------------------------------------------------------------
 *
 * TToiApplicationServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiApplicationService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIAPPLICATIONSERVICECALLER_H
#define TTOIAPPLICATIONSERVICECALLER_H

#include "interface/IToiApplicationService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiApplicationServiceCaller : public TIpcCaller, public virtual IToiApplicationService
{
private:
  static const char* const _InterfaceName;
public:
  TToiApplicationServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void RegisterApplication(const std::string& propertyFilename) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReportStarted(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReportPing(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void Activate(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ActivateWithUri(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& uri, const std::string& mimeType) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ActivateWithCommand(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& command) throw (TToiInvalidArgumentException, TIpcException);
  virtual void Deactivate(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void Kill(const IToiApplicationService::TToiApplicationId& applicationId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetOwnApplicationId(IToiApplicationService::TToiApplicationId& applicationId) throw (TIpcException);
  virtual void GetApplicationIds(IToiApplicationService::TToiApplicationIdSequence& applicationIds) throw (TIpcException);
  virtual void GetBoolProperty(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& property, bool& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetIntProperty(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& property, int& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetStringProperty(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& property, std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetStringSequenceProperty(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& property, IToiApplicationService::TToiPropertyStringSequence& values) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetInfo(const IToiApplicationService::TToiApplicationId& applicationId, IToiApplicationService::TToiApplicationInfo& info) throw (TToiInvalidArgumentException, TIpcException);
  virtual void LoadUri(const std::string& uri, const std::string& mimeType) throw (TToiUnhandledValueException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
