/*
 *-----------------------------------------------------------------------------
 *
 * TToiAssetManagerServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiAssetManagerService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIASSETMANAGERSERVICECALLER_H
#define TTOIASSETMANAGERSERVICECALLER_H

#include "interface/IToiAssetManagerService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiAssetManagerServiceCaller : public TIpcCaller, public virtual IToiAssetManagerService
{
private:
  static const char* const _InterfaceName;
public:
  TToiAssetManagerServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetAssetOperationManager(std::string& address) throw (TIpcException);
  virtual void CreateDirectory(const IToiAssetManagerService::TToiDirectoryId& parentId, const std::string& title, IToiAssetManagerService::TToiDirectoryId& dirId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void MoveDirectory(const IToiAssetManagerService::TToiDirectoryId& dirId, const IToiAssetManagerService::TToiDirectoryId& newParentId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetDirectoryProperties(const IToiAssetManagerService::TToiDirectoryId& dirId, const IToiAssetManagerService::TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemoveDirectoryProperties(const IToiAssetManagerService::TToiDirectoryId& dirId, const IToiAssetManagerService::TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemoveDirectory(const IToiAssetManagerService::TToiDirectoryId& dirId, const bool& recursiveFlag, const bool& removeAssetsFlag) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException);
  virtual void GetDirectoryInfo(const IToiAssetManagerService::TToiDirectoryId& dirId, IToiAssetManagerService::TToiDirectoryInfo& info) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetDirectories(const IToiAssetManagerService::TToiDirectoryId& dirId, IToiAssetManagerService::TToiDirectoryIdSequence& childDirIds) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetDefinedProperties(IToiAssetManagerService::TToiPropertyIdSequence& properties) throw (TIpcException);
  virtual void GetPropertyDefinition(const IToiAssetManagerService::TToiPropertyId& propertyId, IToiAssetManagerService::TToiPropertyDefinition& definition) throw (TToiInvalidArgumentException, TIpcException);
  virtual void CreatePropertyDefinition(const IToiAssetManagerService::TToiPropertyId& propertyId, const IToiAssetManagerService::TToiPropertyType& type, const bool& hasMultipleValueSupport) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemovePropertyDefinition(const IToiAssetManagerService::TToiPropertyId& propertyId) throw (TToiInvalidArgumentException, TIpcException);
  virtual void CreateAsset(const IToiAssetManagerService::TToiAssetType& assetType, IToiAssetManagerService::TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void ImportAsset(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiAssetId& assetId, const std::string& uri, const IToiAssetManagerService::TToiImportPolicy& importPolicy) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException);
  virtual void RemoveAsset(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiAssetId& assetId) throw (TToiInvalidArgumentException, TToiNoDataException, TToiPermissionDeniedException, TIpcException);
  virtual void CopyAsset(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiAssetId& sourceAssetId, const unsigned int& startOffset, const unsigned int& duration, const IToiAssetManagerService::TToiAssetId& destinationAssetId) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException);
  virtual void LinkAssets(const IToiAssetManagerService::TToiDirectoryId& dirId, const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnlinkAssets(const IToiAssetManagerService::TToiDirectoryId& dirId, const IToiAssetManagerService::TToiAssetIdSequence& assetIds) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RunQuery(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiQueryConditionSequence& queryConditions, const IToiAssetManagerService::TToiPropertyIdSequence& requestedProperties, const IToiAssetManagerService::TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void RunQueryForDirectory(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiDirectoryId& directoryId, const IToiAssetManagerService::TToiQueryConditionSequence& queryConditions, const IToiAssetManagerService::TToiPropertyIdSequence& requestedProperties, const IToiAssetManagerService::TToiSortConditionSequence& sortConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void RunCountQuery(const IToiOperationManager::TToiOperationId& operationId, const IToiAssetManagerService::TToiQueryConditionSequence& queryConditions) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void GetAssetInfoResult(const IToiOperationManager::TToiOperationId& operationId, const unsigned int& maxCount, IToiAssetManagerService::TToiAssetInfoSequence& objects, bool& hasMore) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException);
  virtual void GetLongResult(const IToiOperationManager::TToiOperationId& operationId, unsigned int& value) throw (TToiInvalidArgumentException, TToiNoDataException, TIpcException);
  virtual void GetProperties(const IToiAssetManagerService::TToiAssetId& assetId, const IToiAssetManagerService::TToiPropertyIdSequence& requestedProperties, IToiAssetManagerService::TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException);
  virtual void GetAllProperties(const IToiAssetManagerService::TToiAssetId& assetId, IToiAssetManagerService::TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException);
  virtual void SetProperties(const IToiAssetManagerService::TToiAssetId& id, const IToiAssetManagerService::TToiPropertySequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException);
  virtual void RemoveProperties(const IToiAssetManagerService::TToiAssetId& id, const IToiAssetManagerService::TToiPropertyIdSequence& properties) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException);
  virtual void RemoveMultiValuedPropertyValue(const IToiAssetManagerService::TToiAssetId& id, const IToiAssetManagerService::TToiProperty& property) throw (TToiInvalidArgumentException, TToiNoDataException, TToiNotEnoughResourcesException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
