/*
 *-----------------------------------------------------------------------------
 *
 * TToiAudioOutputServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiAudioOutputService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIAUDIOOUTPUTSERVICECALLER_H
#define TTOIAUDIOOUTPUTSERVICECALLER_H

#include "interface/IToiAudioOutputService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiAudioOutputServiceCaller : public TIpcCaller, public virtual IToiAudioOutputService
{
private:
  static const char* const _InterfaceName;
public:
  TToiAudioOutputServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetConnections(IToiAudioOutputService::TToiAudioConnectionDescriptorSequence& connectionList) throw (TIpcException);
  virtual void GetConfiguration(std::string& address) throw (TIpcException);
  virtual void CreateConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException);
  virtual void SetVolume(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, const unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void GetVolume(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, unsigned int& level) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void SetMuteState(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, const bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void GetMuteState(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, bool& state) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void SetLatency(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, const int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void GetLatency(const IToiAudioOutputService::TToiAudioConnectionId& connectionId, int& latency) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
