/*
 *-----------------------------------------------------------------------------
 *
 * TToiDvbEitCacheCaller.h
 * 
 * This file was created from ".idlcpp/IToiDvbEitCache.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIDVBEITCACHECALLER_H
#define TTOIDVBEITCACHECALLER_H

#include "interface/IToiDvbEitCache.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiDvbEitCacheCaller : public TIpcCaller, public virtual IToiDvbEitCache
{
private:
  static const char* const _InterfaceName;
public:
  TToiDvbEitCacheCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void SetFilterMode(const int& filterMode) throw (TIpcException);
  virtual void ClearServices() throw (TIpcException);
  virtual void ClearEvents() throw (TIpcException);
  virtual void AddService(const IToiDvbEitCache::TToiServiceItem& service) throw (TIpcException);
  virtual void GetEvents(const IToiDvbEitCache::TToiServiceItem& service, const unsigned int& time, const int& duration, IToiDvbEitCache::TToiEventInfoSequence& infoSequence, bool& more) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetPresentEvent(const IToiDvbEitCache::TToiServiceItem& service, IToiDvbEitCache::TToiEventInfo& event) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetFollowingEvent(const IToiDvbEitCache::TToiServiceItem& service, IToiDvbEitCache::TToiEventInfo& event) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetPrivateData(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, uint8_t* privData, int& privDataDataSize, const int& privDataMaxSize) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetExtendedEventInfo(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, IToiDvbEitCache::TToiExtendedEventInfo& eventInfo) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetEventItemInfo(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, IToiDvbEitCache::TToiEventItemInfoSequence& eventItems) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetVideoComponentList(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, IToiDvbEitCache::TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetAudioComponentList(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, const IToiDvbEitCache::TToiLanguageCode& languageCode, IToiDvbEitCache::TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSubtitleComponentList(const IToiDvbEitCache::TToiServiceItem& service, const int& eventId, const IToiDvbEitCache::TToiLanguageCode& languageCode, IToiDvbEitCache::TToiComponentSequence& components) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseInstance() throw (TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
