/*
 *-----------------------------------------------------------------------------
 *
 * TToiFrontendServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiFrontendService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIFRONTENDSERVICECALLER_H
#define TTOIFRONTENDSERVICECALLER_H

#include "interface/IToiFrontendService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiFrontendServiceCaller : public TIpcCaller, public virtual IToiFrontendService
{
private:
  static const char* const _InterfaceName;
public:
  TToiFrontendServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetOperationManager(std::string& address) throw (TIpcException);
  virtual void CreateDvbTScanner(const IToiApplicationService::TToiApplicationId& applicationId, const IToiFrontendService::TToiFrontendId& frontendId, std::string& scannerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void CreateDvbCScanner(const IToiApplicationService::TToiApplicationId& applicationId, const IToiFrontendService::TToiFrontendId& frontendId, std::string& scannerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void CreateFrontendDownloader(const IToiApplicationService::TToiApplicationId& applicationId, const IToiFrontendService::TToiFrontendId& frontendId, std::string& downloaderAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void GetFrontends(IToiFrontendService::TToiFrontendIdSequence& identifiers) throw (TToiOperationNotSupportedException, TIpcException);
  virtual void GetFrontendInfo(const IToiFrontendService::TToiFrontendId& frontendId, IToiFrontendService::TToiFrontendInfo& info) throw (TToiInvalidArgumentException, TToiNoDataException, TToiOperationNotSupportedException, TIpcException);
  virtual void GetFrontendInfoBySession(const IToiMediaSession::TToiSessionId& sessionId, IToiFrontendService::TToiFrontendInfo& info) throw (TToiInvalidArgumentException, TToiNoDataException, TToiOperationNotSupportedException, TIpcException);
};

#endif 
