/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaPlayerBaseCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaPlayerBase.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIAPLAYERBASECALLER_H
#define TTOIMEDIAPLAYERBASECALLER_H

#include "interface/IToiMediaPlayerBase.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaPlayerBaseCaller : public TIpcCaller, public virtual IToiMediaPlayerBase
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaPlayerBaseCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetState(IToiMediaPlayerBase::TToiState& state) throw (TIpcException);
  virtual void GetError(IToiMediaPlayerBase::TToiError& error) throw (TIpcException);
  virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException, TIpcException);
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException);
  virtual void GetStreamInfo(IToiMediaPlayerBase::TToiStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void GetVideoStreamInfo(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent, IToiMediaPlayerBase::TToiVideoStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void GetAudioStreamInfo(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent, IToiMediaPlayerBase::TToiAudioStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void GetSubtitleStreamInfo(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent, IToiMediaPlayerBase::TToiSubtitleStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void GetTeletextStreamInfo(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent, IToiMediaPlayerBase::TToiTeletextStreamInfo& streamInfo) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void GetCapabilities(int& capabilityMask) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void GetPosition(int& position) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException);
  virtual void GetPace(int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException);
  virtual void IsTimeshiftPlayback(bool& timeshiftPlayback) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void GetTimeshiftInfo(IToiMediaPlayerBase::TToiTimeshiftInfo& timeshiftInfo) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void GetTimeshiftError(IToiMediaPlayerBase::TToiError& timeshiftError) throw (TIpcException);
  virtual void GetActiveComponents(IToiMediaPlayerBase::TToiComponentSequence& components) throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void ReleaseInstance() throw (TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
