/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaPlayerCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaPlayer.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIAPLAYERCALLER_H
#define TTOIMEDIAPLAYERCALLER_H

#include "interface/IToiMediaPlayer.h"
#include "interface/TToiMediaPlayerBaseCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaPlayerCaller : public TToiMediaPlayerBaseCaller, public virtual IToiMediaPlayer
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaPlayerCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void Open(const std::string& url) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void Close() throw (TToiSessionViolationException, TToiUnavailableException, TIpcException);
  virtual void Play(const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException);
  virtual void PlayFromPosition(const int& position, const int& pace) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void StartTimeshiftBuffering(const int& maxBufferLength) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiInvalidPreconditionException, TToiOperationNotSupportedException, TToiUnavailableException, TIpcException);
  virtual void StopTimeshiftBuffering() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException, TIpcException);
  virtual void DiscardTimeshiftBuffer() throw (TToiSessionViolationException, TToiInvalidPreconditionException, TToiUnavailableException, TIpcException);
  virtual void ActivateComponent(const IToiMediaPlayerBase::TToiComponentEntry& mediaComponent) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void DeactivateComponent(const IToiMediaPlayerBase::TToiComponentType& mediaType) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void SetAudioChannelMode(const int& streamId, const IToiMediaPlayerBase::TToiAudioChannelMode& channelMode) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiUnavailableException, TIpcException);
  virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException, TIpcException);
  virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TToiUnavailableException, TIpcException);
};

#endif 
