/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaRecorderBaseCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaRecorderBase.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIARECORDERBASECALLER_H
#define TTOIMEDIARECORDERBASECALLER_H

#include "interface/IToiMediaRecorderBase.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaRecorderBaseCaller : public TIpcCaller, public virtual IToiMediaRecorderBase
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaRecorderBaseCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetState(IToiMediaRecorderBase::TToiMediaRecorderState& state) throw (TIpcException);
  virtual void GetSessionId(IToiMediaSession::TToiSessionId& id) throw (TToiSessionViolationException, TIpcException);
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException);
  virtual void GetAssetId(std::string& assetId) throw (TToiSessionViolationException, TIpcException);
  virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseInstance() throw (TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
