/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaRecorderCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaRecorder.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIARECORDERCALLER_H
#define TTOIMEDIARECORDERCALLER_H

#include "interface/IToiMediaRecorder.h"
#include "interface/TToiMediaRecorderBaseCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaRecorderCaller : public TToiMediaRecorderBaseCaller, public virtual IToiMediaRecorder
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaRecorderCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void Open(const std::string& url, const std::string& assetId) throw (TToiSessionViolationException, TToiInvalidArgumentException, TToiBusyException, TToiUnavailableException, TToiInvalidPreconditionException, TIpcException);
  virtual void Close() throw (TToiSessionViolationException, TIpcException);
  virtual void Record() throw (TToiSessionViolationException, TToiOperationNotSupportedException, TIpcException);
  virtual void RecordAt(const unsigned int& offset) throw (TToiSessionViolationException, TToiOperationNotSupportedException, TIpcException);
  virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException);
  virtual void UnsetParameter(const std::string& name) throw (TToiInvalidArgumentException, TToiPermissionDeniedException, TIpcException);
};

#endif 
