/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIASERVICECALLER_H
#define TTOIMEDIASERVICECALLER_H

#include "interface/IToiMediaService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaServiceCaller : public TIpcCaller, public virtual IToiMediaService
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void CreatePlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& playerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiPermissionDeniedException, TIpcException);
  virtual void CreatePipPlayerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& pipAddress) throw (TToiInvalidArgumentException, TToiOperationNotSupportedException, TToiPermissionDeniedException, TIpcException);
  virtual void CreateRecorderInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& recorderAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiOperationNotSupportedException, TIpcException);
  virtual void CreateConsumerInstance(const IToiApplicationService::TToiApplicationId& applicationId, std::string& consumerAddress) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void EnumerateSessions(const IToiMediaSession::TToiSessionType& type, IToiMediaService::TToiSessionSequence& sessions) throw (TIpcException);
  virtual void OpenSession(const IToiApplicationService::TToiApplicationId& applicationId, const IToiMediaSession::TToiSessionId& sessionId, std::string& sessionAddress) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
