/*
 *-----------------------------------------------------------------------------
 *
 * TToiMediaSessionCaller.h
 * 
 * This file was created from ".idlcpp/IToiMediaSession.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIMEDIASESSIONCALLER_H
#define TTOIMEDIASESSIONCALLER_H

#include "interface/IToiMediaSession.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiMediaSessionCaller : public TIpcCaller, public virtual IToiMediaSession
{
private:
  static const char* const _InterfaceName;
public:
  TToiMediaSessionCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetId(IToiMediaSession::TToiSessionId& id) throw (TIpcException);
  virtual void GetType(IToiMediaSession::TToiSessionType& type) throw (TToiSessionViolationException, TIpcException);
  virtual void GetUrl(std::string& url) throw (TToiSessionViolationException, TIpcException);
  virtual void GetState(IToiMediaSession::TToiState& state) throw (TIpcException);
  virtual void GetStreamInfo(IToiMediaSession::TToiStreamInfo& info) throw (TToiNoDataException, TToiSessionViolationException, TIpcException);
  virtual void GetAssetId(std::string& assetId) throw (TToiOperationNotSupportedException, TToiSessionViolationException, TIpcException);
  virtual void AddSectionDataRelay(const int& pid, const uint8_t* data, const uint8_t* include, const uint8_t* exclude, const int& length, const std::string& socketName, int& dataRelayId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiSessionViolationException, TIpcException);
  virtual void AddPacketDataRelay(const int& pid, const std::string& socketName, int& dataRelayId) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TToiSessionViolationException, TIpcException);
  virtual void RemoveDataRelay(const int& dataRelayId) throw (TToiInvalidArgumentException, TToiSessionViolationException, TIpcException);
  virtual void GetParameter(const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TToiSessionViolationException, TIpcException);
  virtual void SetParameter(const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TToiSessionViolationException, TIpcException);
  virtual void SubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiSessionViolationException, TIpcException);
  virtual void UnsubscribeParameter(const std::string& address, const std::string& name) throw (TToiInvalidArgumentException, TToiSessionViolationException, TIpcException);
  virtual void SetDecryptionCipher(const IToiMediaSession::TToiStreamIdSequence& streamIds, const IToiMediaSession::TToiCipher& cipher, const IToiMediaSession::TToiCipherBlockMode& blockMode, const IToiMediaSession::TToiCipherResidueMode& residueMode) throw (TToiOperationNotSupportedException, TToiSessionViolationException, TIpcException);
  virtual void SetDecryptionKeys(const IToiMediaSession::TToiStreamIdSequence& streamIds, const bool& isEncrypted, const uint8_t* evenKey, const uint8_t* evenIv, const uint8_t* oddKey, const uint8_t* oddIv, const int& length) throw (TToiOperationNotSupportedException, TToiSessionViolationException, TIpcException);
  virtual void ReleaseInstance() throw (TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
