/*
 *-----------------------------------------------------------------------------
 *
 * TToiSchedulerServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiSchedulerService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOISCHEDULERSERVICECALLER_H
#define TTOISCHEDULERSERVICECALLER_H

#include "interface/IToiSchedulerService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiSchedulerServiceCaller : public TIpcCaller, public virtual IToiSchedulerService
{
private:
  static const char* const _InterfaceName;
public:
  TToiSchedulerServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void Schedule(const std::string& category, const std::string& activity, const IToiSchedulerService::TToiTime& start, const int& duration, IToiSchedulerService::TToiBookingId& id) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void ScheduleSeries(const std::string& category, const std::string& activity, const IToiSchedulerService::TToiTime& start, const int& duration, const int& weekdays, const int& numberOfOccurrences, const IToiSchedulerService::TToiConflictStrategy& conflictStrategy, IToiSchedulerService::TToiSeriesId& id) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void Reschedule(const IToiSchedulerService::TToiBookingId& id, const std::string& category, const std::string& activity, const IToiSchedulerService::TToiTime& start, const int& duration) throw (TToiInvalidArgumentException, TToiNotEnoughResourcesException, TIpcException);
  virtual void Remove(const IToiSchedulerService::TToiBookingId& id) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemoveSeries(const IToiSchedulerService::TToiSeriesId& id) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetConflicts(const IToiSchedulerService::TToiBookingId& id, const std::string& category, const std::string& activity, const IToiSchedulerService::TToiTime& start, const int& duration, IToiSchedulerService::TToiConflictSequence& conflicts) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSeriesConflicts(const IToiSchedulerService::TToiSeriesId& id, const std::string& category, const std::string& activity, const IToiSchedulerService::TToiTime& start, const int& duration, const int& weekdays, const int& occurrence, IToiSchedulerService::TToiConflictSequence& conflicts) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetNextStartTime(const std::string& categoryExpression, IToiSchedulerService::TToiTime& nextStart) throw (TIpcException);
  virtual void GetBooking(const IToiSchedulerService::TToiBookingId& id, IToiSchedulerService::TToiBooking& booking) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSeries(const IToiSchedulerService::TToiSeriesId& id, IToiSchedulerService::TToiSeries& series) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetBookingIds(const std::string& categoryExpression, const IToiSchedulerService::TToiTime& start, const IToiSchedulerService::TToiTime& stop, IToiSchedulerService::TToiBookingIdSequence& bookings) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSeriesIds(const std::string& categoryExpression, IToiSchedulerService::TToiSeriesIdSequence& seriesIds) throw (TIpcException);
  virtual void GetBookingIdsForSeries(const IToiSchedulerService::TToiSeriesId& seriesId, IToiSchedulerService::TToiBookingIdSequence& bookings) throw (TToiInvalidArgumentException, TIpcException);
  virtual void AddTrigger(const IToiSchedulerService::TToiBookingId& id, const IToiSchedulerService::TToiDelta& delta) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemoveTrigger(const IToiSchedulerService::TToiBookingId& id, const IToiSchedulerService::TToiDelta& delta) throw (TToiInvalidArgumentException, TIpcException);
  virtual void AddTriggerOnBookings(const IToiSchedulerService::TToiBookingIdSequence& ids, const IToiSchedulerService::TToiDelta& delta) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RemoveTriggerOnBookings(const IToiSchedulerService::TToiBookingIdSequence& ids, const IToiSchedulerService::TToiDelta& delta) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetTriggers(const IToiSchedulerService::TToiBookingId& id, IToiSchedulerService::TToiDeltaSequence& deltas) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetParameter(const IToiSchedulerService::TToiBookingId& id, const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnsetParameter(const IToiSchedulerService::TToiBookingId& id, const std::string& name) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetParameter(const IToiSchedulerService::TToiBookingId& id, const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetParameterNames(const IToiSchedulerService::TToiBookingId& id, IToiSchedulerService::TToiParameterNameSequence& names) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetParametersOnBookings(const IToiSchedulerService::TToiBookingIdSequence& ids, const IToiSchedulerService::TToiParameterNameSequence& names, const IToiSchedulerService::TToiParameterValueSequence& values) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetSeriesParameter(const IToiSchedulerService::TToiSeriesId& id, const std::string& name, const std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void UnsetSeriesParameter(const IToiSchedulerService::TToiSeriesId& id, const std::string& name) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSeriesParameter(const IToiSchedulerService::TToiSeriesId& id, const std::string& name, std::string& value) throw (TToiInvalidArgumentException, TIpcException);
  virtual void GetSeriesParameterNames(const IToiSchedulerService::TToiSeriesId& id, IToiSchedulerService::TToiParameterNameSequence& names) throw (TToiInvalidArgumentException, TIpcException);
  virtual void SetCategorySubscription(const std::string& address, const std::string& categoryExpression) throw (TToiInvalidArgumentException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
