/*
 *-----------------------------------------------------------------------------
 *
 * TToiStorageDeviceCaller.h
 * 
 * This file was created from ".idlcpp/IToiStorageDevice.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOISTORAGEDEVICECALLER_H
#define TTOISTORAGEDEVICECALLER_H

#include "interface/IToiStorageDevice.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiStorageDeviceCaller : public TIpcCaller, public virtual IToiStorageDevice
{
private:
  static const char* const _InterfaceName;
public:
  TToiStorageDeviceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetStorageInfo(IToiStorageDevice::TToiStorageInfo& info) throw (TIpcException);
  virtual void GetPartitionInfo(const IToiStorageDevice::TToiPartitionId& partitionId, IToiStorageDevice::TToiPartitionInfo& info) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException);
  virtual void MountPartition(const IToiOperationManager::TToiOperationId& operationId, const IToiStorageDevice::TToiPartitionId& partitionId, const std::string& mountPoint) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException);
  virtual void UnmountPartition(const IToiOperationManager::TToiOperationId& operationId, const IToiStorageDevice::TToiPartitionId& partitionId) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException);
  virtual void Reformat(const IToiOperationManager::TToiOperationId& operationId) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TToiOperationNotSupportedException, TIpcException);
  virtual void ScheduleReformatOnNextReboot(const IToiStorageDevice::TToiPartitionId& partitionId) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void ScheduleFileSystemRepairOnNextReboot(const IToiStorageDevice::TToiPartitionId& partitionId) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SpinDown() throw (TToiInvalidPreconditionException, TIpcException);
  virtual void SpinUp() throw (TToiInvalidPreconditionException, TIpcException);
};

#endif 
