/*
 *-----------------------------------------------------------------------------
 *
 * TToiStorageServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiStorageService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOISTORAGESERVICECALLER_H
#define TTOISTORAGESERVICECALLER_H

#include "interface/IToiStorageService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiStorageServiceCaller : public TIpcCaller, public virtual IToiStorageService
{
private:
  static const char* const _InterfaceName;
public:
  TToiStorageServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetStorageOperationManager(std::string& address) throw (TIpcException);
  virtual void GetStorageDeviceIds(IToiStorageService::TToiStorageDeviceIdSequence& identifiers) throw (TIpcException);
  virtual void GetStorageDevice(const IToiStorageDevice::TToiStorageDeviceId& id, std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void Copy(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException, TIpcException);
  virtual void Move(const IToiOperationManager::TToiOperationId& operationId, const std::string& source, const std::string& target) throw (TToiInvalidArgumentException, TIpcException);
  virtual void CreateFile(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& fileName, const IToiStorageFile::TToiStorageFileType& fileType, std::string& address) throw (TToiInvalidArgumentException, TToiFileException, TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
