/*
 *-----------------------------------------------------------------------------
 *
 * TToiVideoOutputConfigurationSessionCaller.h
 * 
 * This file was created from ".idlcpp/IToiVideoOutputConfigurationSession.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIVIDEOOUTPUTCONFIGURATIONSESSIONCALLER_H
#define TTOIVIDEOOUTPUTCONFIGURATIONSESSIONCALLER_H

#include "interface/IToiVideoOutputConfigurationSession.h"
#include "interface/TToiVideoOutputConfigurationCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiVideoOutputConfigurationSessionCaller : public TToiVideoOutputConfigurationCaller, public virtual IToiVideoOutputConfigurationSession
{
private:
  static const char* const _InterfaceName;
public:
  TToiVideoOutputConfigurationSessionCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void SetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoModeSequence& modes, const IToiVideoOutputConfiguration::TToiAspectRatio& aspectRatio) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ResetDisplayInfo(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId) throw (TIpcException);
  virtual void SetDefaultVideoMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiVideoMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SetColorSpace(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiColorSpace& colorSpace) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SetScartMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiScartMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SetScartLoopThroughMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SetDviMode(const IToiVideoOutputConfiguration::TToiVideoOutputId& outputId, const IToiVideoOutputConfiguration::TToiValueMode& mode) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void SetColorSystem(const IToiVideoOutputConfiguration::TToiColorSystem& colorSystem) throw (TToiOperationNotSupportedException, TToiInvalidArgumentException, TIpcException);
  virtual void Revert() throw (TToiOperationNotSupportedException, TIpcException);
  virtual void Clear() throw (TIpcException);
  virtual void Apply() throw (TToiOperationNotSupportedException, TIpcException);
  virtual void ReleaseInstance() throw (TIpcException);
};

#endif 
