/*
 *-----------------------------------------------------------------------------
 *
 * TToiVideoOutputServiceCaller.h
 * 
 * This file was created from ".idlcpp/IToiVideoOutputService.idl"
 * by the Motorola IDL backend, which is based on the OmniORB IDL parser.
 *
 * This file was generated from the ServiceCallerHeader.tpl template.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TTOIVIDEOOUTPUTSERVICECALLER_H
#define TTOIVIDEOOUTPUTSERVICECALLER_H

#include "interface/IToiVideoOutputService.h"
#include "ipc/TIpcCaller.h"
#include "ipc/TIpcException.h"

#include <string>
#include <vector>

class TToiVideoOutputServiceCaller : public TIpcCaller, public virtual IToiVideoOutputService
{
private:
  static const char* const _InterfaceName;
public:
  TToiVideoOutputServiceCaller(TIpcClient* client,
    const std::string& objectAddress) throw ();
  
  
  virtual void GetVideoConfiguration(std::string& address) throw (TIpcException);
  virtual void CreateVideoConfigurationSession(const IToiApplicationService::TToiApplicationId& applicationId, std::string& address) throw (TToiInvalidArgumentException, TToiInvalidPreconditionException, TIpcException);
  virtual void SetVideoSafeMode() throw (TToiInvalidPreconditionException, TIpcException);
  virtual void LoadAdaptiveRuleSets(const IToiVideoOutputService::TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TToiNotEnoughResourcesException, TToiInvalidArgumentException, TIpcException);
  virtual void GetAvailableAdaptiveRuleSetNames(IToiVideoOutputService::TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TIpcException);
  virtual void GetLoadedAdaptiveRuleSetNames(IToiVideoOutputService::TToiAdaptiveRuleSetNameSequence& adaptiveRuleSets) throw (TIpcException);
  virtual void RegisterObserver(const IToiApplicationService::TToiApplicationId& applicationId, const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
  virtual void ReleaseObserver(const std::string& address) throw (TToiInvalidArgumentException, TIpcException);
};

#endif 
