/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IKreaTvGfxExtensionObserver.h
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */ 

#ifndef IKREATVGFXEXTENSIONOBSERVER_H
#define IKREATVGFXEXTENSIONOBSERVER_H

/** \class IKreaTvGfxExtensionObserver IKreaTvGfxExtensionObserver.h "kreatvgfx/IKreaTvGfxExtensionObserver.h"

    This interface needs to be implemented by applications that use
    extensions.

    \see IKreaTvGfxExtension
 */
class IKreaTvGfxExtensionObserver
{
protected:
  virtual ~IKreaTvGfxExtensionObserver() { /* Empty */ }

public:

  /** Callback when the extension has changed some graphics and wants
      to redraw. The application should tell the extension to draw
      when it finds it suitable.

      \param[in] extension
                        The extension that wants to draw.
      \see IKreaTvGfxExtension::Draw()
   */
  virtual void OnGraphicsChanged(IKreaTvGfxExtension* extension) throw () = 0;

};

#endif
