/* -*- mode: c++; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * IIpcDispatcher.h
 *
 * Copyright (c) 2010 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef IPC_IIPCDISPATCHER_H
#define IPC_IIPCDISPATCHER_H

#include <string>

class TBinIpcParameterStack;

class IIpcDispatcher
{
public:
  virtual ~IIpcDispatcher() {}
  virtual void SuspendEvents(bool suspend) = 0;
  virtual bool _Invoke(const char* interfaceName,
                       const char* methodName,
                       TBinIpcParameterStack* requestStack,
                       bool* errorResponse,
                       TBinIpcParameterStack* responseStack) throw () = 0;
  virtual const std::string GetAddress() const throw() = 0;
};

#endif /* IPC_IIPCDISPATCHER_H */
