/* -*- mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * IIpcEventHandler.h
 *
 *
 * Copyright (c) 2008 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef IIPCEVENTHANDLER_H_
#define IIPCEVENTHANDLER_H_

#include "event/IIOEventLoop.h"
#include "IIpcDispatcher.h"

class IIpcEventHandler
{
public:
  virtual ~IIpcEventHandler() {}

  virtual IIOEventLoop* GetEventLoop() = 0;
  virtual std::string CreateObject() throw () = 0;
  virtual void AddDispatcher(const std::string& address,
                             IIpcDispatcher* dispatcher) throw () = 0;
  virtual void RemoveDispatcher(const std::string& address,
                                IIpcDispatcher* dispatcher) throw () = 0;
  virtual void SuspendEvents(bool suspend) = 0;
  virtual int GetPeerPid() const throw () = 0;
  virtual int GetCallDescriptor() const throw () = 0;
  virtual int GetPeerUid() const throw () = 0;
  virtual int GetPeerGid() const throw () = 0;
};

#endif /* IIPCEVENTHANDLER_H_ */
