/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *-----------------------------------------------------------------------------
 *
 * ipc/TDispatchableException.h
 *
 * An exception base class used for exceptions that can be dispatched across
 * process boundaries.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef IPC_TDISPATCHABLEEXCEPTION_H
#define IPC_TDISPATCHABLEEXCEPTION_H

#include "base/TException.h"

#include <stdint.h>

#include <string>

typedef uint16_t TFaultCode;

class TDispatchableException : public TException
{
protected:
  TDispatchableException(const std::string& message) throw ();
  virtual ~TDispatchableException() throw ();

public:
  virtual TFaultCode GetCode() const throw () = 0;
};

inline
TDispatchableException::TDispatchableException(const std::string& message)
  throw () :
  TException(message)
{
  
}

inline TDispatchableException::~TDispatchableException() throw ()
{
  
}

#endif 
