/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *-----------------------------------------------------------------------------
 *
 * ipc/TDispatchableExceptionTemplate.h
 *
 * This template is used to automatically generate exceptions from IDL
 * declarations.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */
#ifndef IPC_TDISPATCHABLEEXCEPTIONTEMPLATE_H
#define IPC_TDISPATCHABLEEXCEPTIONTEMPLATE_H

#include "ipc/TDispatchableException.h"

template<TFaultCode TypeId>
class TDispatchableExceptionTemplate : public TDispatchableException
{
public:
  TDispatchableExceptionTemplate(const std::string& text) throw ();

  virtual TFaultCode GetCode() const throw ();
};

template<TFaultCode TypeId>
inline
TDispatchableExceptionTemplate<TypeId>::
TDispatchableExceptionTemplate(const std::string& message) throw () :
  TDispatchableException(message)
{
  
}

template<TFaultCode TypeId>
inline
TFaultCode TDispatchableExceptionTemplate<TypeId>::GetCode() const throw ()
{
  return TypeId;
}

#endif 
