/*
 *---------------------------------------------------------------------------
 *
 * ipc/TIpcClient.h
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef IPC_TIPCCLIENT_H
#define IPC_TIPCCLIENT_H

#include "cipc/TCIpcClient.h"
#include "ipc/TIpcException.h"

class TIpcClient
{
private:
  TCIpcClient Client;

public:
  static bool ValidateAddress(const std::string& address) throw ();

  TIpcClient() throw ();
  virtual ~TIpcClient() throw ();

  virtual void CloseConnections() throw ();

  virtual void AddCaller(const std::string& address) throw ();
  virtual void RemoveCaller(const std::string& address) throw ();
  
  virtual void InvokeOneway(const char* objectName,
                            const char* interfaceName,
                            const char* methodName,
                            TBinIpcParameterStack* requestStack)
    throw (TIpcException);
  virtual void Invoke(const char* objectName,
                      const char* interfaceName,
                      const char* methodName,
                      TBinIpcParameterStack* requestStack,
                      bool* errorResponse,
                      TBinIpcParameterStack* responseStack)
    throw (TIpcException);
};

#endif
