/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * ipc/TIpcDispatcher.h
 *
 * Copyright (c) 2009 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef IPC_TIPCDISPATCHER_H
#define IPC_TIPCDISPATCHER_H

#include "bin-ipc/TBinIpcParameterStack.h"
#include "IIpcDispatcher.h"

#include <cassert>
#include <string>

class IIpcEventHandler;

class TIpcDispatcher : public IIpcDispatcher
{
protected:
  IIpcEventHandler* _Server;
  std::string _ObjectAddress;

  
  static int _GetMethodIndex(const char* const methodTable[],
                             const char* methodName) throw ();

  TIpcDispatcher(IIpcEventHandler* server, const std::string& objectAddress,
                 void* /*implementation*/) throw ();
  virtual ~TIpcDispatcher() throw ();

public:
  virtual void SuspendEvents(bool suspend);

  virtual bool _Invoke(const char* interfaceName,
                       const char* methodName,
                       TBinIpcParameterStack* requestStack,
                       bool* errorResponse,
                       TBinIpcParameterStack* responseStack) throw ();
  virtual const std::string GetAddress() const throw();
};

#endif 
