/*
 *---------------------------------------------------------------------------
 *
 * Mpeg2Si.h
 *
 * Constants from ISO IEC 13818-1 and ISO IEC 13818-6
 *
 * Copyright (c) 2005 Kreatel Communications AB. All Rights Reserved.
 * Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef MPEG2SI_H
#define MPEG2SI_H

namespace Mpeg2Si
{
  enum TTableId {
    TABLE_PAT = 0x00,
    TABLE_CAT = 0x01,
    TABLE_PMT = 0x02,
    TABLE_TSDT = 0x03,
    TABLE_SCENE_DESCRIPTOR = 0x04,
    TABLE_OBJECT_DESCRIPTOR = 0x05,
    TABLE_MULTI_PROTOCOL_ENCAPSULATED_DATA = 0x3a,
    TABLE_UN_MESSAGES = 0x3b,
    TABLE_DOWNLOAD_DATA_MESSAGES = 0x3c,
    TABLE_STREAM_DESCRIPTORS = 0x3d,
    TABLE_PRIVATE_DATA = 0x3e
  };

  enum TPid {
    PID_PAT = 0x0000,
    PID_CAT = 0x0001,
    PID_TSDT = 0x0002,
    PID_NULL = 0x1fff,
    PID_INVALID = 0xffff
  };

  
  enum TDescriptorTag {
    TAG_VIDEO_STREAM = 0x02,
    TAG_AUDIO_STREAM = 0x03,
    TAG_HIERARCHY = 0x04,
    TAG_REGISTRATION = 0x05,
    TAG_DATA_STREAM_ALIGNMENT = 0x06,
    TAG_TARGET_BACKGROUND_GRID = 0x07,
    TAG_VIDEO_WINDOW = 0x08,
    TAG_CA = 0x09,
    TAG_ISO_639_LANGUAGE = 0x0a,
    TAG_SYSTEM_CLOCK = 0x0b,
    TAG_MULTIPLEX_BUFFER_UTILIZATION = 0x0c,
    TAG_COPYRIGHT = 0x0d,
    TAG_MAXIMUM_BITRATE = 0x0e,
    TAG_PRIVATE_DATA_INDICATOR = 0x0f,
    TAG_SMOOTHING_BUFFER = 0x10,
    TAG_STD = 0x11,
    TAG_IBP = 0x12,
    TAG_CAROUSEL_IDENTIFIER = 0x13,
    TAG_ASSOCIATION_TAG = 0x14,
    TAG_DEFERRED_ASSOCIATION_TAGS = 0x15,
    TAG_NPT_REFERENCE = 0x17,
    TAG_NPT_ENDPOINT = 0x18,
    TAG_STREAM_MODE = 0x19,
    TAG_STREAM_EVENT = 0x1a,
    TAG_MPEG4_VIDEO = 0x1b,
    TAG_MPEG4_AUDIO = 0x1c,
    TAG_IOD = 0x1d,
    TAG_SL = 0x1e,
    TAG_FMC = 0x1f,
    TAG_EXTERNAL_ES_ID = 0x20,
    TAG_MUXCODE = 0x21,
    TAG_FMX_BUFFER_SIZE = 0x22,
    TAG_MULTIPLEX_BUFFER = 0x23,
    TAG_AVC_VIDEO = 0x28
  };

  enum TSectionMaxSize {
    SECTION_MAX_SIZE_NORMAL = 1024,
    SECTION_MAX_SIZE_PRIVATE = 4096
  };
};

#endif
