/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *-----------------------------------------------------------------------------
 *
 * TDsmccDownloadDataBlockHandle.h
 * 
 * 13818-6 7.3.3 Table 7-7
 *
 * Copyright (c) 2007 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef TDSMCCDOWNLOADDATABLOCKHANDLE_H
#define TDSMCCDOWNLOADDATABLOCKHANDLE_H

#include "TDsmccMessageHeaderHandle.h"


struct TScmccDownloadDataBlock
{
  uint8_t  moduleId[2];
  uint8_t  moduleVersion;
  uint8_t  reserved;
  uint8_t  blockNumber[2];
};

class TDsmccDownloadDataBlockHandle : public TDsmccMessageHeaderHandle
{
private:
  const TScmccDownloadDataBlock* Ddb;

public:
  TDsmccDownloadDataBlockHandle(const uint8_t* buffer) throw ();
  uint16_t GetModuleId() const throw ();
  uint8_t  GetModuleVersion() const throw ();
  uint16_t  GetBlockNumber() const throw ();
  const uint8_t *GetData() const throw ();
  uint16_t GetDataLength() const throw ();
};

inline 
TDsmccDownloadDataBlockHandle::
TDsmccDownloadDataBlockHandle(const uint8_t* buffer) throw ()
  : TDsmccMessageHeaderHandle(buffer)
{
  Ddb =
    reinterpret_cast<const TScmccDownloadDataBlock*>(GetSectionDataBegin()
                                                     + GetMessageHeaderSize());
}

inline 
uint16_t TDsmccDownloadDataBlockHandle::GetModuleId() const throw ()
{
  return TMpeg2Util::Make16(Ddb->moduleId[0], Ddb->moduleId[1]);
}

inline 
uint8_t TDsmccDownloadDataBlockHandle::GetModuleVersion() const throw ()
{
  return Ddb->moduleVersion;
}

inline 
uint16_t TDsmccDownloadDataBlockHandle::GetBlockNumber() const throw ()
{
  return TMpeg2Util::Make16(Ddb->blockNumber[0], Ddb->blockNumber[1]);
}

inline const uint8_t *
TDsmccDownloadDataBlockHandle::GetData() const throw ()
{
  return &Ddb->blockNumber[0] + sizeof(Ddb->blockNumber);
}

inline uint16_t 
TDsmccDownloadDataBlockHandle::GetDataLength() const throw()
{
  return static_cast<uint16_t>(GetSectionDataLength() - 
     (GetData() - GetSectionDataBegin()));
}

#endif 
