/*
 *--------------------------------------------------------------------
 *
 * libH222/TMpeg2CopyrightDescriptorHandle.h
 *
 * ISO/IEC 138181-1 copyright descriptor.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef MEDIA_COMMON_TMPEG2COPYRIGHTDESCHANDLE_H
#define MEDIA_COMMON_TMPEG2COPYRIGHTDESCHANDLE_H


#include "media/libH222/TMpeg2DescriptorHandle.h"
#include "media/libH222/TMpeg2Util.h"
#include <string>




#define SIZEOF_TMPEG2COPYRIGHTDESCRIPTORBODY 4


class TMpeg2CopyrightDescriptorHandle : public TMpeg2DescriptorHandle
{
public:
  TMpeg2CopyrightDescriptorHandle() throw ();
  explicit TMpeg2CopyrightDescriptorHandle(const uint8_t* buffer) throw ();
  TMpeg2CopyrightDescriptorHandle(const TMpeg2DescriptorHandle &desc) throw ();

  uint32_t GetCopyrightId() const throw ();
  const uint8_t* GetAdditionalInfoBegin() const throw ();
  const uint8_t* GetAdditionalInfoEnd() const throw ();
};


inline TMpeg2CopyrightDescriptorHandle::TMpeg2CopyrightDescriptorHandle() throw ()
{
  
}

inline TMpeg2CopyrightDescriptorHandle::
TMpeg2CopyrightDescriptorHandle(const uint8_t* buffer) throw ()
  : TMpeg2DescriptorHandle(buffer)
{
  
}

inline TMpeg2CopyrightDescriptorHandle::
TMpeg2CopyrightDescriptorHandle(const TMpeg2DescriptorHandle &desc) throw ()
  : TMpeg2DescriptorHandle(desc)
{
  
}

inline uint32_t
TMpeg2CopyrightDescriptorHandle::GetCopyrightId() const throw ()
{
  const uint8_t* body = GetBodyData();
  return TMpeg2Util::Make32(body[0], body[1], body[2], body[3]);
}

inline
const uint8_t* TMpeg2CopyrightDescriptorHandle::GetAdditionalInfoBegin() const throw ()
{
  return GetBodyData() + SIZEOF_TMPEG2COPYRIGHTDESCRIPTORBODY;
}

inline
const uint8_t* TMpeg2CopyrightDescriptorHandle::GetAdditionalInfoEnd() const throw ()
{
  return GetDataPtr() + GetSize();
}

#endif
