/*
 *--------------------------------------------------------------------
 *
 * libH222/TMpeg2VideoStreamInfoDescriptor
 *
 * Video Stream Info Descriptor
 *
 * Copyright (c) 2010 Motorola Inc.
 *
 *--------------------------------------------------------------------
*/

#ifndef LIBH222_TMPEG2VIDEOSTREAMINFODESCRIPTORHANDLE_H
#define LIBH222_TMPEG2VIDEOSTREAMINFODESCRIPTORHANDLE_H

#include "media/libH222/TMpeg2DescriptorHandle.h"
#include "media/libH222/TMpeg2Util.h"
#include "media/libH222/Mpeg2Si.h"

#include <endian.h>

#ifndef NDEBUG
#include <iostream>
#endif

#ifndef __LITTLE_ENDIAN
#error Big endian target environment not supported!
#endif


class TMepg2VideoStreamInfoDescriptorHandle : public TMpeg2DescriptorHandle
{
public:
  TMepg2VideoStreamInfoDescriptorHandle(const TMpeg2DescriptorHandle& desc) throw ();
  
  
  bool GetStillPictureFlag() const throw();
};





inline TMepg2VideoStreamInfoDescriptorHandle::
TMepg2VideoStreamInfoDescriptorHandle(const TMpeg2DescriptorHandle& desc) throw ()
  : TMpeg2DescriptorHandle(desc)
{
  if (GetTag() != Mpeg2Si::TAG_VIDEO_STREAM
      || GetSize() < 3 ) {
    
    Header = NULL;
  }
}

inline bool TMepg2VideoStreamInfoDescriptorHandle::
GetStillPictureFlag() const throw()
{
  if (!IsValid()) {
    return false;
  }
  const uint8_t *p = GetDataPtr(); 
  const int stillPictureFlagBit = 0x01;
  return (p[2] & stillPictureFlagBit);
}

#endif
