/*
 *--------------------------------------------------------------------
 *
 * libH222/TTsDsmCcHandle.h
 *
 * 
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef LIBH222_TTSDSMCCHANDLE_H
#define LIBH222_TTSDSMCCHANDLE_H

#include "media/libH222/TTsSectionHandle.h"

#ifndef __LITTLE_ENDIAN
#error Big endian target environment not supported!
#endif








class TTsDsmCcHandle : public TTsSectionHandle
{
  friend class TTsDsmCcHandleTests;

protected:
  uint32_t CalculateChecksum() const throw ();

public:
  TTsDsmCcHandle(const uint8_t* buffer) throw ();

  bool CheckSanity() const throw ();
  bool CheckCrc() const throw ();  

  const uint8_t* GetData() const throw ();

#ifndef NDEBUG
  void PrintInfo(std::ostream& s) const throw ();
#endif
};





inline TTsDsmCcHandle::TTsDsmCcHandle(const uint8_t* buffer) throw ()
  : TTsSectionHandle(buffer)
{
  
}

inline const uint8_t* TTsDsmCcHandle::GetData() const throw ()
{
  return GetSectionDataBegin();
}

#endif
