/*
 *--------------------------------------------------------------------
 *
 * libH222/TTsPacket.h
 *
 * A MPEG2 transport stream packet buffer class. All details about the
 * internal structure is provided by the TTsPacketHandle base class.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef MEDIA_COMMON_TTSPACKET_H
#define MEDIA_COMMON_TTSPACKET_H

#include "media/libH222/TTsPacketHandle.h"

#include <iostream>


class TTsPacket : public TTsPacketHandle
{
public:
  uint8_t Data[TTsPacketHandle::PACKET_SIZE];

  TTsPacket();
  TTsPacket(const uint8_t* data);

  friend std::istream& operator >>(std::istream& s, TTsPacket& packet);
  friend std::ostream& operator <<(std::ostream& s, TTsPacket& packet);
};


inline TTsPacket::TTsPacket()
  : TTsPacketHandle(&Data[0])
{
  
}

#endif
