/*
 *---------------------------------------------------------------------------
 *
 * THaiUtil.h
 *
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef THAIUTIL_H
#define THAIUTIL_H

#define HAICALL(x) \
  THaiUtil::HaiCall((x), Debug, __FILE__, __LINE__)
#define HAICALL_IGNORE(x, y) \
  THaiUtil::HaiCallIgnore((x), (y), Debug, __FILE__, __LINE__)
#define HAICALLFATAL(x) \
  THaiUtil::HaiCallFatal((x), Debug, __FILE__, __LINE__)

#include "hal/IHaiSystem.h"

class IDebug;

class THaiUtil
{
private:
  static int32_t Target;

public:
  static THaiResult HaiCall(THaiResult result, IDebug* debug,
                            const char* file, int line) throw ();
  static THaiResult HaiCallIgnore(THaiResult result, THaiResult ignore,
                                  IDebug* debug,
                                  const char* file, int line) throw ();
  static void HaiCallFatal(THaiResult result, IDebug* debug,
                           const char* file, int line) throw ();
  static int32_t GetTarget() throw ();
  static const char* HaiResultString(THaiResult result) throw ();
};

#endif
