/*
 *--------------------------------------------------------------------
 *
 * TMetadataStorage.h
 *
 * A class for storing metadata while synchronizing.
 * 
 * Copyright (c) 2004 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TMETADATASTORAGE_H
#define TMETADATASTORAGE_H

#include "media/streamer/TMetadata.h"


class TMetadataStorage
{
private:
  // Internal structure to store saved metadata since we cannot use
  // TMetadata.
  class TMetadataStruct
  {
  public:
    std::string Key;
    std::string Value;
    TMetadataStruct* Next;
  };

  TMetadataStruct* First;
  TMetadataStruct* Last;

public:
  TMetadataStorage() throw ();
  ~TMetadataStorage() throw ();

  bool IsEmpty() const throw ();
  void PushBack(const TMetadata& metadata) throw ();
  void PopFront(TMetadata& metadata) throw ();
  void PopFront(std::string& Key, std::string& Value) throw ();
  void Clear() throw ();
};


inline TMetadataStorage::TMetadataStorage() throw ()
  : First(NULL),
    Last(NULL)
{
  // Empty.
}

inline TMetadataStorage::~TMetadataStorage() throw ()
{
  Clear();
}

inline bool TMetadataStorage::IsEmpty() const throw ()
{
  return First == NULL;
}

#endif
