/*
 *--------------------------------------------------------------------
 *
 * TMetaAudioDecoderInfo.h
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TMETAAUDIODECODERINFO_H
#define TMETAAUDIODECODERINFO_H

#include "hal/IHaiMpegAudioDecoder.h"

#include <string>

class TMetaAudioDecoderInfo
{
private:
  int SampleRate;
  int ChannelCount;
  IHaiMpegAudioDecoder_TAudioMode Mode;
public:
  TMetaAudioDecoderInfo();
  ~TMetaAudioDecoderInfo();

  void ParseXml(const std::string& xml);
  void GetXml(std::string& xml) const throw ();

  void SetSampleRate(int sampleRate) throw ();
  void SetChannelCount(int channelCount) throw();
  void SetMode(IHaiMpegAudioDecoder_TAudioMode mode) throw();

  int GetSampleRate() throw ();
  int GetChannelCount() throw ();
  IHaiMpegAudioDecoder_TAudioMode GetMode() throw ();
};

inline void TMetaAudioDecoderInfo::SetSampleRate(int sampleRate) throw ()
{
  SampleRate = sampleRate;
}

inline void TMetaAudioDecoderInfo::SetChannelCount(int channelCount) throw ()
{
  ChannelCount = channelCount;
}

inline void TMetaAudioDecoderInfo::
SetMode(IHaiMpegAudioDecoder_TAudioMode mode) throw ()
{
  Mode = mode;
}

inline int TMetaAudioDecoderInfo::GetSampleRate() throw ()
{
  return SampleRate;
}

inline int TMetaAudioDecoderInfo::GetChannelCount() throw ()
{
  return ChannelCount;
}

inline IHaiMpegAudioDecoder_TAudioMode TMetaAudioDecoderInfo::GetMode() throw ()
{
  return Mode;
}

#endif
