/*
 *--------------------------------------------------------------------
 *
 * TMetaDecoderVideoStreamInfo.h
 *
 * Helper class for handling decoder video stream info in the meta
 * data.
 * 
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TMETADECODERVIDEOSTREAMINFO_H
#define TMETADECODERVIDEOSTREAMINFO_H

#include "media/streamer/IStreamerTypes.h"
#include <string>

class TMetaDecoderVideoStreamInfo
{
private:
  IStreamerTypes::TDecoderVideoStreamInfo StreamInfo;
  
public:
  TMetaDecoderVideoStreamInfo();
  ~TMetaDecoderVideoStreamInfo();

  void ParseXml(const std::string& xml);
  void GetXml(std::string& xml) const throw ();
  
  void SetInfo(const IStreamerTypes::TDecoderVideoStreamInfo& streamInfo)
    throw ();

  void GetInfo(IStreamerTypes::TDecoderVideoStreamInfo& streamInfo) const
    throw ();
};


// ----------------------------------------------------------------------------
// Inlined functions

inline void
TMetaDecoderVideoStreamInfo::SetInfo(const IStreamerTypes::
                                     TDecoderVideoStreamInfo& streamInfo)
  throw ()
{
  StreamInfo = streamInfo;
}

inline void
TMetaDecoderVideoStreamInfo::GetInfo(IStreamerTypes::
                                     TDecoderVideoStreamInfo& streamInfo) const
  throw ()
{
  streamInfo = StreamInfo;
}

#endif
