/*
 *---------------------------------------------------------------------------
 *
 * TMetaFrontendInfo.h
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef TMETAFRONTENDINFO_H
#define TMETAFRONTENDINFO_H

#include "media/streamer/IStreamerTypes.h"
#include <string>

class TMetaFrontendInfo
{
private:
  IStreamerTypes::TFrontendInfo FrontendInfo;
  
public:
  TMetaFrontendInfo();
  ~TMetaFrontendInfo();

  void ParseXml(const std::string& xml);
  void GetXml(std::string& xml) const throw ();

  void SetInfo(IStreamerTypes::TFrontendInfo& info) throw ();
  void GetInfo(IStreamerTypes::TFrontendInfo& info) const throw ();

  bool operator==(const TMetaFrontendInfo& tunerInfo);
};


// ----------------------------------------------------------------------------
// Inlined functions

inline void
TMetaFrontendInfo::SetInfo(IStreamerTypes::TFrontendInfo& tunerInfo) throw ()
{
  FrontendInfo = tunerInfo;
}

inline void
TMetaFrontendInfo::GetInfo(IStreamerTypes::TFrontendInfo& tunerInfo)
  const throw ()
{
  tunerInfo = FrontendInfo;
}

inline bool
TMetaFrontendInfo::operator==(const TMetaFrontendInfo& FrontendInfo)
{
  std::string xml1;
  std::string xml2;
  GetXml(xml1);
  FrontendInfo.GetXml(xml2);
  return (xml1 == xml2);
}

#endif
