/*
 *--------------------------------------------------------------------
 *
 * TMetaTeletextStreamInfo.h
 *
 * Helper class for handling teletext stream info in the meta data.
 * 
 * Copyright (c) 2004 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TMETATELETEXTSTREAMINFO_H
#define TMETATELETEXTSTREAMINFO_H

#include "media/streamer/IStreamerTypes.h"
#include <string>

class TMetaTeletextStreamInfo
{
private:
  IStreamerTypes::TTeletextStreamInfo StreamInfo;
  
public:
  void ParseXml(const std::string& xml);
  void GetXml(std::string& xml) const throw ();
  
  void SetLanguage(const std::string& language) throw ();
  void SetPid(int32_t pid) throw ();

  void GetInfo(IStreamerTypes::TTeletextStreamInfo& streamInfo) const throw ();

  bool operator==(const TMetaTeletextStreamInfo& streamInfo);
};


// ----------------------------------------------------------------------------
// Inlined functions

inline void
TMetaTeletextStreamInfo::SetLanguage(const std::string& language) throw ()
{
  StreamInfo.Language = language;
}

inline void
TMetaTeletextStreamInfo::SetPid(int32_t pid) throw ()
{
  StreamInfo.Pid = pid;
}

inline void
TMetaTeletextStreamInfo::GetInfo(IStreamerTypes::
                                 TTeletextStreamInfo& streamInfo)
  const throw ()
{
  streamInfo = StreamInfo;
}

inline bool
TMetaTeletextStreamInfo::operator==(const TMetaTeletextStreamInfo& streamInfo)
{
  std::string xml1;
  std::string xml2;
  GetXml(xml1);
  streamInfo.GetXml(xml2);
  return (xml1 == xml2);
}

#endif
