/*
 *--------------------------------------------------------------------
 *
 * TParameterValidation.h
 *
 * Helper class for validating parameters.
 * 
 * Copyright (c) 2005 Kreatel Communications AB. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef TPARAMETERVALIDATION_H
#define TPARAMETERVALIDATION_H

#include "interface/TToiInvalidArgumentException.h"
#include "interface/TToiPermissionDeniedException.h"
#include "media/streamer/ParameterNames.h"
#include <string>

class TParameterValidation
{
private:
  TParameterValidation();
  ~TParameterValidation();

public:
  static void CheckParameterName(const std::string& name)
    throw (TToiInvalidArgumentException);
  static void CheckParameterWritePermission(const std::string& name)
    throw (TToiPermissionDeniedException);
};

#endif
