/*
 *--------------------------------------------------------------------
 *
 * FeatureNames.h
 *
 * Definitions of feature names used in the source elements.
 *
 * Copyright (c) 2009 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef FEATURENAMES_H
#define FEATURENAMES_H

/**
 * This is used to tell if the source input stream is live.
 */
#define FEATURE_INPUTCLOCKED "InputClocked"

/**
 * This is used to tell if the source input stream is jitter free.
 */
#define FEATURE_JITTERFREE "JitterFree"

/**
 * This is used to tell if the source can be paused.
 */
#define FEATURE_PAUSE "Pause"

/**
 * This is used to tell if the source allow picture freeze.
 */
#define FEATURE_FREEZE "Freeze"

/**
 * This is used to tell if the source can fast forward.
 */
#define FEATURE_FASTFORWARD "FastForward"

/**
 * This is used to tell if the source can rewind.
 */
#define FEATURE_REWIND "Rewind"

/**
 * This is used to tell if the source reports position.
 */
#define FEATURE_REPORTPOSITION "ReportPosition"

/**
 * This is used to tell if the source position can be set.
 */
#define FEATURE_SETPOSITION "SetPosition"

/**
 * This is used to tell if the pipeline not should be flushed on pause.
 */
#define FEATURE_NOFLUSHONPAUSE "NoFlushOnPause"

/**
 * This is used to tell if the the source allow timeshift.
 */
#define FEATURE_TIMESHIFT "Timeshift"

/**
 * This is used if the source is able to control the complete flow of the
 * stream input data. It is used by the DVR source.
 */
#define FEATURE_PIPELINEMASTER "PipelineMaster"

#endif
