/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *-----------------------------------------------------------------------------
 *
 * IAudioOverlay.h
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef IAUDIOOVERLAY_H
#define IAUDIOOVERLAY_H

#include <string>

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

  /** \class IAudioOverlay IAudioOverlay.h "media/streamer/IAudioOverlay.h"

      This interface is used by streamer elements to gain access to
      the audio overlay service.
  */

  class IAudioOverlay
  {
  public:
    virtual ~IAudioOverlay() throw () { /* Empty */ }

    /** Request playback of a given filename.
     */
    virtual void Play(const std::string& file) throw () = 0;

    /** Stops a requested playback.
     */
    virtual void Stop() throw () = 0;
  };

#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
