/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * ICa.h
 *
 * CA interface for streamer elements.
 *
 * Copyright (c) 2010 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef STREAMER_ICA_H
#define STREAMER_ICA_H

#include "IElement.h"
#include "hai/ICa.h"
#include "hal/HaiCaDivxTypes.h"
#include <string>

class ICa
{
public:
  virtual ~ICa() { /* Empty */ }

  virtual std::string GetResourceName() const throw () = 0;
  virtual std::string GetInstanceName() const throw () = 0;

  virtual void Release() throw () = 0;

  virtual THaiResult SetSystemKey(const uint8_t* key,
                                  const uint32_t keySize) throw () = 0;

  virtual THaiResult GetParameter(const uint32_t parameterId,
                                  uint8_t* data,
                                  uint16_t* dataSize,
                                  const uint16_t dataMaxSize) throw () = 0;

  virtual THaiResult SetParameter(const uint32_t parameterId, uint8_t* data,
                                  const uint16_t dataSize) throw () = 0;
};

#endif
