// Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
//
// This program is confidential and proprietary to Motorola Mobility, Inc and
// may not be copied, reproduced, disclosed to others, published or used, in
// whole or in part, without the expressed prior written permission of Motorola
// Mobility, Inc.

#ifndef STREAMER_IDVRASSET_H
#define STREAMER_IDVRASSET_H

#include "hai/IDvrAsset.h"

class IElement;

class IDvrAssetObserver
{
public:
  virtual ~IDvrAssetObserver() {}

  virtual void OnAssetPropertiesChanged(
    const THaiDvrAssetProperties& properties) = 0;
  virtual void OnLimitExceeded() = 0;
};

class IDvrAsset
{
protected:
  virtual ~IDvrAsset() {}

public:
  virtual void Close() = 0;
  virtual void SetObserver(IElement* element, IDvrAssetObserver* observer) = 0;
  // TODO: Remove SetUp* from the streamer interface when moving the setup from
  //       the dvr sink element to the mediamanager
  virtual THaiResult SetUpUnlimited() = 0;
  virtual THaiResult SetUpTimeLimited(uint32_t maxDuration) = 0;
  virtual THaiResult SetUpSizeLimited(uint64_t maxStreamFileSize,
                                      uint64_t maxIndexFileSize) = 0;
  virtual THaiResult GetProperties(THaiDvrAssetProperties& properties) = 0;
};

#endif
