/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *-----------------------------------------------------------------------------
 *
 * IFault.h
 *
 * This is an interface supplied by the streamer and may be used by
 * elements to report failures.
 *
 * Copyright (c) 2005 Motorola Inc. All Rights Reserved.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef PIPELINE_IFAULT_H
#define PIPELINE_IFAULT_H

#include "media/streamer/IStreamerTypes.h"

#include <string>

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

/** \class IFault IFault.h "media/streamer/IFault.h"

    This interface is implemented by the Streamer core and may be used
    by elements to report failures.
*/

class IFault
{
public:
  virtual ~IFault() {}

  /** This function reports a failure to the streamer core.

      \param reason     The reason for failure.
   */
  virtual void OnFailure(const std::string& reason) throw () = 0;

  virtual void OnError(const IStreamerTypes::TError& error) throw () = 0;
};

#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
