/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IInformation.h
 *
 * Information interface for streamer elements.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 * Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
 *
 * This program is confidential and proprietary to Motorola Mobility, Inc and
 * may not be copied, reproduced, disclosed to others, published or used, in
 * whole or in part, without the expressed prior written permission of Motorola
 * Mobility, Inc.
 *
 *---------------------------------------------------------------------------
 */

#ifndef STREAMER_IINFORMATION_H
#define STREAMER_IINFORMATION_H

#include "hai/IInformation.h"

class IInformation
{
public:
  virtual ~IInformation() { /* Empty */ }

  virtual std::string GetResourceName() const throw () = 0;
  virtual std::string GetInstanceName() const throw () = 0;

  virtual THaiResult GetBoolean(const char* key, const bool* &value) = 0;
  virtual THaiResult GetInteger(const char* key, const uint64_t* &value) = 0;
  virtual THaiResult GetString(const char* key, const char* &string) = 0;
  virtual THaiResult GetData(const char* key, const uint8_t* &buffer,
                             uint16_t* nr_of_bytes) = 0;
};

#endif
