/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IMediaSource.h
 *
 * MediaSource interface for streamer elements.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef STREAMER_IMEDIASOURCE_H
#define STREAMER_IMEDIASOURCE_H

#include "IElement.h"

#include "stdint.h"
#include <string>

#include "hai/IMediaSource.h"

class IMediaSourceObserver
{
public:
  virtual ~IMediaSourceObserver() { /* Empty */ }

  virtual void OnInfoChanged() throw () = 0;
};

class IMediaSource
{
public:
  virtual ~IMediaSource() { /* Empty */ }

  virtual std::string GetResourceName() const throw () = 0;
  virtual std::string GetInstanceName() const throw () = 0;

  virtual THaiResult Enable(bool enableFlag) throw () = 0;
  virtual THaiResult CreateOutput(uint32_t* outputId) throw () = 0;
  virtual THaiResult DestroyOutput(uint32_t outputId) throw () = 0;
  virtual THaiResult GetInfo(void* info, uint32_t size) throw () = 0;

  virtual void AddObserver(IElement* element,
                           IMediaSourceObserver* observer) throw () = 0;
  virtual void RemoveObserver(IElement* element,
                              IMediaSourceObserver* observer) throw () = 0;
  virtual void Release() throw () = 0;
};

#endif
