// Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.

#ifndef IMENU_H
#define IMENU_H

#include "media/streamer/IStreamerTypes.h"

/** Interface for menu operations, should be implemented by source elements
    that support menu operations.
 */
class IMenu
{
public:
  virtual ~IMenu() {}

  virtual void NavigateMenu(const IStreamerTypes::TMenuOperation& operation)
    throw () = 0;

  virtual void ShowMenu(const IStreamerTypes::TMenuType& menuType)
    throw () = 0;

  virtual void ResumeFromMenu()
    throw () = 0;
};

#endif
