/*
 *--------------------------------------------------------------------
 *
 * IPipelineEntry.h
 *
 * Interface to root elements that are not source elements.
 * 
 * Copyright (c) 2005 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef PIPELINE_IPIPELINEENTRY_H
#define PIPELINE_IPIPELINEENTRY_H

class TMetadata;

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif


/** \class IPipelineEntry IPipelineEntry.h "media/streamer/IPipelineEntry.h"

    This interface must be implemented by all root elements that are
    not source elements to allow metadata to flow between pipelines.
*/

class IPipelineEntry
{
public:
  virtual ~IPipelineEntry() {}

  /** This function is called by the Streamer core when the pipeline
      has received new metadata from the previous pipeline.

      \param metadata      A list of metadata to be processed.
     
   */
  virtual void ProcessMetadata(const TMetadata* metadata) throw () = 0;
};


#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
