/*
 *--------------------------------------------------------------------
 *
 * IPipelineLink.h
 *
 * This is the interface used by a leaf element to forward metadata to
 * another pipeline.
 * 
 * Copyright (c) 2005 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef PIPELINE_IPIPELINELINK_H
#define PIPELINE_IPIPELINELINK_H

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif


/** \class IPipelineLink IPipelineLink.h "media/streamer/IPipelineLink.h"

    This is the interface used by leaf elements to commit metadata to
    another pipeline.

    \see IPump
*/

class IPipelineLink
{
public:
  virtual ~IPipelineLink() {}

  /** This function is used to commit a metadata structure to the
      pipeline. Each incoming metadata structure attached to a
      segment must be committed, destroyed or published.

      \param metadata      The metadata structure to commit.
  */
  virtual void CommitMetadata(const TMetadata* metadata) throw () = 0;
};


#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
