/*
 *--------------------------------------------------------------------
 *
 * IPlaybackCommandObserver.h
 *
 * Playback events propagate to elements via this interface.
 *
 * Copyright (c) 2009 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef PIPELINE_IPLAYBACKCOMMANDOBSERVER_H
#define PIPELINE_IPLAYBACKCOMMANDOBSERVER_H

#include "media/streamer/IStreamerTypes.h"

#include <stdint.h>

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

/** \class IPlaybackCommandObserver IPlaybackCommandObserver.h "media/streamer/IPlaybackCommandObserver.h"

    This is a callback interface for source playback state change events.
*/

class IPlaybackCommandObserver
{
public:
  virtual ~IPlaybackCommandObserver() {}

  /** The streamer core uses this function to inform an element that
      the source has completed a Play command.
   */
  virtual void OnPlay(int32_t pace) throw () = 0;

  /** The streamer core uses this function to inform an element that
      the source has completed a PlayFromPosition command.
   */
  virtual void OnPlayFromPosition(uint32_t position, int32_t pace) throw () = 0;
};

#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
