// Copyright (c) 2011 Motorola Mobility, Inc. All rights reserved.
//
// This program is confidential and proprietary to Motorola Mobility, Inc and
// may not be copied, reproduced, disclosed to others, published or used, in
// whole or in part, without the expressed prior written permission of Motorola
// Mobility, Inc.

#ifndef IRECORDERSINK_H
#define IRECORDERSINK_H

#include "ISink.h"

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

/** \class IRecorderSink ISink.h "media/streamer/IRecorderSink.h"

    This interface is implemented by recorder sinks to control
    recording functionality.
*/

class IRecorderSink : virtual public ISink
{
public:
  virtual ~IRecorderSink() { /* Empty */ }

  virtual void StartRecording(const std::string& assetUri,
                              uint32_t offset) = 0;
  virtual void StopRecording(const std::string& assetUri) = 0;
};

#ifdef PIPELINE_NAMESPACE
}
#endif

#endif /* IRECORDERSINK_H */
