/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * ISocket.h
 *
 * Socket interface for streamer elements.
 *
 * Copyright (c) 2009 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef STREAMER_ISOCKET_H
#define STREAMER_ISOCKET_H

#include "IElement.h"

#include "hai/ISocket.h"

#include "stdint.h"
#include <string>

class ISocketObserver
{
public:
  virtual ~ISocketObserver() { /* Empty */ }

  virtual void OnEvent(THaiSocket_TEvent event, int32_t error) throw () = 0;
};


class ISocket
{
public:
  virtual ~ISocket() { /* Empty */ }

  virtual std::string GetResourceName() const throw () = 0;
  virtual std::string GetInstanceName() const throw () = 0;

  virtual THaiResult Bind(const char* addr, uint32_t port,
                          uint32_t flags) throw () = 0;
  virtual THaiResult Halt(bool flag) throw () = 0;
  virtual void AddObserver(IElement* element,
                           ISocketObserver* observer) throw () = 0;
  virtual void RemoveObserver(IElement* element,
                              ISocketObserver* observer) throw () = 0;
  virtual void Release() throw () = 0;
};

#endif
