/*
 *--------------------------------------------------------------------
 *
 * ISystemEventObserver.h
 *
 * Specific system events propagate to elements via this interface.
 * 
 * Copyright (c) 2006 Motorola Inc. All Rights Reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef PIPELINE_ISYSTEMEVENTOBSERVER_H
#define PIPELINE_ISYSTEMEVENTOBSERVER_H

#include "media/streamer/IStreamerTypes.h"

#include <stdint.h>

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

/** \class ISystemEventObserver ISystemEventObserver.h "media/streamer/ISystemEventObserver.h"

    This is a callback interface for various system events.
*/

class ISystemEventObserver
{
public:
  virtual ~ISystemEventObserver() {}

  /** The streamer core uses this function to inform an element that the ip
      address of the system has changed. Typically, only source elements
      need to react on this event.
   */
  virtual void OnIpAddressChanged() throw () = 0;
};
  
#ifdef PIPELINE_NAMESPACE
}
#endif

#endif
