/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * IVbi.h
 *
 * MediaDecoder interface for streamer elements.
 *
 * Copyright (c) 2010 Motorola, Inc. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef STREAMER_IVBI_H
#define STREAMER_IVBI_H

#include "IElement.h"

#include "hai/IVbi.h"

#include "stdint.h"
#include <string>

class IVbi
{
public:
  virtual ~IVbi() { /* Empty */ }

  virtual std::string GetResourceName() const throw () = 0;
  virtual std::string GetInstanceName() const throw () = 0;

  virtual THaiResult ConnectInput(const char* resourceName,
                                  const char* instanceName, int index)
    throw () = 0;
  virtual void Release() throw () = 0;
};

#endif

