/* -*- mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset:2 -*-
 *--------------------------------------------------------------------
 *
 * IVideoSink.h
 * 
 * 
 * Copyright (c) 2009 Motorola, Inc. All rights reserved.
 *
 *--------------------------------------------------------------------
 */

#ifndef IVIDEOSINK_H
#define IVIDEOSINK_H

#include "ISink.h"

#ifdef PIPELINE_NAMESPACE
namespace Pipeline {
#endif

/** \class IVideoSink ISink.h "media/streamer/IVideoSink.h"

    This interface is implemented by video sinks to control
    Picture-in-Picture functionality.
*/

class IVideoSink : virtual public ISink
{
public:
  virtual ~IVideoSink() { /* Empty */ }

  /**
   * This function is called to enable/disable Picture-in-Picture
   * mode for this sink. The sink must be in inactive state when calling this
   * method.
   */
  virtual void SetPipMode(bool flag) throw () = 0;
};

#ifdef PIPELINE_NAMESPACE
}
#endif

#endif /* IVIDEOSINK_H */
