







#ifndef UTILS_ALIGN_H
#define UTILS_ALIGN_H

template<typename T, typename U>
inline T AlignDown(T value, U align)
{
  return (value / static_cast<T>(align)) * static_cast<T>(align);
}

template<typename T, typename U>
inline T AlignUp(T value, U align)
{
  return AlignDown(value + static_cast<T>(align - 1), align);
}

template<typename T, typename U>
inline bool IsAligned(T value, U align)
{
  return AlignDown(value, align) == value;
}

template<typename T, typename U>
inline bool IsAligned(T* value, U align)
{
  return IsAligned(reinterpret_cast<unsigned long>(value), align);
}

#endif
