







#ifndef UTILS_IDISK_H
#define UTILS_IDISK_H

#include <string>

class IDisk
{
public:
  enum IDiskState {
    IDISK_STATE_UNKNOWN,
    IDISK_STATE_ACTIVE,
    IDISK_STATE_IDLE,
    IDISK_STATE_STANDBY
  };

  virtual ~IDisk() {}

  virtual void Open(int fd) throw () = 0;
  virtual bool Open(const std::string& devicename) throw () = 0;
  virtual void Close() throw () = 0;

  virtual bool GetModel(std::string& model) throw () = 0;
  virtual bool GetSerialNo(std::string& serialNo) throw () = 0;
  virtual bool GetTemperature(int &temperature) throw () = 0;
  virtual bool GetDiskState(IDiskState& state) throw () = 0;
  virtual bool SpinDown() throw () = 0;
  virtual bool SpinUp() throw () = 0;
  virtual bool SetIdleTimer(int timeout) throw () = 0;
  virtual bool Flush() throw () = 0;
};

#endif




