







#ifndef UTILS_KSTRING_H
#define UTILS_KSTRING_H

#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

namespace KString
{
  std::string Format(const char* format, ...)
    __attribute__ ((format (printf, 1, 2)));

  template<typename TD, typename TS> TD LexicalCast(const TS&);
  
  
  template<typename TD> TD LexicalCast(const char*);

  bool Compare(const char* str1, const char* str2);
  bool Compare(const std::string& str1, const char* str2);
  bool Compare(const char* str1, const std::string& str2);
  bool Compare(const std::string& str1, const std::string& str2);

  bool CompareNoCase(const char* str1, const char* str2);
  bool CompareNoCase(const std::string& str1, const char* str2);
  bool CompareNoCase(const char* str1, const std::string& str2);
  bool CompareNoCase(const std::string& str1, const std::string& str2);

  
  void Strip(std::string& str, const char garbage);
}

#endif
