










#ifndef UTILS_STRINGUTILS_H
#define UTILS_STRINGUTILS_H

#include <string>

namespace StringUtils
{
  /**
   * Case insensitive comparison of two strings.
   *
   * Since boost::algorithm::iequals() seems to enlarge binaries by
   * about 40k when used, we decided to implement a similar (except
   * for locale) function that is currently based on strcasecmp.
   */
  bool iequals(const std::string& str1, const std::string& str2);

  /**
   * Returns the extension (including the delimiter character) of the
   * input string.
   */
  std::string extension(const std::string& input, const char delim);

  /**
   * Replacement of first substring occurance (non-destructive).
   */
  std::string replaceFirst(const std::string& sourceString,
                           const std::string& subString,
                           const std::string& replacement);

  /**
   * Replacement of all substring occurances (non-destructive).
   */
  std::string replaceAll(const std::string& sourceString,
                         const std::string& subString,
                         const std::string& replacement);
}

#endif
