










#ifndef UTILS_TAVERAGEVALUE_H
#define UTILS_TAVERAGEVALUE_H

#include "debug/TTracker.h"

#include <stdint.h>

#include <vector>

class TAverageValue
{
protected:
  TTracker* Tracker;

  
  int SampleCount;
  
  std::vector<int32_t> Samples;

  
  uint8_t MinSampleCount;
  
  uint8_t MaxSampleCount;

  int32_t CurrentSum;

public:
  TAverageValue(int minSampleCount, int maxSampleCount) throw ();

  int32_t GetAverage() throw ();
  int32_t Push(int32_t sample) throw ();
  bool ValidValue() throw ();
  void Clear() throw ();
  void Print() throw ();
};

inline bool TAverageValue::ValidValue() throw ()
{
  return SampleCount >= MinSampleCount;
}

inline int32_t TAverageValue::GetAverage() throw ()
{
  int32_t average = 0;
  if (SampleCount >= MinSampleCount) {
    average = CurrentSum / SampleCount;
  }
  return average;
}

#endif
