










#ifndef UTILS_TBASE64_H
#define UTILS_TBASE64_H

#include <stdint.h>

#include <string>
#include <vector>

class TBase64
{
private:
  static const char Base64Table[];

  static uint8_t GetData(const char ch);
  static uint32_t CalculateBlocks(const std::string& in);

public:
  static uint32_t CalculateDecodeBufferSize(const std::string& in);
  static std::string Encode(const uint8_t* in, uint32_t size);
  static std::string Encode(const std::vector<uint8_t>& in);
  static uint32_t Decode(const std::string& in, uint8_t* out);
  static void Decode(const std::string& in, std::vector<uint8_t>& out);
};

inline uint32_t TBase64::CalculateDecodeBufferSize(const std::string& in) 
{
  return CalculateBlocks(in) *3 ;
}

inline uint32_t TBase64::CalculateBlocks(const std::string& in)
{
  return (in.length() + 3) / 4;
}

#endif
