









#ifndef UTILS_TBASHARGS_H
#define UTILS_TBASHARGS_H

#include <stdint.h>

#include <string>
#include <vector>

class TBashArgs
{
public:
  enum TParserState
  {
    NormalState,
    SingleQuotedState,
    DoubleQuotedState
  };

protected:
  class TToken
  {
  private:
    TParserState State;
    std::string Text;

  public:
    TToken();

    std::string GetString() const;

    friend std::istream& operator >>(std::istream& s,
                                     TBashArgs::TToken& token) throw ();
  };

  friend std::istream& operator >>(std::istream& s,
                                   TBashArgs::TToken& token) throw ();

  const char* Text;

public:
  TBashArgs(const char* text);

  bool Parse(std::vector<std::string>& result) const;

  
  static uint32_t GetStorageRequirement(const std::vector<std::string>& args);
  static void TransformArgVector(const std::vector<std::string>& args,
                                 char** argv, char* storage);
};

inline TBashArgs::TBashArgs(const char* text) :
  Text(text)
{
  
}

#endif
