











#ifndef UTILS_TCHARARRAYARRAY_H
#define UTILS_TCHARARRAYARRAY_H

#include <stdint.h>
#include <string>

class TCharArrayArray
{
private:
  uint32_t Size;
  char** Vector;
  char* Storage;

  char* StoreString(char* dest, const std::string& s);

public:
  template <class TInputIter>
  TCharArrayArray(TInputIter first, TInputIter last);
  ~TCharArrayArray();

  uint32_t GetSize() const;
  char** GetData();
  const char* const* GetData() const;

  char* operator [](int index);
  const char* operator [](int index) const;
};


template <class TInputIter>
TCharArrayArray::TCharArrayArray(TInputIter first, TInputIter last)
{
  uint32_t vectorSize = 1;  
  uint32_t storageSize = 0;
  TInputIter i;
  for (i = first; i != last; ++i) {
    vectorSize += 1;
    storageSize += (*i).length() + 1;  
  }
  Size = vectorSize - 1;
  Vector = new char*[vectorSize];
  Storage = new char[storageSize];

  uint32_t index = 0;
  char* pos = Storage;
  for (i = first; i != last; ++i) {
    Vector[index] = pos;
    ++index;
    pos = StoreString(pos, *i);
  }
  Vector[index] = NULL;
}

inline TCharArrayArray::~TCharArrayArray()
{
  delete[] Vector;
  delete[] Storage;
}

inline uint32_t TCharArrayArray::GetSize() const
{
  return Size;
}

inline char** TCharArrayArray::GetData()
{
  return Vector;
}

inline const char* const* TCharArrayArray::GetData() const
{
  return Vector;
}

inline char* TCharArrayArray::operator [](int index)
{
  return Vector[index];
}

inline const char* TCharArrayArray::operator [](int index) const
{
  return Vector[index];
}

#endif
