






#ifndef UTILS_TLICENSE_H
#define UTILS_TLICENSE_H

#include "base/NonCopyable.h"

#include <string>

namespace SuiteTestLicense
{
class TFixture;
class TFixtureDecodeAacHelper;
class TFixtureDecodeAc3Helper;
class TFixtureDecodeAacInvalidHelper;
class TFixtureDecodeAc3InvalidHelper;
class TFixtureInvalidConfigHelper;
} 

class TLicense
{
  NON_COPYABLE(TLicense);

private:
  friend class SuiteTestLicense::TFixture;
  friend class SuiteTestLicense::TFixtureDecodeAacHelper;
  friend class SuiteTestLicense::TFixtureDecodeAc3Helper;
  friend class SuiteTestLicense::TFixtureDecodeAacInvalidHelper;
  friend class SuiteTestLicense::TFixtureDecodeAc3InvalidHelper;
  friend class SuiteTestLicense::TFixtureInvalidConfigHelper;

  static const std::string KREATV_CONF;

  bool IsValid(const std::string& name, const std::string& key,
               const std::string& configFile = KREATV_CONF) const;
public:
  enum TLicenseType {
    LICENSE_TYPE_AUDIO_DECODE_AAC,
    LICENSE_TYPE_AUDIO_DECODE_AC3,
    LICENSE_TYPE_AUDIO_DECODE_EAC3,

    LICENSE_TYPE_VIDEO_DECODE_MPEG2,
    LICENSE_TYPE_VIDEO_DECODE_H264,
    LICENSE_TYPE_VIDEO_DECODE_WMV3,

    LICENSE_TYPE_CA_MACROVISION,
    LICENSE_TYPE_CA_CGMSA
  };

  TLicense() { /* Empty */ }
  bool IsValid(TLicenseType licenseType) const;
};

#endif
