







#ifndef UTILS_TSATADISK_H
#define UTILS_TSATADISK_H

#include "IDisk.h"
#include "debug/TTracker.h"

class TSataDisk : public IDisk
{
private:
  TTracker* Tracker;
  int DiskFd;
  
public:
  TSataDisk();
  TSataDisk(int fd);
  TSataDisk(std::string& devicename);
  virtual ~TSataDisk();

  
  void Open(int fd) throw ();
  bool Open(const std::string& devicename) throw ();
  void Close() throw ();
  bool GetModel(std::string& model) throw ();
  bool GetSerialNo(std::string& serialNo) throw ();
  bool GetTemperature(int &temperature) throw ();
  bool GetDiskState(IDiskState& state) throw ();
  bool SpinDown() throw ();
  bool SpinUp() throw ();
  bool SetIdleTimer(int timeout) throw ();
  bool Flush() throw ();
};

#endif
