







#ifndef UTILS_TSIMPLEFILE_H
#define UTILS_TSIMPLEFILE_H

#include <string>
#include <stdint.h>

#include "debug/TTracker.h"

class TSimpleFile
{
private:
  TTracker* Tracker;
  int Fd;
  bool SuccessFlag;
  bool Sync;
  std::string Name;

protected:
  void Initialize(const std::string& name, int flags, bool sync) throw();
  TSimpleFile() throw () { }

public:
  TSimpleFile(const std::string& name, bool sync = false) throw();
  ~TSimpleFile();
  uint64_t GetSize() throw ();
  bool Seek(uint64_t offset) throw (); 
  uint64_t Tell() throw ();
  bool Truncate(uint64_t size) throw ();
  bool Lock(int operation) throw ();
  void Read(void* data, ssize_t size) throw ();
  void Write(const void* data, ssize_t size) throw ();
  bool IsSuccess() const throw () { return SuccessFlag; }
};

class TReadOnlyFile : public TSimpleFile
{
public:
  TReadOnlyFile(const std::string& name) throw();
};

class TWriteOnlyFile : public TSimpleFile
{
public:
  TWriteOnlyFile(const std::string& name, bool sync = false) throw ();
};

#endif
