







#ifndef UTILS_TURL_H
#define UTILS_TURL_H

#include <string>
#include <stdint.h>
#include <map>

class TUrl
{
private:
  std::string Url;
  std::string::size_type AddressStart;
  std::string::size_type PortStart;
  std::string::size_type ObjectStart;
  std::string::size_type ParameterStart;
  
public:
  typedef std::map<std::string, std::string> TQueryParameters;

  TUrl() throw ();
  TUrl(const std::string& url) throw ();
  
  void SetUrl(const std::string& url) throw ();
  const std::string& GetUrl() const throw ();
  std::string GetProtocol() const throw ();
  std::string GetAddress() const throw ();
  std::string GetPort() const throw ();
  std::string GetObject() const throw ();
  std::string GetParameters() const throw ();
  TQueryParameters GetQueryParameters() const throw ();
  void SetQueryParameters(const TQueryParameters& parameters) throw ();
};

#endif
