/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * diskusage.h
 *
 * Functions for computing how much disk space is used by a file or
 * directory on the disk. Useful when needing to know how much space a
 * PVR asset takes up on disk.
 *
 * Copyright (c) 2006 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef UTILS_DISKUSAGE_H
#define UTILS_DISKUSAGE_H

#include "base/TException.h"
#include <sys/types.h>


off_t GetFileSizeOnDisk(const char* path) throw(TException);



int64_t GetDiskSpaceUsage(const char* path) throw(TException);

#endif
