/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TEncodedStrings.h
 *
 * Copyright (c) 2003 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef XML_TENCODEDSTRINGS_H
#define XML_TENCODEDSTRINGS_H

#include <string>

class TUtf8String
{
private:
  std::string Utf8;

public:
  TUtf8String(const std::string& utf8);

  void AssignLatin1(const std::string& latin1);

  std::string GetUtf8() const;
  std::string GetLatin1() const;
};

class TLatin1String
{
private:
  std::string Latin1;

public:
  TLatin1String(const std::string& latin1);

  std::string GetLatin1() const;
  std::string GetUtf8() const;
};

inline TUtf8String::TUtf8String(const std::string& utf8) :
  Utf8(utf8)
{
  
}

inline std::string TUtf8String::GetUtf8() const
{
  return Utf8;
}

inline TLatin1String::TLatin1String(const std::string& latin1) :
  Latin1(latin1)
{
  
}

inline std::string TLatin1String::GetLatin1() const
{
  return Latin1;
}

#endif 
