/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TGeneralXmlParser.h
 *
 *   - A general parser for XML files.
 *
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef XML_TGENERALXMLPARSER_H
#define XML_TGENERALXMLPARSER_H

#include "base/TException.h"
#include "xml/TXmlElement.h"
#include "xml/TXmlParser.h"

#include <stack>

/**
 * Usage of this class
 *
 * This class builds a tree of TXmlElement objects from a general XML file.
 *
 * See the documentation for TXmlElement for more information.
 */
class TGeneralXmlParser : public TXmlParser
{
protected:
  std::stack<TXmlElement> Stack;

  void Clear();

public:
  virtual ~TGeneralXmlParser() throw ();

  void Parse(const std::string& doc) throw (TException);
  void Parse(const char* doc) throw (TException);
  void Parse(const char* doc, int length) throw (TException);
  const TXmlElement& GetRootElement() const;

  
  virtual void StartElementHandler(const XML_Char* name,
                                   const XML_Char** atts) throw ();
  virtual void EndElementHandler(const XML_Char* name) throw ();
  virtual void TextHandler(const XML_Char* s, int len) throw ();
};

#endif 
