/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *---------------------------------------------------------------------------
 *
 * TXmlFormat.h
 *
 * This class is used to quote XML encoded strings.
 * 
 * Copyright (c) 2002 Kreatel Communications AB. All Rights Reserved.
 *
 *---------------------------------------------------------------------------
 */

#ifndef XML_TXMLFORMAT_H
#define XML_TXMLFORMAT_H

#include <iosfwd>
#include <string>

class TXmlFormat
{
private:
  std::string String;

  void Init(const char* str, size_t length);

public:
  explicit TXmlFormat(const char* str);
  explicit TXmlFormat(const std::string& str);

  const std::string& GetString() const;

  operator const char*() const;

  friend std::ostream& operator <<(std::ostream& s, const TXmlFormat& f);
};

inline const std::string& TXmlFormat::GetString() const
{
  return String;
}

inline TXmlFormat::operator const char*() const
{
  return String.c_str();
}

#endif
